/*
 *  notice: japanese
 *@쌠҂̍mF
 *@@uf[^TCgJvOgp@QŁv
 *@@ɋLڂ́uvOvƓɎ舵ĒƂɁA
 *@@{hLg̉{EpEۊǂF߂܂B
 */

/*
 * ps_drct.c
 *
 * Directive functions.
 * Version 1.10 Beta   Date 1999.5.8
 * Copyright (c) Datasight Corp., 1996-1999.
 * All Rights Reserved.
 * Made by A.Nakashima
 *
 */


#define PS_DRCT_C
#include "ps_selec.h"
#include "ps_misc.h"
#include "ps_lex.h"




/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


typedef struct {
	int id;
	symbol* sym;
	fileloc loc;
	long position;
	} sym_loc;


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


extern word_dict* number_opr_dict;
extern int control_num_spec;


/* ̌ɑg[N񂪒萔ł邩ǂ肷邽߁Aǂ݂B */

static int num_expr_look_ahead(lex* lexp,bag_arr* bagp) {
	sym_loc* wp;
	int c;
	int tc;
	int rtc = 0;	/* ꉞA萔ł͖ƂĂ */
	forever {
		/* ̕^ȂI */
		c = skip_space_char(lexp);
		uninp(lexp,c);
		if (lexp->lead_delim) uninp(lexp,' ');
		if (c == META_direct) goto ret;
		/* P̃g[N𓾂 */
		tc = sfl_word(lexp);
		wp = new_alloc(bagp->acp,sizeof(*wp));
		wp->id  = tc;
		wp->sym = lexp->toksym;
		wp->loc = lexp->tokloc;
		wp->position = lexp->lead_delim;
		/* ŕԋpo悤ɋL^Ă */
		append_bag_que(bagp,wp);
		switch(tc) {
		case '(':
			/* '('Ŏn܂鎮́A')'ŏI邱Ƃ */
			if (num_expr_look_ahead(lexp,bagp) != ')' ) return 0;
			/* '(',')'̒́Alł */
			rtc = LEX_NUM;
			break;
		case ')':
			/* ܂łɁAlɏoĂ΁A')'ԂB*/
			if (rtc == LEX_NUM) return ')';
			/* ܂łɁAlĂȂ̂ŁAmfƂȂB */
			goto ret;		/* == 0 (NG) */
		case LEX_EOF:
		case LEX_opr:
		case LEX_NL:
			goto ret;
		case LEX_NUM:
			/* lɏoƂLB*/
			rtc = LEX_NUM;
			break;
		case LEX_SYM:
			/* V{ɏoĂ܂̂ŁA萔ł͂ȂB*/
			rtc = 0;
			goto ret;
			/* default: ̑ɁAIy[^ɏo\邪A
			   Z\Ɖ肵Ał̐ǂ݂ł͒ʉ߂B
			*/
			}
		}
ret:
	return rtc;
	}


ENTRY answer is_number_opr(lex* lexp,int end) {
	word_dict* save_tblp;
	jmp_buf* save_jbp = *(lexp->jmpbfpp);
	jmp_buf jbuf;
	alloc_ctl* acp;
	bag_arr* bagp;
	answer rtc;
	int num,i;
	save_tblp = lexp->opr_tblp;
	*(lexp->jmpbfpp) = &jbuf;
	acp = new_mactl();
	bagp = new_bag(acp);
	rtc = setjmp(jbuf);
	if (rtc == 0) {
		/* ւ */
		lexp->opr_tblp = number_opr_dict;
		num = num_expr_look_ahead(lexp,bagp);
		}
	/* ǂ݂PԋpB */
	for (i = bagp->ix -1 ; i >= 0 ; --i) {
		sym_loc* wp = (sym_loc*)(bagp->ap[i]);
		unget_word(lexp,wp->id,wp->sym->name, &(wp->loc));
		if (wp->position) unget_word(lexp,LEX_SPC," ",&(wp->loc));
		}
	del_mactl(acp);
	lexp->opr_tblp = save_tblp;
	*(lexp->jmpbfpp) = save_jbp;
	if(rtc != 0) {
		/* ُI */
		longjmp(**(lexp->jmpbfpp),rtc);
		}
	rtc = FAIL;	/* ng */
	switch(end) {
	case ')':
		if (num == ')') rtc = GOOD;
		break;
	case ';':
		if (num == ')') rtc = GOOD;
	default:
		if (num == LEX_NUM) rtc = GOOD;
		break;
		}
	return rtc;
	}


static void set_str_on_buf(alloc_ctl* acp,char** spp,int* lenp,int* cntp,char* name) {
	char* buf;
	int len = strlen(name);
	int siz = *cntp + len + 2;
	if (siz >= *lenp) {
		siz += 100;
		buf = (char*)new_segmem(acp,siz);
		if (*cntp != 0) {
			memcpy(buf,*spp,*cntp);
			del_segmem(acp,*spp);
			}
		*spp = buf;
		*lenp = siz;
		}
	buf = *spp;
	*cntp += sprintf(&buf[*cntp],"%s",name);
	}


ENTRY int get_eval_arg(lex* lexp,alloc_ctl* acp,int eval_spec,int r_angle,char** spp) {
	int save_nl = lexp->skip_nl;
	int save_eof = lexp->eof_ng;
	long value;
	char* name;
	int len;
	int cnt;
	int tc;
	int i;
	lexp->skip_nl = 0;
	lexp->eof_ng = 0;
	len = cnt = 0;
	for(i = 0 ; ; ++i) {
		if (is_number_opr(lexp,';') == GOOD) {
			char buf[32];
			tc = LEX_NUM;
			/* POíAvZĂP̃g[Nɕϊ */
			value = get_number(lexp,eval_spec);
			sprintf(buf,"%ld",value);
			name = buf;
			}
		else {
			tc = sfl_word(lexp);
			name = lexp->toksym->name;
			}
		if (tc == r_angle) goto ret;
		switch(tc) {
		case ',' :
		case ';' :
			goto ret;
			}
		/* ǂݍ񂾃g[NԂɋL */
		if (i > 0) {
			if (lexp->lead_delim) {
				set_str_on_buf(acp,spp,&len,&cnt," ");
				}
			}
		set_str_on_buf(acp,spp,&len,&cnt,name);
		}
ret:
	if (i == 0) {
		*spp = name;
		}
	else {
		/* ǂ݂Ō̒PԋpB */
		unget_word(lexp,tc,name,&(lexp->tokloc));
		if (lexp->lead_delim) unget_word(lexp,LEX_SPC," ",&(lexp->tokloc));
		tc = LEX_STR;
		}
	lexp->eof_ng = save_eof;
	lexp->skip_nl = save_nl;
	return tc;
	}


/* ========================================================================= */
/* =====    }N                                                 ===== */
/* ========================================================================= */



/* '( @{ ,  } ') */

ENTRY int macro_argument(lex* lexp, uni_link** lpp, int left, int right) {
	int tc;
	int i;
	int save_mac_flg;
	footmark("macro_argument");
	save_mac_flg = lexp->macro_ctl;
	lexp->macro_ctl = MAC_NG;
	tc = input(lexp);
	if (tc != left) {
		uninp(lexp,tc);
		i = 0;			/* A[MgȂ */
		goto ret;
		}
	tc = sfl_word(lexp);	/* PA[Mg擾 */
	if (*lpp != 0) {
		sprintf(lexp->errbuf,"argument is already defined");
		lex_error(lexp,ERR_user);
		}
	if (tc == right) goto ret;
	for (i = 0 ; ; lpp = &((*lpp)->np)) {
		if(tc != LEX_SYM) {
			sprintf(lexp->errbuf,"symbol expected 1 (%s)",lexp->tokbuf);
			lex_error(lexp,ERR_user);
			}
		*lpp = new_uni_link(lexp->acp,lexp->toksym,0);
		++i;
		tc = sfl_word(lexp);
		if (tc == right)  goto ret;
		if (tc != ',') { 
			sprintf(lexp->errbuf,"',' or '%c' expected (%s)",right,lexp->tokbuf);
			lex_error(lexp,ERR_user);
			}
		tc = sfl_word(lexp);	/* QA[Mg擾 */
		}
ret:
	lexp->macro_ctl = save_mac_flg;
	return i;	/* (i > 0)A[Mg */
	}




/* '( @{ ,  } ') */

ENTRY int macro_real_arg(lex* lexp, uni_link** lpp, int left, int right, alloc_ctl* acp) {
	int tc;
	int i,j;
	int ix = lexp->tbufix;
	symbol* sym;

	int save_mac_ctl = lexp->macro_ctl;
	lexp->macro_ctl = MAC_NG;

	footmark("macro_real_arg");
	tc = skip_space_char(lexp);
	if (tc != left) {
		uninp(lexp,tc);
		i = 0;	/* A[MgȂ */
		goto ret;
		}
	for (i = 0 ; ; lpp = &((*lpp)->np)) {
		lexp->tbufix = ix;
		/* 擪̋󔒕̓XLbv */
		do {
			tc = input(lexp);
			} while (tc == ' ' || tc == '\t');
		/* P̃p[^擾 */
		for (;;) {
			if (tc == right || tc == ',' ||
				tc == EOF   || tc == 0   ) break;
			set_wbuf(lexp,tc);
			tc = input(lexp);
			}
		/* [̋󔒕̓XLbv */
		for (j = lexp->tbufix - 1 ; j >= ix ; --j) {
			int c = lexp->tokbuf[j];
			if (c == ' ' || c == '\t') {
				lexp->tbufix--;
				continue;
				}
			break;
			}
		end_wbuf(lexp);
		sym = symbol_lookup(lexp,&(lexp->tokbuf[ix]));
		*lpp = new_uni_link(acp,sym,0);
		++i;
		if (tc == right) break;
		}
ret:
	lexp->tbufix = ix;
	lexp->macro_ctl = save_mac_ctl;
	return i;	/* A[Mg */
	}


static symbol* def_mac_eval(lex* lexp,int end) {
	int save_meta_off  = lexp->meta_off ;
	int save_eof_ng    = lexp->eof_ng   ;
	int save_in_drct   = lexp->in_drct  ;
	int save_macro_ctl = lexp->macro_ctl;
	int save_save_dol  = lexp->save_dol ;
	int save_skip_spc  = lexp->skip_spc ;
	int save_skip_nl   = lexp->skip_nl  ;
	int save_in_record = lexp->in_record;

	char* buf;
	int tok;
	int c;
	symbol* sym;

	/* }N` */
	lexp->meta_off   = 1;
	lexp->eof_ng     = 0;
	lexp->in_drct    = 0;
	lexp->macro_ctl  = MAC_NG;
	lexp->save_dol   = 0;
	lexp->skip_spc   = 1;
	lexp->skip_nl    = 0;
	lexp->in_record  = 1;

	/* }N̕擾 */
	lexp->tbufix = 0;
	c = skip_space_char(lexp);
	set_wbuf(lexp,c);
	if (symbol_str(lexp, c, &tok) == 0) {
		sprintf(lexp->errbuf,"name expected");
		lex_error(lexp,ERR_user);
		}
	/* }NV{ɂ */
	sym = symbol_lookup(lexp,lexp->tokbuf);
	lexp->tbufix = 0;
	c = skip_space_char(lexp);
	if (c == '\n') {
		end_wbuf(lexp);
		goto ret;
		}
	if (c != '=') {
		lexp->tbufix = sprintf(lexp->tokbuf,"%c",c);
		sprintf(lexp->errbuf,"'=' expected");
		lex_error(lexp,ERR_user);
		}
	/* ́A}NWJ */
	lexp->macro_ctl = MAC_SYM;
	lexp->eof_ng = 0;
	/* }Nϊ镶擾B*/
	get_eval_arg(lexp,lexp->sfp->acp,control_num_spec,end,&buf);
	lexp->tbufix = sprintf(lexp->tokbuf,"%s",buf);

ret:
	lexp->meta_off  = save_meta_off ;
	lexp->eof_ng    = save_eof_ng   ;
	lexp->in_drct   = save_in_drct  ;
	lexp->macro_ctl = save_macro_ctl;
	lexp->save_dol  = save_save_dol ;
	lexp->skip_spc  = save_skip_spc ;
	lexp->skip_nl   = save_skip_nl  ;
	lexp->in_record = save_in_record;

	return sym;
	}


static symbol* def_mac_string(lex* lexp,uni_link** lpp) {
	int save_meta_off  = lexp->meta_off ;
	int save_eof_ng    = lexp->eof_ng   ;
	int save_in_drct   = lexp->in_drct  ;
	int save_macro_ctl = lexp->macro_ctl;
	int save_save_dol  = lexp->save_dol ;
	int save_skip_spc  = lexp->skip_spc ;
	int save_skip_nl   = lexp->skip_nl  ;
	int save_in_record = lexp->in_record;
	int w_quote;
	int tok;
	int c,c2;
	int j;
	symbol* sym;

	/* }N̕擾Bi}NWJȂ Bj*/
	lexp->meta_off   = 1;
	lexp->eof_ng     = 0;
	lexp->in_drct    = 0;
	lexp->macro_ctl  = MAC_NG;
	lexp->save_dol   = 1;
	lexp->skip_spc   = 0;
	lexp->skip_nl    = 0;
	lexp->in_record  = 1;

	*lpp = 0;
	lexp->tbufix = 0;
	c = skip_space_char(lexp);
	set_wbuf(lexp,c);
	if (symbol_str(lexp, c, &tok) == 0) {
		sprintf(lexp->errbuf,"name expected");
		lex_error(lexp,ERR_user);
		}
	/* }NV{ɂ */
	sym = symbol_lookup(lexp,lexp->tokbuf);
	/* }N`ɃA[Mg΁A擾 */
	macro_argument(lexp, lpp,'(', ')');

	/* }Nϊ镶擾Bi}NWJȂ Bj*/
	w_quote = 0;
	lexp->tbufix = 0;
	c = skip_space_char(lexp);	/* 擪̋󔒕̓XLbv */
	for(;;) {
		switch(c) {
		case '\\':
			c2 = input(lexp);
			if (w_quote) {
				set_wbuf(lexp,c);
				c = c2;
				break;
				}
			switch(c2) {
			case '\n':
				c = ' ';    /* c = c2; UNIX݊̂ߋ󔒂ɕύX */
				break;
			case ';':
				c = '\n';
				break;
			default:
				uninp(lexp,c2);
				}
			break;
		case '"':
			w_quote ^= 1;
			break;
		case '\n':
		case EOF :
			uninp(lexp,c);
			goto end;
			}
		set_wbuf(lexp,c);
		c = input(lexp);
		}
end:
	end_wbuf(lexp);
	lexp->tbufix = cut_tail_space(lexp->tokbuf);	/* [̋󔒕̓XLbv */
	lexp->meta_off  = save_meta_off ;
	lexp->eof_ng    = save_eof_ng   ;
	lexp->in_drct   = save_in_drct  ;
	lexp->macro_ctl = save_macro_ctl;
	lexp->save_dol  = save_save_dol ;
	lexp->skip_spc  = save_skip_spc ;
	lexp->skip_nl   = save_skip_nl  ;
	lexp->in_record = save_in_record;

	return sym;
	}


ENTRY source* seek_drct_value(lex* lexp,symbol* sym,drct_blk** blkpp,macro** macp) {
	source* sfp;
	drct_blk* blkp;
	macro* mac;
	for (sfp = lexp->sfp ; sfp != 0 ; sfp = sfp->rfp) {
		for (blkp = sfp->drctblkp ; blkp != 0 ; blkp = blkp->parent) {
			if (blkp->machash == 0) continue;
			mac = macro_lookup(sfp->acp,&(blkp->machash),sym,0);
			if (mac != 0) {
				*blkpp = blkp;
				*macp = mac;
				return sfp;
				}
			}
		}
	return 0;
	}




/* ========================================================================= */
/* =====    symbol to file location                                    ===== */
/* ========================================================================= */


static unsigned int sym2loc_hcode(void* q) {
	return ((sym_val*)q)->sym->code;
	}


static sym_loc* sym2loc_lookup(hashtbl* hp,symbol* sym,long position,fileloc* locp) {
	unsigned int i,ix;
	if (sym == 0) return 0;
	SYMBOL_PA(++(hp->lup_cnt));
retry:
	ix = sym->code;
	for (i = 0 ; i < hp->tblsiz ; ++i,++ix) {	/* 1'st time : hp->tblsiz == 0 */
		sym_loc* p;
		SYMBOL_PA(++(hp->try_cnt));
		ix %= hp->tblsiz;
		p = hp->tblpp[ix];
		if (p == 0) {
			if (locp == 0) return 0;
			++(hp->tblent);
			p = new_alloc(hp->acp,sizeof(sym_loc));
			p->sym = sym;
			p->position = position;
			p->loc = *locp;
			hp->tblpp[ix] = p;
			return p;
			}
		if (p->sym == sym) {
			return p;
			}
		if (i > 10 && hp->tblent > hp->tblsiz/2) break;
		}
	if (locp == 0) return  0;
	expand_hash_tbl(hp,10,sym2loc_hcode);
	goto retry;
	}


/* ========================================================================= */
/* =====   fBNeBu̐E                              ===== */
/* ========================================================================= */


extern max_blk_repeat;

static int dsp_blk_no = 0;


#undef def_blk
#define def_blk(key) case BLK_##key: return #key;
ENTRY char* block_name(drct_blk* blkp) {
	switch(blkp->within) {
	blk_key
		}
	return "unknown block";
	}


static source* blk_source(lex* lexp) {
	return lexp->sfp;
	}


static void rewind_source(source* sfp) {
	lex* lexp = sfp->lexp;
	source* ffp;
	for (ffp = lexp->sfp ; ffp != sfp && ffp != 0 ; ffp = ffp->rfp) ;
	if (ffp == 0) {
		sprintf(lexp->errbuf,"illegal source");
		lex_error(lexp,ERR_user);
		}
	clear_source(lexp->sfp);
	while(lexp->sfp != sfp) {
		source_chain_back(lexp);
		}
	}


static long get_position(drct_blk* blkp) {
	source* sfp = blkp->sfp;
	rewind_source(sfp);
	if (is_file(sfp)) {
		return ftell(sfp->fp);
		}
	return (long)(sfp->mbufix);
	}


static void set_position(drct_blk* blkp, long position) {
	source* sfp = blkp->sfp;
	rewind_source(sfp);
	if (is_file(sfp)) fseek(sfp->fp,position,0);
	else {
		sfp->mbufix = (int)position;
		if (is_template(sfp)) sfp->string = 0;
		}
	}


static int blk_no_src = 0;


/* VfBNeBu𐶐 */

static drct_blk* new_block(lex* lexp,int within) {
	source* sfp    = blk_source(lexp);
	drct_blk* blkp = new_entity(sfp->blkecp);
	blkp->id_no    = ++blk_no_src;
	blkp->within   = within;
	blkp->loc      = sfp->loc;
	blkp->parent   = sfp->drctblkp;
	sfp->drctblkp  = blkp;
	blkp->sfp      = sfp;
	if (dsp_blk_no) printf("new '%s' block id = %d\n",block_name(blkp),blkp->id_no);
	return blkp;
	}


/* ݂̃fBNeBu */

static void del_block(drct_blk* blkp) {
	source* sfp;
	if (blkp == 0) return;
	sfp = blkp->sfp;
	sfp->drctblkp = blkp->parent;
	del_entity(sfp->blkecp,blkp);
	}


/* w̃fBNeBu܂ŉ */

static drct_blk* pop_block(lex* lexp, drct_blk* blkp) {
	source*   sfp  = blk_source(lexp);
	drct_blk* bp;
	drct_blk* pp;
	for (bp = sfp->drctblkp ; bp != 0 ; bp = pp) {
		if (bp == blkp) break;
		pp = bp->parent;
		del_entity(sfp->blkecp,bp);
		}
	sfp->drctblkp = bp;
	return bp;
	}


static void rewind_to_blocktop(lex* lexp,drct_blk* blkp) {
	source*   sfp;
	pop_block(lexp, blkp);
	sfp = blk_source(lexp);
	lexp->lexloc = sfp->loc = blkp->loc;
	set_position(blkp, blkp->restart);
	if (blkp->repeat++ > max_blk_repeat) {
		sprintf(lexp->errbuf,"exceed maximum block repeat(%d)",max_blk_repeat);
		lex_error(lexp,ERR_user);
		}
	}


static drct_blk* pop_repeat(lex* lexp) {
	source*   sfp  = blk_source(lexp);
	drct_blk* bp;
	drct_blk* pp;
	for (bp = sfp->drctblkp ; bp != 0 ; bp = pp) {
		switch(bp->within) {
		case BLK_while:
		case BLK_for:
		case BLK_do:
			goto ret;
			}
		pp = bp->parent;
		del_entity(sfp->blkecp,bp);
		}
	if (bp == 0) {
		/* repeat߂݂Ȃ̂͂ */
		sprintf(lexp->errbuf,"repeat block missing");
		lex_error(lexp,ERR_user);
		}
ret:
	rewind_to_blocktop(lexp,bp);
	return bp;
	}


/* ========================================================================= */
/* =====    \[X̃XLbv                                           ===== */
/* ========================================================================= */


/* w̕܂Ń\[XXLbv */

static int skip_to_target_char(lex* lexp, int mark1, int mark2) {
	int save_mac_ctl;
	int c;
	save_mac_ctl = lexp->macro_ctl;
	lexp->macro_ctl = MAC_NG;
	for(;;) {
		c = input(lexp);
		if (c == mark1 || c == mark2) break;
		switch(c) {
		case '\\':
			input(lexp);
			break;
		case '\'':
			input(lexp);
			input(lexp);
			break;
		case '"':
			while ((c = input(lexp)) != '"') {
				switch(c) {
				case '\\':
					input(lexp);
					break;
					}
				}
			break;
			}
		}
ret:
	lexp->macro_ctl = save_mac_ctl;
	return c;
	}


/* ݂̃ubNXLbv */

static void skip_drct_block(lex* lexp,int meta_char) {
	int save_mac_ctl;
	int lvl_cnt = 0;
	int c;
	save_mac_ctl = lexp->macro_ctl;
	lexp->macro_ctl = MAC_NG;
	lexp->tbufix = 0;
	for(;;) {
		skip_to_target_char(lexp, meta_char, meta_char);
		c = skip_space_char(lexp);
		switch(c) {
		case '{':
			/* VɃubN̊JnB*/
			++lvl_cnt;
			break;
		case '}':
			/* ubNI */
			if (lvl_cnt-- == 0) goto ret;
			}
		}
ret:
	lexp->macro_ctl = save_mac_ctl;
	}


static void get_drct_word(lex* lexp) {
	int c;
	lexp->tbufix = 0;
	c = skip_space_char(lexp);
	set_wbuf(lexp,c);
	if ((c >= 'A' && c <= 'Z') || (c >= 'a' && c <= 'z')) asz_str(lexp);
	else end_wbuf(lexp);
	}


	static void skip_drct_line(lex* lexp,int meta_char);


/* ݂DIRECTsڕW܂ŃXLbv */

static void skip_drct_target(
	lex* lexp,
	int meta_char,
	int trg_char,	/* ڕW̕isv̏ꍇ́Ameta_charwj */
	int trg_blk		/* ڕWDCRTisv̏ꍇ́A-1wj */
) {
	symbol*   sym;
	sym_val*  svp;
	fileloc  loc;
	int save_skip_nl;
	int save_mac_ctl;
	int c;
	save_skip_nl = lexp->skip_nl;
	save_mac_ctl = lexp->macro_ctl;
	lexp->skip_nl = 0;
	lexp->macro_ctl = MAC_NG;
	for(;;) {
		c = skip_to_target_char(lexp, meta_char,trg_char);
		if (meta_char != trg_char && c == trg_char) goto ret;
		get_drct_word(lexp);
		sym = symbol_lookup(lexp,lexp->tokbuf);
		/* SFLfBNeBuH */
		svp = sym2val_lookup(lexp->drct_hp,sym,0,0);
		if (svp == 0) continue;		/* SFLfBNeBułȂ */
		if (svp->value == trg_blk) goto ret;
		switch(svp->value) {
		case DRCT_i:	/* include */
		case DRCT_d:	/* macro define */
		case DRCT_u:	/* macro undefine */
			do {
				c = input(lexp);
				} while(c != '\n');
			goto nl_test;
		case DRCT_if:
			/* VifubN̊JnBۂƃXLbv */
			skip_drct_line(lexp,meta_char);		/* ōsɒBĂ */
			/* else߂Ă΁AXLbv */
			do {
				loc = lexp->lexloc;
				c = skip_space_char(lexp);
				} while(c == '\n');
			if (c != meta_char) {
				uninp(lexp,c);
				goto nl_test;
				}
			get_drct_word(lexp);
			if (strcmp("else",lexp->tokbuf) == 0) {
				/* else߂Ă */
				skip_drct_line(lexp,meta_char);
				}
			else {
				/* Pԋp */
				unget_word(lexp,LEX_STR,lexp->tokbuf, &loc);
				uninp(lexp,meta_char);
				lexp->lexloc = loc;
				}
		nl_test:
			if (trg_char == '\n') goto ret;
			break;
		case DRCT_else:
			break;
		case DRCT_while:
		case DRCT_for:
		case DRCT_do:
			skip_drct_line(lexp,meta_char);		/* ōsɒBĂ */
			goto nl_test;
			break;
		case DRCT_continue:
			break;
		case DRCT_break:
			break;
		case DRCT_bigin:
			/* VɃubN̊JnB*/
			skip_drct_block(lexp,meta_char);
			/* %%% goto nl_test; */
			break;
		case DRCT_end:
			/* ̈ʒuŃubNÎ͂ */
			lexp->tbufix = sprintf(lexp->tokbuf,"%c",c);
			sprintf(lexp->errbuf,"unbalanced(1) block end");
			lex_error(lexp,ERR_user);
		case DRCT_goto:
			break;
		case DRCT_echo:
		case DRCT_set:	/* valiable define */
		case DRCT_let:	/* valiable define */
			skip_drct_line(lexp,meta_char);		/* ōsɒBĂ */
			goto nl_test;
		default:
			break;
			}
		}
ret:
	lexp->skip_nl = save_skip_nl;
	lexp->macro_ctl = save_mac_ctl;
	}


/* ݂DIRECTsXLbv */

static void skip_drct_line(lex* lexp,int meta_char) {
	skip_drct_target(lexp, meta_char,'\n',-1);
	}



/* ݂DIRECTs'%while'܂ŃXLbv */

static void skip_drct_while(lex* lexp,int meta_char) {
	skip_drct_target(lexp, meta_char,meta_char,DRCT_while);
	}



/* ========================================================================= */
/* =====    x                                                     ===== */
/* ========================================================================= */


/* w̃x܂Ń\[XXLbv */

static void skip_to_label(lex* lexp,int meta_char,symbol* lbl) {
	char*     label;
	drct_blk* blkp;
	int save_mac_ctl;
	int c;
	save_mac_ctl = lexp->macro_ctl;
	lexp->macro_ctl = MAC_NG;
	label = lbl->name;
	for(;;) {
		skip_to_target_char(lexp, meta_char, meta_char);
		lexp->tbufix = 0;
		c = skip_space_char(lexp);
		switch(c) {
		case '{':
			/* ubN̊JnB*/
			skip_drct_block(lexp,meta_char);
			continue;
		case '}':
			/* ubN̏I̂ŁAPubN|bv */
			blkp = blk_source(lexp)->drctblkp;
			if (blkp == 0) {
				sprintf(lexp->errbuf,"unbalanced(3) block end");
				lex_error(lexp,ERR_user);
				}
			del_block(blkp);
			continue;
			}
		set_wbuf(lexp,c);
		/* fBNeBu̕𓾂 */
		asz_str(lexp);
		c = skip_space_char(lexp);
		if (c != ':') {
			uninp(lexp,c);
			continue;
			}
		/* x */
		if (strcmp(lexp->tokbuf,label) == 0) {
			/* ړĨx܂œB */
			goto ret;
			}
		}
ret:
	lexp->macro_ctl = save_mac_ctl;
	}


/* ݂̃ubNOŁAw̃xo^Ă邩ׂ */

static answer rewind_to_label(lex* lexp, symbol* lbl) {
	source* sfp;
	drct_blk* blkp;
	hashtbl*  lblhash;
	sym_loc*  slp;
	sfp = blk_source(lexp);
	for (blkp = sfp->drctblkp ; blkp != 0 ; blkp = blkp->parent) {
		/* ̃ubNœo^Ă邩ׂ */
		lblhash = blkp->lblhash;
		if (lblhash == 0) continue;
		slp = sym2loc_lookup(lblhash,lbl,0,0);
		if (slp == 0) continue;
		/* o^ꂽx̂ŁÃubN܂Ń|bv */
		pop_block(lexp,blkp);
		/* xʒu܂Ŗ߂ */
		lexp->lexloc = sfp->loc = slp->loc;
		set_position(blkp, slp->position);
		return GOOD;	/* ܂B */
		}
	return FAIL;		/* w̃x́AłB */
	}


/* ݂̃ubNɁAw̃xo^ */


static void regist_label(lex* lexp,symbol* lbl) {
	source*    sfp = blk_source(lexp);
	alloc_ctl* acp = sfp->acp;
	drct_blk* blkp;
	hashtbl*  lblhash;
	sym_loc*  slp;
	blkp = sfp->drctblkp;
	if (blkp == 0) blkp = new_block(lexp,BLK_grand);
	lblhash = blkp->lblhash;
	if (lblhash == 0) lblhash = blkp->lblhash = new_hashtbl(acp);
	/* ̃ubNɓo^Ă邩ׂ */
	slp = sym2loc_lookup(lblhash,lbl,0,0);
	if (slp != 0) {
		/* łɁÃubNɓo^Ă */
		sprintf(lexp->errbuf,"duplicate label (%s)",lbl->name);
		lex_error(lexp,ERR_user);
		}
	/* ̃ubNɓo^ */
	slp = sym2loc_lookup(lblhash,lbl,0,&(sfp->loc));
	/* ̃x̒lƂāAx̃\[ẌʒuL^ */
	slp->position = get_position(blkp);
	}


/* ========================================================================= */
/* =====    fBNeBu                                         ===== */
/* ========================================================================= */


/* if̏lvZ */

static int if_condition(lex* lexp) {
	long value;
	int save_nl = lexp->skip_nl;
	int save_eof = lexp->eof_ng;
	lexp->skip_nl = 0;
	lexp->eof_ng  = 0;
	value = get_mono_number(lexp,control_num_spec);
	lexp->eof_ng  = save_eof;
	lexp->skip_nl = save_nl;
	return (value) ? 1 : 0;
	}


/* ----- forubN ----- */


/* foȑlvZ */

static int for_condition(lex* lexp) {
	long value;
	int save_nl = lexp->skip_nl;
	int save_eof = lexp->eof_ng;
	lexp->skip_nl = 0;
	lexp->eof_ng  = 0;
	value = get_number(lexp,control_num_spec);
	lexp->eof_ng  = save_eof;
	lexp->skip_nl = save_nl;
	return (value) ? 1 : 0;
	}


/* forubN̏ݒ肷 */

static void setup_for_cond(drct_blk* blkp,int meta_char) {
	source* sfp = blkp->sfp;
	lex* lexp = sfp->lexp;
	int save_mac_ctl;
	symbol* sym;
	macro* mp;
	int for_rtc;
	int c;
	save_mac_ctl = lexp->macro_ctl;
	lexp->macro_ctl = MAC_NG;
	char_assert(lexp, '(');
	for(;;) {
		c = skip_space_char(lexp);
		switch(c) {
		case ';':
			goto set_cond;
		default:
			uninp(lexp,c);
			}
		sym = def_mac_eval(lexp,';');
		/* ϐ`                          ϐ,   ϐl */
		mp = macro_lookup(sfp->acp,&(blkp->machash),sym,lexp->tokbuf);
		mp->arg = 0;	/* ϐEA[Mg */
		lexp->lexloc = lexp->sfp->loc;
		c = skip_space_char(lexp);
		switch(c) {
		case ',':
			continue;
		case ';':
			goto set_cond;
		default:
			lexp->tbufix = sprintf(lexp->tokbuf,"%c",c);
			sprintf(lexp->errbuf,"';' expected");
			lex_error(lexp,ERR_user);
			}
		}
set_cond:
	blkp->test = get_position(blkp);
	lexp->macro_ctl = MAC_SYM;
	for_rtc = for_condition(lexp);
	if ((c = skip_space_char(lexp)) != ';') {
		lexp->tbufix = sprintf(lexp->tokbuf,"%c",c);
		sprintf(lexp->errbuf,"';' expected");
		lex_error(lexp,ERR_user);
		}
	blkp->restart = get_position(blkp);
	lexp->macro_ctl = MAC_NG;
	skip_block('(', ')',lexp);
	blkp->body = get_position(blkp);
	/* for߂̏s */
	if (for_rtc == 0) {
		/* for߂̏͐ĂȂ̂ŁAforubN~߂ */
		skip_drct_line(lexp,meta_char);
		del_block(blkp);
		}
	lexp->macro_ctl = save_mac_ctl;
	}


/* forubN̎̏lvZ */

static void step_next_for(drct_blk* blkp, int meta_char) {
	source* sfp = blkp->sfp;
	lex* lexp = sfp->lexp;
	int save_mac_ctl;
	symbol* sym;
	macro* mp;
	int for_rtc;
	int c;
	save_mac_ctl = lexp->macro_ctl;
	lexp->macro_ctl = MAC_NG;
	/* %@ */
	for(;;) {
		c = skip_space_char(lexp);
		switch(c) {
		case ')':
			goto test_cond;
		default:
			uninp(lexp,c);
			}
		sym = def_mac_eval(lexp,')');
		/* ϐ폜                     ϐ,   ϐl */
		macro_lookup(sfp->acp,&(blkp->machash),sym,hash_del_mp);
		/* ϐ`                          ϐ,   ϐl */
		mp = macro_lookup(sfp->acp,&(blkp->machash),sym,lexp->tokbuf);
		mp->arg = 0;	/* ϐEA[Mg */
		lexp->lexloc = lexp->sfp->loc;
		c = skip_space_char(lexp);
		switch(c) {
		case ',':
			continue;
		case ')':
			goto test_cond;
		default:
			lexp->tbufix = sprintf(lexp->tokbuf,"%c",c);
			sprintf(lexp->errbuf,"')' expected");
			lex_error(lexp,ERR_user);
			}
		}
test_cond:
	set_position(blkp, blkp->test);
	lexp->macro_ctl = MAC_SYM;
	for_rtc = for_condition(lexp);
	if (skip_space_char(lexp) != ';') {
		lexp->tbufix = sprintf(lexp->tokbuf,"%c",c);
		sprintf(lexp->errbuf,"';' expected");
		lex_error(lexp,ERR_user);
		}
	set_position(blkp, blkp->body);
	if (for_rtc == 0) {
		/* ubN̉߂~߂ */
		skip_drct_line(lexp,meta_char);
		del_block(blkp);
		}
	lexp->macro_ctl = save_mac_ctl;
	}


/* ----- whileubN ----- */

static void while_cond(drct_blk* blkp,int meta_char) {
	source* sfp = blkp->sfp;
	lex* lexp = sfp->lexp;
	int if_rtc = if_condition(lexp);
	if (if_rtc) {
		/* while͐Ă̂ŁÂ܂ܑs */
		return;
		}
	/* while͕sȂ̂ŁAwhileubNXLbv */
	skip_drct_line(lexp,meta_char);
	del_block(blkp);
	}


/* ----- doubN ----- */

static void do_cond(drct_blk* blkp,int meta_char) {
	source* sfp = blkp->sfp;
	lex* lexp = sfp->lexp;
	int if_rtc = if_condition(lexp);
	if (if_rtc) {
		/* while͐Ă̂ŁA擪ɖ߂ */
		set_position(blkp, blkp->restart);
		return;
		}
	/* while͕sȂ̂ŁÂ܂ܒʉ߂ */
	del_block(blkp);
	}


/* ========================================================================= */
/* =====    rekfBNeBu                                       ===== */
/* ========================================================================= */


extern int meta_off_ctl;


ENTRY answer sfl_directive(lex* lexp, int meta_char, int c) {
	int save_nl;
	int save_eof;
	int save_mac_ctl;
	int if_rtc;
	int sel_dir;
	fileloc   loc;
	source*   sfp;
	symbol*   sym;
	sym_val*  svp;
	macro*    mp;
	uni_link* lp;
	drct_blk* blkp;
	symbol*   lbl;
	int       tok;
	answer    rtc;
	int       line_feed;
	if (lexp->in_drct) return FAIL;
	lexp->in_drct = 1;
	/* ͏̕ۑƕύX */
	save_nl = lexp->skip_nl;
	save_eof = lexp->eof_ng;
	lexp->skip_nl = 0;
	lexp->eof_ng = 1;
	line_feed = 0;
	loc = lexp->lexloc;		/* ݂̈ʒuL^ */
	rtc = FAIL;				/* ꉞfBNeBuŖƂĂ */
	if (c == meta_char) goto meta_func;
	/* ͕̓^ł͖̂ŁAubN̏I[ɂĒׂ */
	blkp = blk_source(lexp)->drctblkp;
	if (blkp == 0) goto ret;


/* %%% */

	if (c != '\n') {
		if (c != ' ' && c != '\t') {
			/* ʏ͂̕ł̂ŁAif-trueubN̏I[ɂĒׂ */


/* %% */
#if 0
			if ((blkp->within == BLK_if || blkp->within == BLK_else) && blkp->restart >= 1) {
				/* if߂́AɂPȏ̉sǂݍłA
				   ɑelse߂͖̂ŁAI */
				del_block(blkp);
				}
#endif

			switch(blkp->within) {
			case BLK_if:
				/* if߂́AɂPȏ̉sǂݍłA
				   ɑelse߂͖̂ŁAI */
				if (blkp->restart == 0) break;
			case BLK_else:
				/* if߂ɑelse߂͖̂ŁAI */
				del_block(blkp);
				}


			}
		goto ret;
		}

	/* s͂ł̂ŁAeubN̏I[ɂĒׂ */
	switch(blkp->within) {
	case BLK_if:
		blkp->restart++;
		break;
	case BLK_else:
		/* else߂̍sɒB̂ŁAI */
		del_block(blkp);
		break;
	case BLK_while:
		/* while߂̍sɒB̂ŁA[v̐擪ɖ߂ */
		rewind_to_blocktop(lexp,blkp);
		while_cond(blkp,meta_char);
		break;
	case BLK_for:
		pop_repeat(lexp);
		step_next_for(blkp,meta_char);
		break;
		}
	goto ret;
meta_func:
	/* ͕̓^Ȃ̂ŁAfBNeBus */
	if (meta_char == 0) goto ret;
	rtc = GOOD;	/* directive */
	/* METAɑV{擾 */
	get_drct_word(lexp);
	sym = symbol_lookup(lexp,lexp->tokbuf);
	/* SFLfBNeBuH */
	svp = sym2val_lookup(lexp->drct_hp,sym,0,0);
	if (svp == 0) goto label_test;	/* SFLfBNeBułȂH */
	if ((int)svp->value != DRCT_else) {
		/* else߈ȊOȂ̂ŁAif-trueubN̏I[ɂĒׂ */
		blkp = blk_source(lexp)->drctblkp;
		if (blkp != 0) {
			switch(blkp->within) {
			case BLK_if:
				/* if߂́AɂPȏ̉sǂݍłA
				   ɑelse߂͖̂ŁAI */
				if (blkp->restart == 0) break;
			case BLK_else:
				/* if߂ɑelse߂͖̂ŁAI */
				del_block(blkp);
				}
			}
		}
	switch((int)svp->value) {
	case DRCT_i:	/* include */
		/* CN[ht@CJ */
		lexp->tbufix =0;
		c = skip_space_char(lexp);
		switch(c) {
		case '\n':
			goto ret;
		case '"':
		case '<':
			sel_dir = c;	/* c: CN[hEt@CE^Cv */
			break;
		default:
			sel_dir = 1;
			set_wbuf(lexp,c);
			break;
			}
		/* CN[hEt@C擾 */
		get_string(lexp, sel_dir);
		/* CN[hEt@CɕtɂA[Mg擾 */
		get_cmd_arg(lexp,lexp->tokbuf);
		line_feed = 0;
		/* A[MgtŃCN[hEt@CJ */
		new_include(lexp,sel_dir,lexp->args[0],'$',lexp->argc,lexp->args);
		goto ret;

	case DRCT_d:	/* macro define */
		sym = def_mac_string(lexp,&lp);
		/* }N`                     }N,   }Nl */
		mp = macro_lookup(lexp->acp,&(lexp->machash),sym,lexp->tokbuf);
		if (mp == 0) {
			sprintf(lexp->errbuf,"already defined (%s)",sym->name);
			lex_error(lexp,ERR_user);
			}
		mp->arg = lp;	/* }NEA[Mg */
		/* }N̒`̍sXLbv */
		line_feed = 1;
		goto ret;

	case DRCT_u:	/* macro undefine */
		/* }N̒` */
		save_mac_ctl = lexp->macro_ctl;
		lexp->macro_ctl = MAC_NG;
		/* }N̕擾 */
		lexp->tbufix = 0;
		c = skip_space_char(lexp);
		set_wbuf(lexp,c);
		if (symbol_str(lexp, c, &tok) == 0) {
			sprintf(lexp->errbuf,"macro name expected");
			lex_error(lexp,ERR_user);
			}
		/* }NV{ɂ */
		sym = symbol_lookup(lexp,lexp->tokbuf);
		/* }N폜                     }N,   }Nl */
		macro_lookup(lexp->acp,&(lexp->machash),sym,hash_del_mp);
		lexp->macro_ctl = save_mac_ctl;
		/* }N̒`̍sXLbv */
		line_feed = 1;
		goto ret;
	case DRCT_if:
		blkp = new_block(lexp,BLK_if);	/* VȃubNݒ肷 */
		blkp->restart = 0;
		if_rtc = if_condition(lexp);
		if (if_rtc) {
			/* if͐̂ŁÂ܂ܑs */
			blkp->within = BLK_if;		/* within true */
			}
		else {
			/* if͕sȂ̂ŁAif̍sXLbv */
			skip_drct_line(lexp,meta_char);
			/* elseߑ҂ݒ */
			blkp->within = BLK_else;	/* within false */
			}
		goto ret;

	case DRCT_else:
		blkp = blk_source(lexp)->drctblkp;
		if (blkp == 0) goto else_err;
		switch(blkp->within) {
		case BLK_if:
			/* if߂ŝŁAelse߂̓XLbv */
			skip_drct_line(lexp,meta_char);
			break;
		case BLK_else:
			/* ̃ubŃAelseߑ҂Ă */
			/* else߂͗LȂ̂ŁÂ܂ܑs */
			break;
		default:
			goto else_err;
			}
		/* if߂͏Ił */
		del_block(blkp);
		goto ret;
	else_err:
		/* if߂̉ߒłȂ̂͂ */
		sprintf(lexp->errbuf,"%cif missing",meta_char);
		lex_error(lexp,ERR_user);
	case DRCT_while:
		blkp = blk_source(lexp)->drctblkp;
		if (blkp->within == BLK_do) {
			/* doubN̉ߒł */
			do_cond(blkp,meta_char);
			goto ret;
			}
		blkp = new_block(lexp,BLK_while);	/* VȃubNݒ肷 */
		blkp->restart = get_position(blkp);
		while_cond(blkp,meta_char);
		goto ret;

	case DRCT_for:
		/* for߂̐ݒ𓾂 */
		blkp = new_block(lexp,BLK_for);
		setup_for_cond(blkp,meta_char);
		goto ret;

	case DRCT_do:
		blkp = new_block(lexp,BLK_do);	/* VȃubNݒ肷 */
		blkp->restart = get_position(blkp);
		goto ret;

	case DRCT_continue:
		blkp = pop_repeat(lexp);
		switch(blkp->within) {
		case BLK_while:
			/* while߂̎̃[vs */
			while_cond(blkp,meta_char);
			goto ret;
		case BLK_for:
			/* for߂̎̃[vs */
			step_next_for(blkp,meta_char);
			goto ret;

		case BLK_do:
			/* do߂̎̃[vs */
			skip_drct_while(lexp,meta_char);
			/* doubN𔻒肷 */
			do_cond(blkp,meta_char);
			goto ret;

		default:
			/* while,for߂̉ߒłȂ̂͂ */
			sprintf(lexp->errbuf,"repeat block missing");
			lex_error(lexp,ERR_user);
			}
		goto ret;

	case DRCT_break:
		blkp = pop_repeat(lexp);
		switch(blkp->within) {
		case BLK_while:
			/* ubN̉߂~߂ */
			skip_drct_line(lexp,meta_char);
			del_block(blkp);
			goto ret;
		case BLK_for:
			/* ubN̉߂~߂ */
			set_position(blkp, blkp->body);
			skip_drct_line(lexp,meta_char);
			del_block(blkp);
			goto ret;
		case BLK_do:
			/* ubN̉߂~߂ */
			skip_drct_while(lexp,meta_char);
			/* doubNǂݎ̂ */
			if_condition(lexp);
			del_block(blkp);
			goto ret;
		default:
			/* while,for߂̉ߒłȂ̂͂ */
			sprintf(lexp->errbuf,"repaet block missing");
			lex_error(lexp,ERR_user);
			}
		goto ret;
	case DRCT_bigin:
		blkp = new_block(lexp,BLK_bigin);		/* VȃubNݒ肷 */
		goto ret;
	case DRCT_end:
		blkp = blk_source(lexp)->drctblkp;
		if (blkp == 0 || blkp->within != BLK_bigin) {
			/* ubN̉ߒłȂ̂͂ */
			sprintf(lexp->errbuf,"unbalanced(4) block end");
			lex_error(lexp,ERR_user);
			}
		del_block(blkp);
		goto ret;
	case DRCT_goto:
		/* w肳ꂽx擾 */
		lexp->tbufix = 0;
		c = skip_space_char(lexp);
		set_wbuf(lexp,c);
		asz_str(lexp);
		lbl = symbol_lookup(lexp,lexp->tokbuf);
		/* QƂŒT */
		if (rewind_to_label(lexp,lbl) == FAIL) {
			/* o^ꂽxȂ̂ŁAOQƂƔf */
			skip_to_label(lexp,meta_char,lbl);
			}
		goto ret;
	case DRCT_echo:
		/* w肳ꂽbZ[W擾 */
		{
			source* sfp = lexp->sfp;
			source* rfp;
			int save_eof = lexp->eof_ng;
			int save_mac = lexp->macro_ctl;
			lexp->eof_ng    = 0;
			lexp->macro_ctl = MAC_SYM;
			lexp->tbufix = 0;
			c = skip_space_char(lexp);
			for(;;) {
				switch(c) {
				case EOF:
					uninp(lexp,c);
					goto dsp_echo;
				case '\n':
					/* }NWJĂꍇ͌p */
					for (rfp = lexp->sfp->rfp ; rfp != 0 ; rfp = rfp->rfp) {
						if (rfp == sfp) {
							/* '\n'́A}NƔBp */
							goto echo_chr;
							}
						}
					uninp(lexp,c);
					goto dsp_echo;
				case '"':
					get_string(lexp, '"');
					c = input(lexp);
					continue;
					}
			echo_chr:
				set_wbuf(lexp,c);
				c = input(lexp);
				}
		dsp_echo:
			end_wbuf(lexp);
			lexp->macro_ctl = save_mac;
			lexp->eof_ng = save_eof;
			}
		lexp->tbufix = cut_tail_space(lexp->tokbuf);
		if      (strcmp(lexp->tokbuf,"on" ) == 0) lexp->echo_on = 1;
		else if (strcmp(lexp->tokbuf,"off") == 0) lexp->echo_on = 0;
		else if (lexp->echo_on) fprintf(lexp->speakfp,"%s\n",lexp->tokbuf);
		goto ret;

	case DRCT_set:	/* valiable define */
		/* Vϐo^ */
		sfp  = blk_source(lexp);
		blkp = sfp->drctblkp;
		if (blkp == 0) blkp = new_block(lexp,BLK_grand);
		loc = lexp->sfp->loc;
		sym = def_mac_eval(lexp,LEX_NL);
		/* ϐT                          ϐ,   */
		mp = macro_lookup(sfp->acp,&(blkp->machash),sym,0);
		if (mp != 0) {
			sprintf(lexp->errbuf,"valiable(%s) is already defined.",mp->macsym->name);
			lex_loc_err(lexp,&loc,ERR_user);
			}
		/* ϐ`                          ϐ,   ϐl */
		mp = macro_lookup(sfp->acp,&(blkp->machash),sym,lexp->tokbuf);
		mp->arg = 0;	/* ϐEA[Mg */
		/* ϐ̒`̍sXLbv */
		line_feed = 1;
		goto ret;

	case DRCT_let:	/* valiable define */
		/* ϐ̒lXV */
		loc = lexp->sfp->loc;
		sym = def_mac_eval(lexp,LEX_NL);
		/* ϐo^nbVe[u */
		sfp  = seek_drct_value(lexp,sym,&blkp,&mp);
		if (sfp == 0) {
			lexp->tbufix = sprintf(lexp->tokbuf,"%s",sym->name);
			sprintf(lexp->errbuf,"valiable(%s) is not defined",lexp->tokbuf);
			lex_loc_err(lexp,&loc,ERR_user);
			}
		/* ϐ폜                     ϐ,   ϐl */
		macro_lookup(sfp->acp,&(blkp->machash),sym,hash_del_mp);
		/* ϐ`                          ϐ,   ϐl */
		mp = macro_lookup(sfp->acp,&(blkp->machash),sym,lexp->tokbuf);
		mp->arg = 0;	/* ϐEA[Mg */
		/* ϐ̒`̍sXLbv */
		line_feed = 1;
		goto ret;
	default:
		goto label_test;
		}
ret:
	/* ͏̕ */
	lexp->eof_ng = save_eof;
	if (line_feed) skip_line(lexp);
	lexp->skip_nl = save_nl;
	lexp->in_drct = 0;
	return rtc;
label_test:
	c = skip_space_char(lexp);
	if (c == ':') {
		regist_label(lexp,sym);
		goto ret;
		}
	uninp(lexp,c);
	if (meta_off_ctl == 0) {
		/* fBNeBúAɗLȂ̂ŁA`Ȃ̂͂B */
		sprintf(lexp->errbuf,"undefined %c directive (%s)",meta_char,lexp->tokbuf);
		lex_error(lexp,ERR_user);
		return rtc;
		}

	unget_word(lexp,LEX_STR,lexp->tokbuf, &loc);
	rtc = FAIL;

	line_feed = 0;
	goto ret;
	}

