/*
 *  notice: japanese
 *@쌠҂̍mF
 *@@uf[^TCgJvOgp@QŁv
 *@@ɋLڂ́uvOvƓɎ舵ĒƂɁA
 *@@{hLg̉{EpEۊǂF߂܂B
 */

/*
 * ps_proto.h
 *
 * define protitype functions.
 * Version 1.06 Beta   Date 1999.02.08
 * Copyright (c) Datasight Corp., 1996-1999.
 * All Rights Reserved.
 * Made by A.Nakashima
 *
 */


#if !defined(PS_PROTO_H)
#define PS_PROTO_H


#if defined(ENTRY)
#	undef ENTRY
#	endif
#define ENTRY extern


/* ========================================================================= */
/* =====   sflexpan.c                                                  ===== */
/* ========================================================================= */


ENTRY int sflspec_no;
ENTRY char* cmd_exec_path;
ENTRY char* lib_comp_path;
ENTRY char* user_comp_path;
ENTRY char* comp_exec_path;
ENTRY char* comp_exec_ext;


/* ========================================================================= */
/* =====   ps_cmd.c                                                    ===== */
/* ========================================================================= */


ENTRY void   script_backtrace(lex* lexp);
ENTRY void   cmd_error(lex* lexp, int rtc);
ENTRY int    remark_lookup(hashtbl* hp,symbol* sym);
ENTRY int    cal_bit_width(int cnt);
ENTRY char*  sflntok2dec_str(token* tp);
ENTRY char*  sflntok2str(token* tp);
ENTRY char*  memadr2str(token* tp);
ENTRY token* str2sflntok(tMYc char* buf);
ENTRY token* resize_sfln(tMYc unsigned int fig,token* tp);
ENTRY token* tell_token_path(FILE* spkfp, token* tp);
ENTRY void   tell_expr_path(FILE* spkfp, int no, expr* rep);
ENTRY int    get_cmd_code(tMYc char* sp);
ENTRY token* get_command(tMYc token* lxp);
ENTRY void   parge_all(tMY);
ENTRY char*  gui_init(global* my,int gui_buflen);
ENTRY void   dummy_gui_2_cui(int len,char* buf);
ENTRY global* interpreter_init(int,char**,char*,cmd_func*,setup_parm* setup_tbl[]);
ENTRY int    command_interpreter(global* my);
ENTRY char*  analize_arg(int* argcp, char*** argvp);


/* ========================================================================= */
/* =====   ps_token.c                                                  ===== */
/* ========================================================================= */


ENTRY char* token_name(token* tp);
ENTRY char* token_file(token* tp);
ENTRY int   token_line(token* tp);
ENTRY void  token_rename(lex* lexp, token* tp, char* name);
ENTRY void  dsp_token_name(token* tp);
ENTRY char* token_location(token* tp);
ENTRY void  tok_claim(lex* lexp,token* tp);
ENTRY void  tok_error(lex* lexp,token* tp);


/* Hash Table */
ENTRY component* component_table(token* gtp);
ENTRY token* token_lookup(token* gtp, token* tp, int* newfp);

/* link functions */
ENTRY token* alloc_tok_buf(alloc_ctl* acp);
ENTRY void free_tok_buf(alloc_ctl* acp, token* tp);

ENTRY void unget_token(lex* lexp, token* tp);
ENTRY unsigned long str2num(lex* lexp, char *bp);
ENTRY token* get_token(tMYc token* gtp, token* lxp);
ENTRY int next_tokcode(lex* lexp);
ENTRY void sfl_assert(lex* lexp,int typ);
ENTRY answer same_token_assert(tMYc token* dtp,token* stp);
ENTRY void sub_token_duplicate(token* dtp, token* stp);
ENTRY answer same_arg_assert(tMYc token* dtp, token* stp);
ENTRY token* define_new_member(tMYc token* parp, int typ);
ENTRY void check_dup_member(tMYc int set_flg,token* now_tp,token* set_tp);
ENTRY char* name_restrict(char* o_name,int try_cnt);
ENTRY void mod_name_change(tMYc token* mtp);
ENTRY void with_toksym_alias(tMYc token* mtp);

ENTRY void dsp_template(tMYc char* fn);
ENTRY mod_def_env* save_my_env_at_define(tMYc alloc_ctl* acp);
ENTRY void get_arg_link_of_token(tMYc token* def_tp,int typ,int left,int right);
ENTRY token* apply_template(tMYc token*,token*,token* (*)(tMYc token*, int, token*));
ENTRY void define_tpl_real_arg(tMYc token* module_tp,int r_ang);
ENTRY void make_tpl_class_name(lex* lexp,token* tp);
ENTRY void record_template(tMYc token* tpl_tp,mod_def_env* envp);


/* ========================================================================= */
/* =====   ps_sflrd.c                                                  ===== */
/* ========================================================================= */


ENTRY char* type_name(int);
ENTRY char* tok_id_name(token* tp);
ENTRY key_word drct_key_tbl[];
ENTRY key_word sfl_key_tbl[];
ENTRY key_word char_opr_tbl[];

ENTRY char* element_opr_name(int opr);
ENTRY char* mono_opr_name(int opr);
ENTRY char* expr_opr_name(int opr);
ENTRY char* beh_opr_name(int opr);
ENTRY char* decl_opr_name(int opr);
ENTRY char* opr_name(int opr);

ENTRY void teach_key_dict(lex* lexp, token* ktp, key_word* tbl);
ENTRY void chain_arg_list(token* link_tp,token* tp);
ENTRY void sflread(tMYc char* fname, int argc, char** args);
ENTRY token* get_stage_name(tMYc token* module_tp);
ENTRY token* get_segment_name(tMYc token* stage_tp);
ENTRY token* get_state_name(tMYc token* stgseg_tp);


ENTRY token* seek_auto_task(tMYc token* stage_tp, int auto_def);
ENTRY long get_bit_order(lex* lexp, char* object, long low);
ENTRY token* get_eval_num_tok(lex* lexp,token* tp);


/* ========================================================================= */
/* =====   ps_beh.c                                                    ===== */
/* ========================================================================= */


ENTRY opr_inst* opr_inst_lookup(expr* ep,opr_inst* instp);
ENTRY void  add_expr_ulink(alloc_ctl* acp, uni_link** lpp, expr* ep);
ENTRY int   describe_rd_behavior(tMYc token* owner_tp);
ENTRY void  delete_exp_behavior(expr* ep);
ENTRY expr* duplicate_exp_behavior(expr* ep, expr* beh);
ENTRY expr* step_back_behavior(expr* ep);
ENTRY int   decl_opr_priority(int opr);
ENTRY int   beh_opr_priority(int opr);
ENTRY int   expr_opr_priority(int spec_no,int opr);
ENTRY int   mono_opr_priority(int spec_no,int opr);
ENTRY int   element_opr_priority(int opr);
ENTRY char* expr_location(expr *dep);
ENTRY answer same_exp_assert(lex* lexp, expr* dep, expr* sep);
ENTRY void  f_Del_expr_ulink(uni_link* lp);


/* ========================================================================= */
/* =====   ps_nldwt.c                                                  ===== */
/* ========================================================================= */


ENTRY void nldwrite(tMYc char* fn);


/* ========================================================================= */
/* =====   ps_sflwt.c                                                  ===== */
/* ========================================================================= */


ENTRY char* token_sname(token* tp);
ENTRY void sflwrite(tMYc char* fn);
ENTRY void sflwt_exp_behavior(FILE* spkfp, int indlvl,expr* ep);
ENTRY void sflwt_opr_expression(FILE*,int,expr*);
ENTRY void sflwt_elm_opr_expression(FILE* spkfp, int lvl,expr* ep);
ENTRY void sflwt_bra_opr_expression(FILE*,int,expr*);


/* ========================================================================= */
/* =====   ps_class.c                                                  ===== */
/* ========================================================================= */


ENTRY classtbl* classtbl_lookup(hashtbl* hp,symbol* sym);
ENTRY void make_class_def(char* cname,char* ctype,int figure,int width,char program_type);
ENTRY char* get_class_name(char* ctype,int opr,int figure,int width,char* program_typep);
ENTRY classtbl* get_class_tblp(char* ctype,int opr,int figure,int width,char program_type);
ENTRY lex* cmd_lexp;
ENTRY hashtbl* class_hashtbl;
ENTRY hashtbl* inst_hashtbl;


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


#if defined(EXTRA)
#	include "sm_proto.h"
#	endif


#undef  ENTRY
#define ENTRY 

#endif PS_PROTO_H

