/*
 *  notice: japanese
 *@쌠҂̍mF
 *@@uf[^TCgJvOgp@QŁv
 *@@ɋLڂ́uvOvƓɎ舵ĒƂɁA
 *@@{hLg̉{EpEۊǂF߂܂B
 */

/*
 * ps_sflwt.c
 *
 * sflwrite command execution.
 * Version 1.10 Beta   Date 1999.5.8
 * Copyright (c) Datasight Corp., 1996-1999.
 * All Rights Reserved.
 * Made by A.Nakashima
 *
 */


#define foot_on 0
#include "ps_selec.h"
#include "ps_misc.h"
#include "ps_lex.h"
#include "ps_strct.h"
#include "ps_tdef.h"
#include "ps_proto.h"


#if defined(EXTRA)
#	define Ex_sflwt
#	include "extra.h"
#	endif


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


#if !defined(Ex_sflwt_exp_pass)
#	define Ex_sflwt_exp_pass
#	define Ex_sflwt_mono_pass
#	endif


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


#define sflwt_mono_behavior dsp_sflwt_mono_behavior
static void sflwt_mono_behavior(FILE*,int,expr*);

extern hashtbl* class_hashtbl;
extern hashtbl* inst_hashtbl;

static int circuit_type;


/*****************************************************************************/
/* ========================================================================= */
/* =====    source indent                                            ===== */
/* ========================================================================= */
/*****************************************************************************/


static char* incl_direcive = "%i";
static char  incl_left  = '"';
static char  incl_right = '"';
static int   newl_pos   = 70;


static int indent_on   =  1;
static int beauty_pos  = -1;
static int dsp_cond_no =  0;
static int putc_cnt    =  0;
static int now_indlvl  =  0;

/* xNg\̍ڃCfFNX */
static int vector_ix   =  0;	/* 0: ̎ vector Ȃ */


static void speak_ind(FILE* spkfp, int indlvl) {
	int end;
	now_indlvl = indlvl;
	if (indent_on == 0) {
		/* Ps̒newl_pos܂łɐB */
		end = indlvl * 4 + 40;
		/* APsɍŒSO͏oƂɂ */
		if (end < newl_pos) end = newl_pos;
		if (putc_cnt > end) fprintf(spkfp,"\n");
		else return;
		}
	putc_cnt = 0;
	while(indlvl-- > 0) putc_cnt += fprintf(spkfp,"    ");
	indent_on = 0;
	}


static void indent_clear(void) {
	indent_on = 1;
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


static char* sflrd_with_ext = ".prt";

static void define_opr_class_declare(
	FILE* spkfp,
	int indlvl,
	token* declare_tp,
	char* fn
){
	static char* delm = "; \t\n";
	char* path;
	FILE* wfp;
	alloc_ctl* acp;
	token* tp;
	component* cp;
	uni_link* lp;
	hashtbl* remark_hp = 0;
	unsigned int i;
	if (sflspec_no != 1) return;
	if (declare_tp == 0) return;
	cp = declare_tp->comp_tbl;
 	if (cp == 0) return;
	/* %%% '98.6.19 */
	for (lp = cp->top ; lp != 0 ; lp = lp->np) {
		hashtbl* hp;
		tp = lp->ap;
		switch(token_id(tp)) {
		case DEF_module:
		case DEF_circuit:
			hp = tp->ipp[TOKi_sfl_class];
			for (i = 0 ; i < hp->tblsiz ; ++i) {
				classtbl* p;
				p = hp->tblpp[i];
				if (p == 0) continue;
				if (p->tblent == 0) continue;
				if (remark_hp == 0 || remark_lookup(remark_hp,p->sym) == 0) continue;
				goto put;
				}
			break;
			}
		}
	return;
put:
	if (fn != NULL && *fn != 0) {
		fn = another_ext_file_name(fn,sflrd_with_ext);
		wfp = fopen(fn,"wt");
		if (wfp == NULL) {
			fprintf(serr_efp,"Can't open (%s)",fn);
			sys_error("define_opr_class_declare()");
			}
		}
	else {
		wfp = stdout;
		}
	acp = new_mactl();
	remark_hp = new_hashtbl(acp);
	for (lp = cp->top ; lp != 0 ; lp = lp->np) {
		hashtbl* hp;
		tp = lp->ap;
		switch(token_id(tp)) {
		case DEF_module:
		case DEF_circuit:
			hp = tp->ipp[TOKi_sfl_class];
			for (i = 0 ; i < hp->tblsiz ; ++i) {
				classtbl* p;
				p = hp->tblpp[i];
				if (p == 0) continue;
				if (p->tblent == 0) continue;
				if (remark_lookup(remark_hp,p->sym) == 0) continue;
				/* W[ */
				path = str_tok(user_comp_path,delm);
				speak_ind(spkfp,indlvl);
				putc_cnt += fprintf(spkfp,"%s %c%s/%s.h%c\n",
					incl_direcive,
					incl_left,
					path,p->sym->name,
					incl_right,
					indlvl	/* dummy use */
					);
				indent_clear();
				fprintf(wfp,"sflread %s/%s.sfl\n",path,p->sym->name);
				}
			break;
			}
		}
	if (wfp != stdout) fclose(wfp);
	del_mactl(acp);
	}


/*****************************************************************************/
/* ######################################################################### */
/* #####  SFL syntax                                                   ##### */
/* ######################################################################### */
/*****************************************************************************/


/*****************************************************************************/
/* ========================================================================= */
/* =====   V{                                                  ===== */
/* ========================================================================= */
/*****************************************************************************/


/* TuW[̃g[N */

ENTRY char* token_sname(token* tp) {
	if (tp == 0) ;
	else if (tp->tokren == 0) ;
	else if (tp->tokren->name == 0) ;
	else return tp->tokren->name;
	return "";
	}


/*****************************************************************************/
/* ========================================================================= */
/* =====   SFLLq                                                   ===== */
/* ========================================================================= */
/*****************************************************************************/


/*
| SFLLq ::= { W[̐錾 | W[̒` | @\H̒` }
*/


	static void define_declare(FILE*,int,token*);
	static void define_module(FILE*,int,token*);
	static void define_circuit(FILE*,int,token*);


ENTRY void sflwrite(tMYc char* fn) {
	lex* lexp = my->cmdlexp;
	int indlvl = 0;
	token* tp;
	component* cp;
	uni_link* lp;
	FILE* spkfp;
	if (fn != NULL && *fn != 0) {
		spkfp = fopen(fn,"wt");
		if (spkfp == NULL) {
			sprintf(lexp->errbuf,"Can't open (%s)",fn);
			lex_error(lexp,ERR_user);
			}
		}
	else {
		spkfp = lexp->speakfp;
		}
	/* put all auto-include */
	define_opr_class_declare(spkfp,indlvl,my->class_tp,fn);
	if (my->declare_tp == 0) goto next1;
	cp = my->declare_tp->comp_tbl;
	if (cp == 0) goto next1;
	for (lp = cp->top ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		switch(token_id(tp)) {
		case DEF_declare:
			define_declare(spkfp,indlvl,tp);
			break;
			}
		}
next1:
	if (my->class_tp == 0) goto next2;
	cp = my->class_tp->comp_tbl;
	if (cp == 0) goto next2;
	for (lp = cp->top ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		switch(token_id(tp)) {
		case DEF_module:
			class_hashtbl = tp->ipp[TOKi_sfl_class];
			inst_hashtbl  = tp->ipp[TOKi_sfl_inst];
			define_module(spkfp,indlvl,tp);
			break;
		case DEF_circuit:
			class_hashtbl = tp->ipp[TOKi_sfl_class];
			inst_hashtbl  = tp->ipp[TOKi_sfl_inst];
			define_circuit(spkfp,indlvl,tp);
			break;
			}
		}
next2:;
	if (spkfp != stdout) fclose(spkfp);
	}


/* ========================================================================= */
/* =====  W[̐錾                                             ===== */
/* ========================================================================= */


/*
|W[̐錾 ::=	
|	declare W[ '{
|		{O[q̒`}
|		{험p̐[q̉̒`}
|	'}
*/


	static void sflwt_exterm(FILE*, int, uni_link*);
	static void sflwt_instrin_arg(FILE*, int indlvl, uni_link* lp);


static void define_declare(FILE* spkfp, int indlvl,token* declare_tp) {
	component* cp;
	uni_link* lp;
	footmark("define_declare");
	if (declare_tp == 0) return;
	cp = declare_tp->comp_tbl;
	if (cp == 0) return;
	lp = cp->top;
	/* W[ */
	speak_ind(spkfp,indlvl);
	putc_cnt += fprintf(spkfp,"declare %s {\n",token_sname(declare_tp));
	indent_clear();
	++indlvl;
	/* {O[q̒`} */
	sflwt_exterm(spkfp,indlvl, lp);
	/* {험p̐[q̉̒`} */
	sflwt_instrin_arg(spkfp,indlvl, lp);
	speak_ind(spkfp,indlvl+beauty_pos);
	putc_cnt += fprintf(spkfp,"}\n");
	indent_clear();
	}


/*
|O[q̒` ::=
|	  input    f[^͒[q['<rbg '>]{,f[^͒[q['<rbg'>]};
|	| output   f[^o͒[q['<rbg '>]{,f[^o͒[q['<rbg '>]};
|	| bidirect f[^o[q['<rbg '>]{,f[^o[q['<rbg '>]};
|	| instrin  ͒[q{,͒[q};
|	| instrout o͒[q{,o͒[q};
*/


	static void rep_define_element(FILE*,int,token*);


static void sflwt_exterm(FILE* spkfp, int indlvl, uni_link* lp) {
	token* tp;
	footmark("sflwt_exterm");
	if (lp == 0) return;
	/* {O[q̒`|\vf̒`} */
	for ( ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		switch(token_id(tp)) {
		/* O[q̒` sflwt_exterm(MYc tp) */
		case DEF_input:
		case DEF_output:
		case DEF_bidirect:
		case DEF_instrin:
		case DEF_instrout:
			rep_define_element(spkfp,indlvl,tp);
			break;
			}
		}
	}


/*
|f[^͒[q['<rbg '>] { , f[^͒[q['<rbg'>] } ;
*/


static void rep_define_element(FILE* spkfp, int indlvl, token* tp) {
	footmark("rep_define_element");
	speak_ind(spkfp,indlvl);
	putc_cnt += fprintf(spkfp,"%-8s %s",tok_id_name(tp),token_sname(tp));
	if (tp->figure > 1) putc_cnt += fprintf(spkfp,"<%d>",tp->figure);
	putc_cnt += fprintf(spkfp,";\n");
	indent_clear();
	}


/*
|험p̐[q̉̒` ::=
|	instr_arg ͒[q([͂ƂȂ[q{,͂ƂȂ[q}]);
*/


	static void define_argument(FILE*,uni_link*,int);


static void sflwt_instrin_arg(FILE* spkfp, int indlvl, uni_link* lp) {
	token* tp;
	footmark("sflwt_instrin_arg");
	for ( ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		switch(token_id(tp)) {
		case DEF_instrin:	/* ͒[q([͂ƂȂ[q{,͂ƂȂ[q}]); */
			if (tp->arg == 0) break;
			speak_ind(spkfp,indlvl);
			putc_cnt += fprintf(spkfp,"instr_arg %s",token_sname(tp));
			define_argument(spkfp,tp->arg,0);
			putc_cnt += fprintf(spkfp,";\n");
			indent_clear();
			break;
			}
		}
	}


/* ========================================================================= */
/* =====  W[̒`                                             ===== */
/* ========================================================================= */


/*
|W[̒` ::=
|	module W[ '{
|		{W[̐錾}
|		{O[q̒`|\vf̒`}
|		{[q̉̒`}
|		{Xe[Wƃ^XNƉ̒`}
|		[ʓ̒`]
|		{[qɂ铮̒`}
|		{Xe[W̓菇̒`}
|	'}
 */


	static void sflwt_ext_or_element(FILE* spkfp, int indlvl, uni_link* lp);
	static void sflwt_opr_class_element(FILE*,int,token*);
	static void sflwt_instr_arg(FILE* spkfp, int indlvl, uni_link* lp);
	static void sflwt_stage_name(FILE*,int,uni_link*);
	static void sflwt_behavior(FILE*,int,token*);
	static void common_behavior(FILE*,int,token*);
	static void sflwt_instruct(FILE*,int,uni_link*);
	static void sflwt_stage_behavior(FILE*,int,uni_link*);


static void define_module(FILE* spkfp, int indlvl,token* module_tp) {
	component* cp;
	uni_link* lp;
	footmark("define_module");
	if (module_tp == 0) return;
	cp = module_tp->comp_tbl;
	if (cp == 0) return;
	circuit_type = 0;
	lp = cp->top;
	/* module W[ */
	speak_ind(spkfp,indlvl);
	putc_cnt += fprintf(spkfp,"module %s {\n",token_sname(module_tp));
	indent_clear();
	++indlvl;
	/* {W[̐錾} */
	/* --- NONE --- */
	/* {O[q̒`|\vf̒`} */
	sflwt_ext_or_element(spkfp,indlvl,lp);
	sflwt_opr_class_element(spkfp,indlvl,module_tp);
	/* {[q̉̒`} */
	sflwt_instr_arg(spkfp,indlvl,lp);
	/* {Xe[Wƃ^XNƉ̒`} */
	sflwt_stage_name(spkfp,indlvl,lp);
	/* [ʓ̒`] */
	common_behavior(spkfp,indlvl,module_tp);
	/* {[qɂ铮̒`} */
	sflwt_instruct(spkfp,indlvl, lp);
	/* {Xe[W̓菇̒`} */
	sflwt_stage_behavior(spkfp,indlvl,lp);
	speak_ind(spkfp,indlvl+beauty_pos);
	putc_cnt += fprintf(spkfp,"}\n");
	indent_clear();
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


ENTRY void source_circuit(FILE* spkfp, int indlvl, token* tp) {
	define_circuit(spkfp,indlvl,tp);
	}


/*
|@\H̒` ::=
|	circuit @\H '{
|		{W[̐錾}
|		{O[q̒`|\vf̒`}
|		{[q̉̒`}
|		{Xe[Wƃ^XNƉ̒`}
|		[ʓ̒`]
|		{[qɂ铮̒`}
|		{Xe[W̓菇̒`}
|	'}
*/


	static void rep_define_mem(FILE*,int,token*);
	static void rep_define_submod(FILE*,int, token*);


static void define_circuit(FILE* spkfp, int indlvl, token* circuit_tp) {
	component* cp;
	uni_link* lp;
	footmark("define_circuit");
	if (circuit_tp == 0) return;
	circuit_type = 1;
	cp = circuit_tp->comp_tbl;
	if (cp == 0) return;
	lp = cp->top;
	/* W[̐錾 */
	speak_ind(spkfp,indlvl);
	putc_cnt += fprintf(spkfp,"circuit %s {\n",token_sname(circuit_tp));
	indent_clear();
	++indlvl;
	/* {W[̐錾} */
	/* --- NONE --- */
	/* {O[q̒`|\vf̒`} */
	sflwt_ext_or_element(spkfp,indlvl,lp);
	sflwt_opr_class_element(spkfp,indlvl,circuit_tp);
	/* {[q̉̒`} */
	sflwt_instr_arg(spkfp,indlvl,lp);
	/* {Xe[Wƃ^XNƉ̒`} */
	sflwt_stage_name(spkfp,indlvl,lp);
	/* [ʓ̒`] */
	common_behavior(spkfp,indlvl,circuit_tp);
	/* {[qɂ铮̒`} */
	sflwt_instruct(spkfp,indlvl, lp);
	/* {Xe[W̓菇̒`} */
	sflwt_stage_behavior(spkfp,indlvl,lp);
	speak_ind(spkfp,indlvl+beauty_pos);
	putc_cnt += fprintf(spkfp,"}\n");
	indent_clear();
	}


/*****************************************************************************/
/* ========================================================================= */
/* =====   \vf                                                  ===== */
/* ========================================================================= */
/*****************************************************************************/


/*
|\vf̒` ::=
|	  instrself [q{,[q};
|	| bus f[^[q['<rbg '>]{,f[^[q['<rbg '>]};
|	| sel f[^[q['<rbg '>]{,f[^[q['<rbg '>]};
|	| bus_v f[^[q['<rbg '>]{,f[^[q['<rbg '>]};
|	| sel_v f[^[q['<rbg '>]{,f[^[q['<rbg '>]};
|	| reg WX^['<rbg '>]{,WX^['<rbg '>]};
|	| reg_ws WX^['<rbg '>]{,WX^['<rbg '>]};
|	| reg_wr WX^['<rbg '>]{,WX^['<rbg '>]};
|	| mem  '[|h ']['<rbg '>]{, '[|h ']['<rbg '>]};
|	| W[ TuW[{,TuW[};
*/


static void sflwt_ext_or_element(FILE* spkfp, int indlvl, uni_link* lp) {
	token* tp;
	footmark("sflwt_ext_or_element");
	if (lp == 0) return;
	for ( ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		switch(token_id(tp)) {
		/* {O[q̒`} */
		case DEF_input:
		case DEF_output:
		case DEF_bidirect:
		case DEF_instrin:
		case DEF_instrout:
			rep_define_element(spkfp,indlvl,tp);
			break;
		/* {\vf̒`} */
		case DEF_instrself:
		case DEF_bus:
		case DEF_sel:
		case DEF_bus_v:
		case DEF_sel_v:
		case DEF_reg:
		case DEF_reg_ws:
		case DEF_reg_wr:
			rep_define_element(spkfp,indlvl,tp);
			break;
		case DEF_mem:
			rep_define_mem(spkfp,indlvl,tp);
			break;
		case DEF_submod:
			rep_define_submod(spkfp,indlvl,tp);
			break;
			}
		}
	}


static void sflwt_opr_class_element(FILE* spkfp,int indlvl,token* mtp) {
	hashtbl* hp;
	unsigned int i,j;
	char program_type;
	if (sflspec_no != 1) return;
	if (mtp == 0) return;
	hp = mtp->ipp[TOKi_sfl_class];
	if (hp == 0) return;
	for (i = 0 ; i < hp->tblsiz ; ++i) {
		classtbl* p;
		p = hp->tblpp[i];
		if (p == 0) continue;
		if (p->tblent == 0) continue;
		speak_ind(spkfp,indlvl);
		putc_cnt += fprintf(spkfp,"%-8s",p->sym->name);
		for (j = 0 ; j < p->tblent ; ++j) {
			opr_inst* q;
			q = p->tblpp[j];
			if (j == 0) {
				putc_cnt += fprintf(spkfp," ");
				program_type = module_prefix;
				if (circuit_type != 0) {
					if (strcmp(q->ctype,"mul") == 0 || 
					    strcmp(q->ctype,"div") == 0 ){
						program_type = circuit_prefix;
						}
					}
				/* ̃NX̕i쐬 */
				make_class_def(p->sym->name,q->ctype,q->figure,q->width,program_type);
				}
			else putc_cnt += fprintf(spkfp,",");
			if (j != 0 && (j % 8) == 0) {
				putc_cnt += fprintf(spkfp,"\n");
				indent_clear();
				speak_ind(spkfp,indlvl+1);
				}
			putc_cnt += fprintf(spkfp,"%s",q->sym->name);
			}
		putc_cnt += fprintf(spkfp,";\n");
		indent_clear();
		}
	}


/*
|	| mem  '[|h ']['<rbg '>]{, '[|h ']['<rbg '>]};
*/


static void rep_define_mem(FILE* spkfp, int indlvl, token* tp) {
	footmark("rep_define_mem");
	speak_ind(spkfp,indlvl);
	putc_cnt += fprintf(spkfp,"%s %s[%s]",tok_id_name(tp),token_sname(tp),memadr2str(tp));
	if (tp->figure > 1) putc_cnt += fprintf(spkfp,"<%d>",tp->figure);
	putc_cnt += fprintf(spkfp,";\n");
	indent_clear();
	}


/*
|	| W[ TuW[{,TuW[};
*/


static void rep_define_submod(FILE* spkfp, int indlvl, token* tp) {
	footmark("rep_define_submod");
	speak_ind(spkfp,indlvl);
	putc_cnt += fprintf(spkfp,"%s %s;\n",token_sname(tp->twin),token_sname(tp));
	indent_clear();
	}


/*****************************************************************************/
/* ========================================================================= */
/* =====                                                     ===== */
/* ========================================================================= */
/*****************************************************************************/


/*
|[q̉̒` ::=
|	  instr_arg o͒[q([o͂ƂȂ[q{,o͂ƂȂ[q}]);
|	| instr_arg [q([f[^[q{,f[^[q}]);
|	| instr_arg TuW[.͒[q([͂ƂȂ[q{,͂ƂȂ[q}]);
||͂ƂȂ[q ::=
|	  f[^͒[q
|	| f[^o[q
||o͂ƂȂ[q ::=
|	  f[^o͒[q
|	| f[^o[q
*/


static void sflwt_instr_arg(FILE* spkfp, int indlvl, uni_link* lp) {
	token* tp;
	token* stp;
	component* ecp;
	uni_link* slp;
	footmark("sflwt_instr_arg");
	for ( ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		switch(token_id(tp)) {
		case DEF_instrout:	/* o͒[q([o͂ƂȂ[q{,o͂ƂȂ[q}]); */
		case DEF_instrself:	/* [q([f[^[q{,f[^[q}]); */
			if (tp->arg == 0) break;
			speak_ind(spkfp,indlvl);
			putc_cnt += fprintf(spkfp,"instr_arg %s",token_sname(tp));
			define_argument(spkfp,tp->arg,0);
			putc_cnt += fprintf(spkfp,";\n");
			indent_clear();
			break;
		case DEF_submod:	/* TuW[.͒[q([͂ƂȂ[q{,͂ƂȂ[q}]); */
			ecp = tp->comp_tbl;
			if (ecp == 0) break;
			for (slp = ecp->top ; slp != 0 ; slp = slp->np) {
				stp = slp->ap;
				switch(stp->id) {
				case DEF_instrin:
					if (stp->arg == 0) break;
					if (get_arg_ovrwt(stp) == 0) break;
					speak_ind(spkfp,indlvl);
					putc_cnt += fprintf(spkfp,"instr_arg %s",token_name(stp));
					define_argument(spkfp,stp->arg,0);
					putc_cnt += fprintf(spkfp,";\n");
					indent_clear();
					break;
					}
				}
			break;
			}
		}
	}


/*
|Xe[Wƃ^XNƉ̒` ::=
|	stage_name Xe[W '{
|		{task ^XN([WX^{,WX^}]);}
|	'}
*/


	static void sflwt_task_name(FILE* spkfp, token* tp);


static void sflwt_stage_name(FILE* spkfp, int indlvl,uni_link* lp) {
	token* tp;
	token* stp;
	component* ecp;
	uni_link* slp;
	footmark("sflwt_stage_name");
	if (lp == 0) return;
	for ( ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		switch(token_id(tp)) {
		case DEF_stage_name:
			speak_ind(spkfp,indlvl);
			putc_cnt += fprintf(spkfp,"stage_name %s{",token_sname(tp));
			ecp = tp->comp_tbl;
			if (ecp == 0) goto ret;
			for (slp = ecp->top ; slp != 0 ; slp = slp->np) {
				stp = slp->ap;
				switch(stp->id) {
				case DEF_task:
					sflwt_task_name(spkfp,slp->ap);
					}
				}
		ret:
			putc_cnt += fprintf(spkfp,"}\n");
			indent_clear();
			}
		}
	}


static void sflwt_task_name(FILE* spkfp, token* tp) {
	/* task ^XN ( [WX^{,WX^}] ) ; */
	footmark("sflwt_task_name");
	putc_cnt += fprintf(spkfp,"task %s",token_sname(tp));
	define_argument(spkfp,tp->arg,1);
	putc_cnt += fprintf(spkfp,"; ");
	}


/* ( [WX^{,WX^}] ) */


static void define_argument(FILE* spkfp, uni_link* lp, int force) {
	footmark("define_argument");
	if (lp == 0 && force == 0) return;
	putc_cnt += fprintf(spkfp,"(");
	while(lp != 0) {
		putc_cnt += fprintf(spkfp,"%s",token_sname(lp->ap));
		lp = lp->np;
		if (lp == 0) break;
		putc_cnt += fprintf(spkfp,",");
		}
	putc_cnt += fprintf(spkfp,")");
	}


/*****************************************************************************/
/* ========================================================================= */
/* =====   ̎̂̓                                          ===== */
/* ========================================================================= */
/*****************************************************************************/

/* ========================================================================= */
/* =====  ʓ̒`                                               ===== */
/* ========================================================================= */


/*
|ʓ̒` ::= 
*/


static void common_behavior(FILE* spkfp, int indlvl,token* owner_tp) {
	component *cp;
	expr* ep;
	footmark("common_behavior");
	cp = owner_tp->comp_tbl;
	if (cp == 0) return;
	ep = cp->behavior;
	if (ep == 0) return;

	if (ep->opr == OPR_behavior) ep = ep->op1;
	switch(ep->opr) {
	case OPR_par:
	case OPR_alt:
	case OPR_any:
	case OPR_if:
		/* if () par {...} Ȃǂ̂߁A"par {" Œɉs鎞ƁA
		   Ȃ鎖ɒӂ邱ƁB
		*/ 
;
/* %%%
		speak_ind(spkfp,indlvl++);
*/
		}

	sflwt_exp_behavior(spkfp,indlvl,cp->behavior);
	}


/* ========================================================================= */
/* =====  [qɂ铮̒`                                     ===== */
/* ========================================================================= */


/*
|[qɂ铮̒` ::=
|	  instruct ͒[q 
|	| instruct [q 
|	| instruct TuW[.o͒[q 
*/


static void sflwt_instruct(FILE* spkfp, int indlvl, uni_link* lp) {
	token* tp;
	token* stp;
	component *ecp;
	uni_link* slp;
	for ( ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		switch(token_id(tp)) {
		case DEF_instrin:
		case DEF_instrself:
			if (tp->comp_tbl == 0) break;
			if (tp->comp_tbl->behavior == 0) break;
			speak_ind(spkfp,indlvl);
			putc_cnt += fprintf(spkfp,"instruct %s ",token_name(tp));
			sflwt_behavior(spkfp,indlvl+1,tp);
			break;
		case DEF_submod:
			ecp = tp->comp_tbl;
			if (ecp == 0) break;
			for (slp = ecp->top ; slp != 0 ; slp = slp->np) {
				stp = slp->ap;
				switch(stp->id) {
				case DEF_instrout:
					if (stp->comp_tbl == 0) break;
					if (stp->comp_tbl->behavior == 0) break;
					speak_ind(spkfp,indlvl);
					putc_cnt += fprintf(spkfp,"instruct %s ",token_name(stp));
					sflwt_behavior(spkfp,indlvl+1,stp);
					break;
					}
				}
			break;
			}
		}
	}


/* ========================================================================= */
/* =====  Xe[W̓菇̒`                                     ===== */
/* ========================================================================= */


/*
|Xe[W̓菇̒` ::=
|	stage Xe[W '{
|		{Ԗ̒`}
|		{ZOg̒`}
|		[Ԃ̒`]
|		[ʓ̒`]
|		{Ԃ̓̒`}
|		{ZOg̓菇̒`}
|	'}
*/


	static void sflwt_state_name(FILE* spkfp, int indlvl, uni_link* lp);
	static void sflwt_segment_name(FILE* spkfp, int indlvl, uni_link* lp);
	static void sflwt_first_state(FILE* spkfp, int indlvl, component* cp);
	static void sflwt_state(FILE*,int, uni_link*);
	static void sflwt_segment(FILE*,int, uni_link*);


static void sflwt_stage_behavior(FILE* spkfp, int indlvl, uni_link* lp) {
	token* tp;
	component* cp;
	uni_link* slp;
	footmark("sflwt_stage_behavior");
	for ( ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		switch(token_id(tp)) {
		case DEF_stage_name:
			cp = tp->comp_tbl;
			if (cp == 0) break;
			slp = cp->top;
			/* stage Xe[W '{ */
			speak_ind(spkfp,indlvl);
			putc_cnt += fprintf(spkfp,"stage %s {\n",token_sname(tp));
			indent_clear();
			/* {Ԗ̒`} */
			sflwt_state_name(spkfp,indlvl+1,slp);
			/*	{ZOg̒`} */
			sflwt_segment_name(spkfp,indlvl+1,slp);
			/*	[Ԃ̒`] */
			sflwt_first_state(spkfp,indlvl+1,cp);
			/*	[ʓ̒`] */
			common_behavior(spkfp,indlvl+1,tp);
			/*	{Ԃ̓̒`} */
			sflwt_state(spkfp,indlvl+1,slp);
			/*	{ZOg̓菇̒`} */
			sflwt_segment(spkfp,indlvl+1,slp);
			speak_ind(spkfp,indlvl+1+beauty_pos);
			putc_cnt += fprintf(spkfp,"}\n");
			indent_clear();
			break;
			}
		}
	}


/*
|ZOg̓菇̒` ::=
|	segment ZOg '{
|		{Ԗ̒`}
|		Ԃ̒`
|		[ʓ̒`]
|		{Ԃ̓̒`}
|	'}
*/


static void sflwt_segment(FILE* spkfp, int indlvl, uni_link* lp) {
	token* tp;
	component* cp;
	uni_link* slp;
	footmark("sflwt_segment");
	for ( ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		switch(token_id(tp)) {
		case DEF_segment_name:
			cp = tp->comp_tbl;
			if (cp == 0) break;
			slp = cp->top;
			/* segment ZOg '{ */
			speak_ind(spkfp,indlvl);
			putc_cnt += fprintf(spkfp,"segment %s {\n",token_sname(tp));
			indent_clear();
			/* {Ԗ̒`} */
			sflwt_state_name(spkfp,indlvl+1,slp);
			/*	[Ԃ̒`] */
			sflwt_first_state(spkfp,indlvl+1,cp);
			/*	[ʓ̒`] */
			common_behavior(spkfp,indlvl+1,tp);
			/*	{Ԃ̓̒`} */
			sflwt_state(spkfp,indlvl+1,slp);
			speak_ind(spkfp,indlvl+1+beauty_pos);
			putc_cnt += fprintf(spkfp,"}\n");
			indent_clear();
			break;
			}
		}
	}


/*
| Ԗ̒` ::= state_name Ԗ{,Ԗ};
*/


static void sflwt_state_name(FILE* spkfp, int indlvl, uni_link* lp) {
	token* tp;
	for ( ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		switch(token_id(tp)) {
		case DEF_state_name:
			speak_ind(spkfp,indlvl);
			putc_cnt += fprintf(spkfp,"state_name %s;\n",token_sname(tp));
			indent_clear();
			}
		}
	}


/*
|ZOg̒` ::= segment_name ZOg{,ZOg};
*/


static void sflwt_segment_name(FILE* spkfp, int indlvl, uni_link* lp) {
	token* tp;
	for ( ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		switch(token_id(tp)) {
		case DEF_segment_name:
			speak_ind(spkfp,indlvl);
			putc_cnt += fprintf(spkfp,"segment_name %s;\n",token_sname(tp));
			indent_clear();
			}
		}
	}


/*
|Ԃ̒` ::= first_state Ԗ;
*/


static void sflwt_first_state(FILE* spkfp, int indlvl, component* cp) {
	if (cp->first == 0) return;
	speak_ind(spkfp,indlvl);
	putc_cnt += fprintf(spkfp,"first_state %s;\n",token_sname(cp->first));
	indent_clear();
	}


/*
| Ԃ̓̒` ::= state Ԗ 
*/


static void sflwt_state(FILE* spkfp, int indlvl, uni_link* lp) {
	token* tp;
	footmark("sflwt_state");
	for ( ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		switch(token_id(tp)) {
		case DEF_state_name:
			speak_ind(spkfp,indlvl);
			putc_cnt += fprintf(spkfp,"state %s ",token_sname(tp));
			sflwt_behavior(spkfp,indlvl+1, tp);
			break;
			}
		}
	}


/*****************************************************************************/
/* ========================================================================= */
/* =====                                                         ===== */
/* ========================================================================= */
/*****************************************************************************/


	static void sflwt_mono_expression(FILE*,int,expr*);


static void sflwt_behavior(FILE* spkfp, int indlvl,token* owner_tp) {
	component *cp;
	footmark("sflwt_behavior");
	cp = owner_tp->comp_tbl;
	if (cp == 0) {
		putc_cnt += fprintf(spkfp,";\n");
		indent_clear();
		return;
		}
	sflwt_exp_behavior(spkfp,indlvl,cp->behavior);
	}


static void sflwt_opr_expr_bit_or(FILE* spkfp,int lvl,expr* ep) {
	int opr_lvl;
	if (sflspec_no == 1 && ep->fig > 1) {
		opr_lvl = mono_opr_priority(sflspec_no,OPR_bit_or);
		if (lvl < opr_lvl) {
			putc_cnt += fprintf(spkfp,"(");
			putc_cnt += fprintf(spkfp,"%s", expr_opr_name(OPR_bit_or));
			sflwt_opr_expression(spkfp,opr_lvl,ep);
			putc_cnt += fprintf(spkfp,")");
			}
		else {
			putc_cnt += fprintf(spkfp,"%s", expr_opr_name(OPR_bit_or));
			sflwt_opr_expression(spkfp,opr_lvl,ep);
			}
		}
	else sflwt_opr_expression(spkfp,lvl,ep);
	}


/*
| ::=
|	  parubN
|	| altubN
|	| anyubN
|	| ifubN
|	| Pʓ
|
|parubN ::= par'{{}'}
|altubN ::= alt'{t{t}[else]'}
|anyubN ::= any'{t{t}[else]'}
|ifubN ::= if()
|t ::= :
|else ::= else:
| ::= 
*/


ENTRY void sflwt_exp_behavior(FILE* spkfp, int indlvl,expr* ep) {
	expr* cep;
	footmark("sflwt_exp_behavior");
	if (ep == 0) return;
	if (ep->opr == OPR_behavior) ep = ep->op1;
	switch(ep->opr) {
	case OPR_par:
		speak_ind(spkfp,indlvl++);
		putc_cnt += fprintf(spkfp,"par {\n");
		indent_clear();
		for ( ; ep != 0 ; ep = ep->op2) {
			speak_ind(spkfp,indlvl);
			sflwt_exp_behavior(spkfp,indlvl,ep->op1);
			}
		speak_ind(spkfp,indlvl+beauty_pos);
		putc_cnt += fprintf(spkfp,"}\n");
		indent_clear();
		break;
	case OPR_alt:
		speak_ind(spkfp,indlvl++);
		putc_cnt += fprintf(spkfp,"alt {\n");
		indent_clear();
		goto any;
	case OPR_any:
		speak_ind(spkfp,indlvl++);
		putc_cnt += fprintf(spkfp,"any {\n");
		indent_clear();
	any:
		for ( ; ep != 0 ; ep = ep->op2) {
			speak_ind(spkfp,indlvl);
			/*
			|t ::= :
			|else     ::= else:
			*/
			cep = ep->op1;
			if (cep->op1 != 0) {
				/*  */
				sflwt_opr_expr_bit_or(spkfp,NO_priority,cep->op1);
				}
			else putc_cnt += fprintf(spkfp,"else");
			if (dsp_cond_no) {
				putc_cnt += fprintf(spkfp," /*[%d]*/ ",cep->beh->opr);
				}
			putc_cnt += fprintf(spkfp," : ");
			/* t */
			sflwt_exp_behavior(spkfp,indlvl,cep->op2);
			if (cep->op1 == 0 && ep->op2 != 0) {	/* else: */
				sys_error("illegal else");
				}
			}
		speak_ind(spkfp,indlvl+beauty_pos);
		putc_cnt += fprintf(spkfp,"}\n");
		indent_clear();
		break;
	case OPR_if:
		speak_ind(spkfp,indlvl);
		putc_cnt += fprintf(spkfp,"if (");
		/*  */
		sflwt_opr_expr_bit_or(spkfp,NO_priority,ep->op1);
		if (dsp_cond_no) {
			putc_cnt += fprintf(spkfp," /*[%d]*/ ",ep->beh->opr);
			}
		putc_cnt += fprintf(spkfp,") ");
		sflwt_exp_behavior(spkfp,indlvl,ep->op2);
		break;
	Ex_sflwt_exp_pass
	default:
		sflwt_mono_behavior(spkfp,indlvl,ep);
		}
	}


ENTRY void dsp_sflwt_exp_behavior(FILE* spkfp, int indlvl, uni_link* lp) {
	footmark("dsp_sflwt_exp_behavior");
	for ( ; lp != 0 ; lp = lp->np) {
		sflwt_exp_behavior(spkfp,indlvl, (expr*)(lp->ap));
		}
	}


/*****************************************************************************/
/* ========================================================================= */
/* =====   Pʓ                                                  ===== */
/* ========================================================================= */
/*****************************************************************************/


/*
|Pʓ ::=
|	  [qւ̒l̏o
|	| WX^ւ̏
|	| ւ̏
|	| ԑJ
|	| ZOgĂяo
|	| ߂Ԃw肵ȂZOgĂяo
|	| ZOg̕A
|	| Wu̐
|	| Wu̓]
|	| WȕI
|	| [q̋N
|	| 
|[qւ̒l̏o ::=
|	  f[^[q=;
|	| f[^o͒[q=;
|	| f[^o[q=;
|	| TuW[.f[^͒[q=;
|	| TuW[.f[^o[q=;
|WX^ւ̏ ::= WX^:=;
|ւ̏ ::=  '[ ']:=;
|ԑJ ::= goto Ԗ;
|ZOgĂяo ::= call ZOg(߂Ԗ);
|߂Ԃw肵ȂZOgĂяo ::= call ZOg();
|ZOg̕A ::= return;
|Wu̐ ::= generate Xe[W.^XN([{,}]);
|Wu̓] ::= relay Xe[W.^XN([{,}]);
|WȕI ::= finish;
|[q̋N ::=
|	  o͒[q([{,}]);
|	| [q([{,}]);
|	| TuW[.͒[q([{,}]);
| ::= ;
|߂Ԗ ::= Ԗ
| ::= 
*/


	static void argument_val(FILE*,expr*);
	static void sflwt_token_element(FILE* spkfp, expr* ep);


ENTRY void sflwt_mono_behavior(FILE* spkfp, int indlvl, expr* ep) {
	expr* ap;
	footmark("sflwt_mono_behavior");
	if (ep == 0) return;
	speak_ind(spkfp,indlvl);
	switch(ep->opr) {
	/* |[qւ̒l̏o ::= */
	case OPR_eq_term:	/*   f[^[q =  ; */
						/* | f[^o͒[q =  ; */
						/* | f[^o[q =  ; */
						/* | TuW[.f[^͒[q =  ; */
						/* | TuW[.f[^o[q =  ; */
		if (sflspec_no == 1) {
			int lvl = indlvl + 1;
			token* tp = (token*)(ep->op1);
			if (token_id(tp) == DEF_vector) {
				putc_cnt += fprintf(spkfp,"par {\n");
				indent_clear();
/* %%% */
				if (ep->op2 != 0 && (ap = ep->op2->op2) != 0) {
					/* [q([{,}]). */
					token* itp;
					token* ptp;
					switch(ap->opr) {
					case OPR_active:
						speak_ind(spkfp,lvl);
						itp =(token*)(ap->op1);
						ptp = itp->parent;
						if (ptp != 0) {
							switch(ptp->id) {
							case DEF_submod:
							case DEF_stage_name:
								putc_cnt += fprintf(spkfp,"%s.",token_name(ptp));
								}
							}
						putc_cnt += fprintf(spkfp,"%s(",token_sname(itp));
						argument_val(spkfp,ap->op2);
						putc_cnt += fprintf(spkfp,");\n");
						indent_clear();
						}
					}
				for (vector_ix = 1 ; vector_ix <= tp->figure ; ++vector_ix) {
					speak_ind(spkfp,lvl);
					sflwt_token_element(spkfp, ep);
					putc_cnt += fprintf(spkfp," = ");
					sflwt_opr_expression(spkfp,NO_priority,ep->op2);
					putc_cnt += fprintf(spkfp,";\n");
					indent_clear();
					} 
				speak_ind(spkfp,lvl+beauty_pos);
				putc_cnt += fprintf(spkfp,"}\n");
				indent_clear();
				vector_ix = 0;
				return;
				}
			}
		sflwt_token_element(spkfp, ep);
		putc_cnt += fprintf(spkfp," = ");
		sflwt_opr_expression(spkfp,NO_priority,ep->op2);
		break;
	case OPR_active:	/* | TuW[.͒[q([{,}]) ; */
						/* | o͒[q([{,}]); */
						/* | [q([{,}]); */
		putc_cnt += fprintf(spkfp,"%s(",token_name((token*)(ep->op1)));
		argument_val(spkfp,ep->op2);
		putc_cnt += fprintf(spkfp,")");
		break;
	/* WX^ւ̏ ::= */
	case OPR_eq_reg:	/* WX^ :=  ; */
		putc_cnt += fprintf(spkfp,"%s := ",token_sname((token*)(ep->op1)));
		sflwt_opr_expression(spkfp,NO_priority,ep->op2);
		break;
	/* ւ̏ ::= */
	case OPR_mem_wt:	/*  '[ ']:=; */
		ap = ep->op1;
		putc_cnt += fprintf(spkfp,"%s[",token_sname((token*)(ap->op1)));
		sflwt_opr_expression(spkfp,NO_priority,ap->op2);
		putc_cnt += fprintf(spkfp,"] := ");
		sflwt_opr_expression(spkfp,NO_priority,ep->op2);
		break;
	case OPR_void:				/*  ::= ; */
		break;
	/* ԑJ ::= */
	case OPR_goto:			/*goto Ԗ; */
		/* ep->op1 = (expr*)(my->stgseg_tp); */
		putc_cnt += fprintf(spkfp,"goto %s",token_sname((token*)(ep->op2)));
		break;
	/* ZOgĂяo ::= */
	case OPR_call:
		/*
			ep->op1 = (expr*)(my->stgseg_tp);
			ep->op2 : 
					call ZOg() ,߂Ԃw肵ȂZOgĂяo
					->opr = OPR_ret_void;
					->op1 = (expr*)tp; call_segment
					->op2 = (expr*)(my->state_tp);
					call ZOg(߂Ԗ)
					->opr = OPR_ret_stat;
					->op1 = (expr*)tp; call_segment
					->op2 = (expr*)stp; return_state
		*/
		ap = ep->op2;
		switch(ap->opr) {
		case OPR_ret_void:
			putc_cnt += fprintf(spkfp,"call %s()",token_sname((token*)(ap->op1)));
			break;
		case OPR_ret_stat:
			putc_cnt += fprintf(spkfp,"call %s(",token_sname((token*)(ap->op1)));
			putc_cnt += fprintf(spkfp,"%s)",token_sname((token*)(ap->op2)));
			break;
			}
		break;
	/* ZOg̕A ::= */
	case OPR_return:		/* return; */
		/* ep->op1 = (expr*)(my->segment_tp); */
		putc_cnt += fprintf(spkfp,"return");
		break;
	/* Wu̐ ::= */
	case OPR_generate:		/* generate Xe[W.^XN([{,}]); */
		putc_cnt += fprintf(spkfp,"generate");
		putc_cnt += fprintf(spkfp," %s(",token_name((token*)(ep->op1)));
		argument_val(spkfp,ep->op2);
		putc_cnt += fprintf(spkfp,")");
		break;
	/* Wu̓] ::= */
	case OPR_relay:			/* relay Xe[W.^XN([{,}]); */
		putc_cnt += fprintf(spkfp,"relay");
		putc_cnt += fprintf(spkfp," %s(",token_name((token*)(ep->op1->op1)));
		argument_val(spkfp,ep->op2);
		putc_cnt += fprintf(spkfp,")");
		break;
	/* WȕI ::= */
	case OPR_finish:		/* finish; */
		putc_cnt += fprintf(spkfp,"finish");
		break;
	Ex_sflwt_mono_pass
	default:
		indent_clear();
		fprintf(serr_efp,"\nopr = x%02x(%c) name=%s\n",ep->opr,ep->opr,opr_name(ep->opr));
		sys_error("Unknown operation : sflwt_mono_behavior()");
		}
	putc_cnt += fprintf(spkfp,";\n");
	indent_clear();
	}


	/* ߂Ԗ ::= Ԗ */
	/*  ::=  */


/* [  { ,  } ]  ) */


static void argument_val(FILE* spkfp, expr* lep) {
	expr* ep;
	footmark("argument_val");
	while(lep != 0) {
		ep = lep->op1;
		/* 
			ep->opr = ( OPR_eq_reg : OPR_eq_term)
			ep->op1 = (expr*)tp
			ep->op2 = sflwt_opr_expression
		*/
		sflwt_opr_expression(spkfp,NO_priority,ep->op2);
		lep = lep->op2;
		if (lep != 0) putc_cnt += fprintf(spkfp,",");
		}
	}


/*****************************************************************************/
/* ========================================================================= */
/* =====   CZq                                                ===== */
/* ========================================================================= */
/*****************************************************************************/


/*
| ::=
|	  P |  		// or 
|	| P @  		// eor 
|	| P &  		// and 
|	| P || 		// A 
|	| P +  		// Z 
|	| P >> 		// rbgEVtg 
|	| P << 		// rbgVtg 
|	| P == 		// v 
|	| P

|	| P -  		// Z 
|	| P *  		// Z 
|	| P /  		// Z 
|	| P %  		// ] 
*/


/*
̊֐́ÂQʂɎgpB
(1) spkfp == 0 ̏ꍇ
@@rekXybNP̏ꍇɁAw̉Z邽߂Ɂi\́jgݍ݊֐
@@gpKv鉉Zǂ肷B
@@gݍ݊֐Kvȏꍇɂ́Å֐̉ZxԒlƂȂB
(2) spkfp != 0 ̏ꍇ
@@rekXybNP̏ꍇɁAw̉Z邽߂ɁAgݍ݊֐gp
@@rek\[XfB
F
@PԖڂ̒ƂQԖڂ̃\[X̘_ɖȂ悤ɁA֐
@Qʂ̎gĂB
*/

static int sflwt_s1_opr_expression(FILE* spkfp, int paren, int opr_lvl, expr* ep) {
	opr_inst* insp;
	char* data;
	char* inv;
	int opr;
	if (paren) {
		putc_cnt += fprintf(spkfp,"(");
		opr_lvl = NO_priority;
		}
	switch(opr = ep->opr) {
	case OPR_cmp_eq:
		if (spkfp == 0) return mono_opr_priority(sflspec_no,opr);
		sflwt_opr_expression(spkfp,opr_lvl,ep->op1);
		putc_cnt += fprintf(spkfp," %s ", expr_opr_name(OPR_cmp_eq));
		sflwt_opr_expression(spkfp,opr_lvl,ep->op2);
		break;
	case OPR_cmp_ne:
		if (spkfp == 0) return mono_opr_priority(sflspec_no,OPR_bit_or);
		putc_cnt += fprintf(spkfp,"%s(",expr_opr_name(OPR_bit_or));
		opr_lvl = expr_opr_priority(sflspec_no,OPR_xor);
		sflwt_opr_expression(spkfp,opr_lvl,ep->op1);
		putc_cnt += fprintf(spkfp," %s ", expr_opr_name(OPR_xor));
		sflwt_opr_expression(spkfp,opr_lvl,ep->op2);
		putc_cnt += fprintf(spkfp,")");
		break;
	case OPR_cmp_gt:
	case OPR_cmp_ge:
	case OPR_cmp_lt:
	case OPR_cmp_le:
		if (spkfp == 0) return ELp_dot;
		insp = opr_inst_lookup(ep,0);
		if (insp == 0) break;
		putc_cnt += fprintf(spkfp,"%s.do(",insp->sym->name);
		sflwt_opr_expression(spkfp,NO_priority,ep->op1);
		putc_cnt += fprintf(spkfp,",");
		sflwt_opr_expression(spkfp,NO_priority,ep->op2);
		putc_cnt += fprintf(spkfp,").out");
		break;
	case OPR_plus:
		data = "0b0";
		inv  = "";
		goto cpa;
	case OPR_minus:
		data = "0b0";
		inv  = mono_opr_name(OPR_invert);
	cpa:
		if (circuit_type == 0) {
			if (spkfp == 0) return ELp_dot;
			insp = opr_inst_lookup(ep,0);
			if (insp == 0) break;
			putc_cnt += fprintf(spkfp,"%s.do(",insp->sym->name);
			sflwt_opr_expression(spkfp,NO_priority,ep->op1);
			putc_cnt += fprintf(spkfp,",%s",inv);
			opr_lvl = mono_opr_priority(sflspec_no,OPR_invert);
			sflwt_opr_expression(spkfp,opr_lvl,ep->op2);
			putc_cnt += fprintf(spkfp,",%s).out",data);
			}
		else {
			if (spkfp == 0) return expr_opr_priority(sflspec_no,OPR_plus);
			opr_lvl = expr_opr_priority(sflspec_no,OPR_plus);
			sflwt_opr_expression(spkfp,opr_lvl,ep->op1);
			putc_cnt += fprintf(spkfp," + ");
			switch(ep->opr) {
			case OPR_plus:
				sflwt_opr_expression(spkfp,opr_lvl,ep->op2);
				break;
			case OPR_minus:
				putc_cnt += fprintf(spkfp,"%s",opr_name(OPR_invert));
				opr_lvl = mono_opr_priority(sflspec_no,OPR_invert);
				sflwt_opr_expression(spkfp,opr_lvl,ep->op2);
				putc_cnt += fprintf(spkfp," + 0b1");
				break;
				}
			}
		break;
	case OPR_multi:
	case OPR_divide:
	case OPR_residue:
		if (spkfp == 0) return ELp_dot;
		insp = opr_inst_lookup(ep,0);
		if (insp == 0) break;
		putc_cnt += fprintf(spkfp,"%s.do(",insp->sym->name);
		sflwt_opr_expression(spkfp,NO_priority,ep->op1);
		putc_cnt += fprintf(spkfp,",");
		sflwt_opr_expression(spkfp,NO_priority,ep->op2);
		if (ep->opr == OPR_residue) putc_cnt += fprintf(spkfp,").rsd");
		else putc_cnt += fprintf(spkfp,").out");
		break;
		}
	if (paren) putc_cnt += fprintf(spkfp,")");
	return 0;
	}


static void sflwt_bi_expression(FILE* spkfp, int paren, int opr_lvl,expr* ep) {
	if (paren) {
		putc_cnt += fprintf(spkfp,"(");
		opr_lvl = NO_priority;
		}
	sflwt_opr_expression(spkfp,opr_lvl,ep->op1);
	putc_cnt += fprintf(spkfp," %s ", expr_opr_name(ep->opr));
	sflwt_opr_expression(spkfp,opr_lvl,ep->op2);
	if (paren) putc_cnt += fprintf(spkfp,")");
	}


ENTRY void sflwt_opr_expression(FILE* spkfp, int lvl,expr* ep) {
	int opr_lvl;
	footmark("sflwt_opr_expression");
	if (ep == 0) return;
	speak_ind(spkfp,now_indlvl);
	if (sflspec_no == 1) {
		/* rekXybNPł̏oɂāA */
		opr_lvl = sflwt_s1_opr_expression(0, 0, 0, ep);
		if (opr_lvl != 0) {
			/* rekXybNPł̓ʂȏo@Kvł */
			sflwt_s1_opr_expression(spkfp, lvl < opr_lvl, opr_lvl, ep);
			return;
			}
		}
	opr_lvl = expr_opr_priority(sflspec_no,ep->opr);
	if (opr_lvl != 0) {
		/* ʏ̂QZLq`ŏ\ł */
		sflwt_bi_expression(spkfp, lvl < opr_lvl, opr_lvl,ep);
		return;
		}
	sflwt_mono_expression(spkfp,lvl,ep);
	}


/* ========================================================================= */
/* =====   P                                                    ===== */
/* ========================================================================= */


/*
|P ::=
|	  ^  P	// ے 
|	| /| P	//  or 
|	| /@ P	//  eor 
|	| /& P	//  and 
|	| /  P	// fR[h 
|	| \  P	// GR[h 
|	| ʂ̌ #P	// g 
|	| vf '<ŏʌʒu[:ŉʌʒu]'>	// rbg؂o 
|	| vf
*/


	static void sflwt_exp_element(FILE*,expr*);


/*
̊֐́ÂQʂɎgpB
(1) spkfp == 0 ̏ꍇ
@@w̉Z邽߂Ɂi\́jgݍ݊֐gpKv鉉Z
@@ǂ肷B
@@gݍ݊֐Kvȏꍇɂ́Å֐̉ZxԒlƂȂB
(2) spkfp != 0 ̏ꍇ
@@w̉Z邽߂ɁAgݍ݊֐gprek\[XfB
F
@PԖڂ̒ƂQԖڂ̃\[X̘_ɖȂ悤ɁA֐
@Qʂ̎gĂB
*/


/* %%% */

static int sflwt_mo_expression(FILE* spkfp, int paren, int opr_lvl, expr* ep) {
	opr_inst* insp;
	long* vp;
	char* data;
	int opr;
	footmark("sflwt_mo_expression");
	if (ep == 0) return 0;
	if (paren) {
		putc_cnt += fprintf(spkfp,"(");
		opr_lvl = NO_priority;
		}
	switch(opr = ep->opr) {
	case OPR_invert:
	case OPR_bit_or:
	case OPR_bit_xor:
	case OPR_bit_and:
	case OPR_decode:
	case OPR_encode:
		if (spkfp == 0) return mono_opr_priority(sflspec_no,opr);
		putc_cnt += fprintf(spkfp,"%s",mono_opr_name(opr));
		sflwt_opr_expression(spkfp,opr_lvl,ep->op1);
		break;
	case OPR_expand:
		if (spkfp == 0) return mono_opr_priority(sflspec_no,opr);
		putc_cnt += fprintf(spkfp,"%lu%s",*(long*)(ep->op2),mono_opr_name(opr));
		sflwt_opr_expression(spkfp,opr_lvl,ep->op1);
		break;
	case OPR_0expand:	/* %%% */
		if (spkfp == 0) return mono_opr_priority(sflspec_no,opr);
		sflwt_opr_expression(spkfp,opr_lvl,ep->op1);
		break;
	case OPR_partial:
		if (spkfp == 0) return mono_opr_priority(sflspec_no,opr);
		sflwt_opr_expression(spkfp,opr_lvl,ep->op1);
		vp = (long*)(ep->op2);
		putc_cnt += fprintf(spkfp,"<%lu",vp[0]);
		if (vp[0] != vp[1]) putc_cnt += fprintf(spkfp,":%lu",vp[1]);
		putc_cnt += fprintf(spkfp,">");
		break;
	case OPR_lognot:
		opr_lvl = MOp_lognot;
		if (sflspec_no == 1) {
			if (spkfp == 0) return mono_opr_priority(sflspec_no,OPR_invert);
			putc_cnt += fprintf(spkfp,"%s%s",mono_opr_name(OPR_invert),mono_opr_name(OPR_bit_or));
			opr_lvl = mono_opr_priority(sflspec_no,OPR_bit_or);
			sflwt_opr_expression(spkfp,opr_lvl,ep->op1);
			break;
			}
		if (spkfp == 0) return mono_opr_priority(sflspec_no,opr);
		putc_cnt += fprintf(spkfp,"%s",mono_opr_name(opr));
		sflwt_opr_expression(spkfp,opr_lvl,ep->op1);
		break;
	case OPR_incre:
		data = "0b1";
		goto incdec;
	case OPR_decre:
		data = "0b0";
	incdec:
		if (sflspec_no == 1) {
			if (circuit_type == 0) {
				if (spkfp == 0) return ELp_dot;
				insp = opr_inst_lookup(ep,0);
				if (insp == 0) break;
				putc_cnt += fprintf(spkfp,"%s.do(",insp->sym->name);
				sflwt_exp_element(spkfp,ep->op1);
				putc_cnt += fprintf(spkfp,",%s).out",data);
				}
			else {
				if (spkfp == 0) return mono_opr_priority(sflspec_no,OPR_plus);
				switch(ep->opr) {
				case OPR_incre:
					putc_cnt += fprintf(spkfp,"(");
					sflwt_exp_element(spkfp,ep->op1);
					putc_cnt += fprintf(spkfp,")+0b1");
					break;
				case OPR_decre:
					putc_cnt += fprintf(spkfp,"(");
					sflwt_exp_element(spkfp,ep->op1);
					putc_cnt += fprintf(spkfp,")+%d%s0b1",ep->fig,opr_name(OPR_expand));
					break;
					}
				}

			break;
			}
		if (spkfp == 0) return mono_opr_priority(sflspec_no,opr);
		sflwt_exp_element(spkfp,ep->op1);
		putc_cnt += fprintf(spkfp,"%s",mono_opr_name(opr));
		break;
		}
	if (paren) putc_cnt += fprintf(spkfp,")");
	return 0;
	}


static void sflwt_mono_expression(FILE* spkfp,int lvl,expr* ep) {
	int opr_lvl;
	footmark("sflwt_mono_expression");
	if (ep == 0) return;
	opr_lvl = sflwt_mo_expression(0, 0, 0, ep);
	if (opr_lvl != 0) {
		/* ʏ̒PZł */
		sflwt_mo_expression(spkfp, lvl < opr_lvl, opr_lvl, ep);
		return;
		}
	sflwt_exp_element(spkfp,ep);
	}



/* ========================================================================= */
/* =====   vf                                                      ===== */
/* ========================================================================= */


/*
|vf ::=
|	  ()
|	| 萔
|	| WX^
|	|  '[AhX ']
|	| Xe[W.^XN
|	| f[^[q
|	| [q
|	| f[^͒[q
|	| f[^o͒[q
|	| f[^o[q
|	| ͒[q
|	| o͒[q
|	| TuW[.f[^͒[q
|	| TuW[.f[^o͒[q
|	| TuW[.f[^o[q
|	| TuW[.͒[q
|	| TuW[.o͒[q
|	| TuW[.͒[q([{,}]).f[^o͒[q
|	| TuW[.͒[q([{,}]).f[^o[q
|	| [q([{,}]).f[^[q
|	| o͒[q([{,}]).f[^͒[q
|	| o͒[q([{,}]).f[^o[q
|
|AhX ::= 
*/


static void sflwt_exp_element(FILE* spkfp, expr* ep) {
	expr* ap;
	int opr;
	if (ep == 0) return;
	footmark("sflwt_exp_element");
	/* vf ::= */
	switch(opr = ep->opr) {
	case OPR_bracket:				/* (  ) */
		if (ep->op1->opr == OPR_bracket) {
			sflwt_opr_expression(spkfp,NO_priority,ep->op1);
			}
		else {
			putc_cnt += fprintf(spkfp,"(");
			sflwt_opr_expression(spkfp,NO_priority,ep->op1);
			putc_cnt += fprintf(spkfp,")");
			}
		break;
	case OPR_sfln:			/* 萔 */
		/* original string : putc_cnt += fprintf(spkfp,"%s",ep->op2); */
		putc_cnt += fprintf(spkfp,"%s",sflntok2str((token*)(ep->op1)));
		break;
	case OPR_value:			/* WX^ */
							/* Xe[W.^XN */
							/* f[^[q */
							/* f[^͒[q */
							/* f[^o͒[q */
							/* f[^o[q */
							/* ͒[q */
							/* [q */
							/* o͒[q */
							/* TuW[.f[^͒[q */
							/* TuW[.f[^o͒[q */
							/* TuW[.f[^o[q */
							/* TuW[.͒[q.([{,}]).f[^o͒[q */
							/* TuW[.͒[q.([{,}]).f[^o[q */
							/* TuW[.͒[q */
							/* TuW[.o͒[q */
		sflwt_token_element(spkfp, ep);
		break;
	case OPR_mem_rd:			/*  '[AhX '] */
		putc_cnt += fprintf(spkfp,"%s[",token_sname((token*)(ep->op1)));
		sflwt_opr_expression(spkfp,NO_priority,ep->op2);
		putc_cnt += fprintf(spkfp,"]");
		break;
	default:
		indent_clear();
		fprintf(serr_efp,"\nopr = %s : ",opr_name(opr));
		fprintf(serr_efp,"code = %02x",opr);
		if (opr >= ' '  && opr < 0x7f)	fprintf(serr_efp,"(%c)",opr);
		fprintf(serr_efp,"\n");
		sys_error("Unknown operation : sflwt_exp_element()");
		}
	}


static void sflwt_token_element(FILE* spkfp, expr* ep) {
	token* ptp;
	token* tp;
	expr* ap;
	uni_link* lp;
	char delm;
	int i;

	tp = (token*)(ep->op1);
	ap = ep->op2;

	ptp = tp->parent;
	if (ptp != 0) {
		switch(ptp->id) {
		case DEF_submod:
		case DEF_stage_name:
			putc_cnt += fprintf(spkfp,"%s.",token_name(ptp));
			}
		}

	if (ap != 0 && vector_ix < 1) {
		/* [q([{,}]). */
		switch(ap->opr) {
		case OPR_active:
			putc_cnt += fprintf(spkfp,"%s(",token_sname((token*)(ap->op1)));
			argument_val(spkfp,ap->op2);
			putc_cnt += fprintf(spkfp,").");
			}
		}
	if (token_id(tp) == DEF_vector) {
		if (vector_ix < 1) {
			/* xNg`ŁAxɕ\ */
			delm = '(';
			for (lp = tp->arg ; lp != 0 ; lp = lp->np) {
				putc_cnt += fprintf(spkfp,"%c%s",delm,token_sname(lp->ap));
				delm = ',';
				}
			putc_cnt += fprintf(spkfp,")");
			}
		else {
			/* eɕ\ */
			for (i = 1,lp = tp->arg ; lp != 0 ; ++i,lp = lp->np) {
				if (i == vector_ix) {
					putc_cnt += fprintf(spkfp,"%s",token_sname(lp->ap));
					break;
					}
				}
			}
		}
	else {
		/* ʏ̍\ */
		putc_cnt += fprintf(spkfp,"%s",token_sname(tp));
		}
	}




/*****************************************************************************/
/* ========================================================================= */
/* =====   fobOp\֐                                          ===== */
/* ========================================================================= */
/*****************************************************************************/


/* ========================================================================= */
/* =====   rekvs̏e[u                                  ===== */
/* ========================================================================= */


setup_parm sflwt_ini[] = {
	sup_int(beauty_pos),
	sup_int(dsp_cond_no),
	sup_int(newl_pos),
	sup_str(sflrd_with_ext),
	{0,0,0,0},
	};


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */

