/*
 *  notice: japanese
 *@쌠҂̍mF
 *@@uf[^TCgJvOgp@QŁv
 *@@ɋLڂ́uvOvƓɎ舵ĒƂɁA
 *@@{hLg̉{EpEۊǂF߂܂B
 */

/*
 * ps_strct.h
 *
 * sfl data structure control functions.
 * Version 1.06 Beta   Date 1999.02.08
 * Copyright (c) Datasight Corp., 1996-1999.
 * All Rights Reserved.
 * Made by A.Nakashima
 *
 */


#if !defined(PS_STRCT_H)
#define PS_STRCT_H

#include "ps_val.h"

#if defined(EXTRA)
#	define Ex_strct
#	include "extra.h"
#	endif


#if defined(ENTRY)
#	undef ENTRY
#	endif
#define ENTRY extern


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


#if !defined(Ex_strct_component)
#	define Ex_strct_component 
#	endif


#define DBG_GETTOK(s)


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


typedef struct s_bi_link {
	void* ap;
	struct s_bi_link* bp;
	struct s_bi_link* np;
	} bi_link;


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


typedef struct s_expr {
	int            opr;
	int            fig;
	struct s_expr* op1;
	struct s_expr* op2;
	struct s_expr* beh;
	} expr;


expr* new_expr(alloc_ctl* acp,int opr,int fig,expr* op1,expr* op2,expr* beh);


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


typedef struct s_component {
	int        count;
	uni_link*  top;
	uni_link** endp;
	hashtbl*   comphash;
	struct s_token* first;
	expr*      behavior;
	Ex_strct_component
	} component;


component* new_component(alloc_ctl* acp);


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


typedef struct s_token {
	int             id;
	unsigned int    figure;
	unsigned long   value;
	symbol*         toksym;
	symbol*         tokren;
	struct s_token* parent;
	struct s_token* twin;
	struct s_token* prototype;
	component*      comp_tbl;
	fileloc        loc;			/* ݂̂kdwʒu */
	word**          wpp;
	uni_link*       arg;
	uni_link*       translate;
	uni_link*       reference;
	void**          ipp;
	alloc_ctl*      acp;
	DBG_GETTOK(int dmark;)
	} token;


token* new_token(alloc_ctl* acp, int typ, token* tp);

#define token_id(tp) (((token*)(tp))->id)


/* === token member ̗pꗗ === */

/* ps_sflrd.c: tp->comp_tbl->first = token-envp */

/* kdwg[Nɂ */
#define with_lead_delim(tp)  tp->ipp = (void**)&(tp)
#define is_lead_delim(tp)   (tp->ipp != 0)


/* W[Eg[Nɂ */
enum {
	TOKi_cond_node,
	TOKi_nld_class,
	TOKi_nld_inst,
	TOKi_sfl_class,
	TOKi_sfl_inst,
	TOKi_end
	};


/* instrinɂ */
#define set_arg_ovrwt(itp) (itp)->wpp = (word**)(itp)
#define get_arg_ovrwt(itp) (itp->wpp != 0)


/* module/circuit/daclare template ɂ */
#define set_tpl_data(mtp,rp) (mtp)->twin = (token*)(rp)
#define get_tpl_data(mtp) (bag_arr*)((mtp)->twin)


/* W[^TuW[Eg[Nɂ */
#define set_mod_max_fig(mtp,fig) (mtp)->wpp = (word**)(fig)
#define get_mod_max_fig(mtp) ((unsigned int)((mtp)->wpp))


/* TuW[Eg[Nɂ */
#define submod_no(tp) (tp)->figure


/* Eg[Nɂ */
#define set_mem_adr_tokp(mtp,atp,afig) \
	(mtp)->wpp = (word**)(atp),/* AhXTCYSFLN */\
	(mtp)->arg = (uni_link*)(afig)	/* AhX̃rbg */
#define get_mem_adr_tokp(mtp) (token*)(mtp->wpp) /* AhXTCYSFLN */
#define get_mem_adr_bits(mtp) (unsigned int)((mtp)->arg) /* AhX̃rbg */


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


typedef struct {
	int   opr;
	int   top;
	int   pno;
	int   len;
	void* inp;
	void* own;
	expr* cep;
	} cond_node;


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


typedef struct {
	symbol* sym;
	size_t  tblent;
	size_t  tblsiz;
	void**  tblpp;
	} classtbl;


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


typedef struct {
	symbol* sym;
	expr*   ep;
	char*   ctype;
	int     figure;
	int     width;
	} opr_inst;


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */



typedef struct {
	long         pos;
	symcate*     file;
	unsigned int line;
	lex*         cmd_lexp;
	token*       define_tp;
	unsigned int max_figure;
	alloc_ctl*   sflacp;
	int          cond_cnt;
	hashtbl*     machash;		/* `e[u */
	bag_arr*     bagp;			/* `ĂP̓o^e[u */
	} mod_def_env;


#define get_token_env(tp) (mod_def_env*)((tp)->comp_tbl->first)


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


#undef  ENTRY
#define ENTRY 



#endif PS_STRCT_H

