/*
 *  notice: japanese
 *@쌠҂̍mF
 *@@uf[^TCgJvOgp@QŁv
 *@@ɋLڂ́uvOvƓɎ舵ĒƂɁA
 *@@{hLg̉{EpEۊǂF߂܂B
 */

/*
 * ps_beh.c
 *
 * sflread command execution. (behavior describe functions.)
 * Version 1.10 Beta   Date 1999.5.8
 * Copyright (c) Datasight Corp., 1996-1999.
 * All Rights Reserved.
 * Made by A.Nakashima
 *
 */


#define foot_on 0
#include "ps_selec.h"
#include "ps_misc.h"
#include "ps_lex.h"
#include "ps_strct.h"
#include "ps_tdef.h"
#include "ps_proto.h"


#if defined(EXTRA)
#	define Ex_beh
#	include "extra.h"
#	endif


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


#if !defined(Ex_beh_resize_sfln)
#	define Ex_beh_resize_sfln(fig,a_fig,ap) 
#	define Ex_data_translate_beh(tp) 
#	define Ex_vector_translate_beh(tp) 
#	define Ex_instruct_active(tp) 
#	define Ex_beh_simple_op2_expr(m_fig,e_fig,r_fig,ep) 
#	define Ex_beh_simple_catinate(m_fig,e_fig,ep) 
#	define Ex_beh_is_const_opr 
#	define Ex_beh_simple_mono_expr 
#endif


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


hashtbl* inst_hashtbl;


static unsigned int opr_inst_hcode(void* q) {
	return (unsigned int)(((opr_inst*)q)->ep) << 2;
	}


ENTRY opr_inst* opr_inst_lookup(expr* ep,opr_inst* instp) {
	hashtbl* hp = inst_hashtbl;
	unsigned int hashcode;			/* hashcode index */
	unsigned int i,ix;
	SYMBOL_PA(++(hp->lup_cnt));
	hashcode = (unsigned int)ep << 2;
retry:
	ix = hashcode;
	for (i = 0 ; i < hp->tblsiz ; ++i,++ix) {	/* 1'st time : hp->tblsiz == 0 */
		opr_inst* p;
		SYMBOL_PA(++(hp->try_cnt));
		ix %= hp->tblsiz;
		p = hp->tblpp[ix];
		if (p == 0) {
			if (instp == 0) return 0;
			++(hp->tblent);
			hp->tblpp[ix] = instp;
			return hp->tblpp[ix];
			}
		if (p->ep == ep) return p;
		if (i > 10 && hp->tblent > hp->tblsiz/2) break;
		}
	expand_hash_tbl(hp,100,opr_inst_hcode);
	goto retry;
	}



/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


extern hashtbl* class_hashtbl;


static void set_opr_inst(tMYc expr* ep,int m_fig,int e_fig) {
	lex* lexp = my->sfllexp;
	char* cname = get_looped_buf(0);
	classtbl* classp;
	char* ctype;
	int   figure;
	int   width;
	char  program_type;
	symbol* sym;
	opr_inst* target;
	component* cp;
	uni_link*  lp;
	token  tok;
	int set_flg;
	int j;
	switch(ep->opr) {
	case OPR_incre:  ctype = "inc"; figure = m_fig; width = 1; break;
	case OPR_decre:  ctype = "dec"; figure = m_fig; width = 1; break;
	case OPR_plus:   ctype = "add"; figure = m_fig; width = 2; break;
	case OPR_minus:  ctype = "add"; figure = m_fig; width = 2; break;
	case OPR_multi:  ctype = "mul"; figure = m_fig; width = e_fig; break;
	case OPR_divide: ctype = "div"; figure = m_fig; width = e_fig; break;
	case OPR_residue:ctype = "div"; figure = m_fig; width = e_fig; break;
	case OPR_cmp_gt: ctype = "cgt"; figure = m_fig; width = 2; break;
	case OPR_cmp_ge: ctype = "cge"; figure = m_fig; width = 2; break;
	case OPR_cmp_lt: ctype = "clt"; figure = m_fig; width = 2; break;
	case OPR_cmp_le: ctype = "cle"; figure = m_fig; width = 2; break;
	default:
		return;
		}
	program_type = module_prefix;
	if (my->module_tp->id == DEF_circuit) {
		switch(ep->opr) {
		case OPR_incre:
		case OPR_decre:
		case OPR_plus:
		case OPR_minus:
			return;
		case OPR_multi:
			program_type = circuit_prefix;
			ctype = "cml";
			break;
		case OPR_divide:
			program_type = circuit_prefix;
			ctype = "cdv";
			break;
		case OPR_residue:
			program_type = circuit_prefix;
			ctype = "cdv";
			break;
			}
		}
	sym = symbol_lookup(lexp,
		get_class_name(ctype,ep->opr,figure,width,&program_type));
	classp = classtbl_lookup(class_hashtbl,sym);
	target = new_alloc(lexp->acp,sizeof(opr_inst));
	classp->tblpp[classp->tblent++] = target;
	cp = my->module_tp->comp_tbl;
	/* W[Ńj[NȃCX^X߂ */
	for (j = inst_hashtbl->tblent+1 ; ; ++j) {
		sprintf(cname,"%s_%d",ctype,j);
		sym = symbol_lookup(lexp,cname);
		/* \ꂩǂf */
		if (sym2val_lookup(my->rsv_hp,sym,0,0) != 0) continue;	/* \ */
		/* ̃R|[lgƃobeBOĂ邩ǂf */
		if (cp == 0) goto next;
		for (lp = cp->top ; lp != 0 ; lp = lp->np) {
			token* ktp = lp->ap;
			if (ktp->tokren == sym) goto chk;
			}
		break;
	chk:;
		}
next:
	/* ̃W[ŁAOdȂȂ悤ɓo^ */
	memset(&tok,0,sizeof(token));
	tok.id = DEF_autosub;
	tok.toksym = sym;
	tok.tokren = sym;
	tok.figure = figure;
	set_flg = 1;
	token_lookup(my->module_tp, &tok, &set_flg);

	target->sym   = sym;
	target->ctype = ctype;
	target->ep    = ep;
	target->figure= figure;
	target->width = width;
	opr_inst_lookup(ep,target);
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


static cond_node* condition_regist(tMYc int opr,int top,int pno) {
	alloc_ctl* acp = my->sfllexp->sflacp;
	cond_node* p = new_alloc(acp,sizeof(cond_node));
	p->opr = opr;
	p->top = top;
	p->pno = pno;
	append_bag_que(my->c_condp,p);
	return p;
	}


ENTRY void add_expr_ulink(alloc_ctl* acp,uni_link** lpp, expr* ep) {
	*lpp = new_uni_link(acp,ep,*lpp);
	}


static void append_expr_ulink(alloc_ctl* acp,uni_link** lpp, expr* ep) {
	for ( ; *lpp != 0 ; lpp = &((*lpp)->np));
	*lpp = new_uni_link(acp,ep,0);
	}


/*****************************************************************************/
/* ========================================================================= */
/* =====                                                         ===== */
/* ========================================================================= */
/*****************************************************************************/


extern word_dict* behavior_opr_dict[]  ;
extern word_dict* expression_opr_dict[];
extern word_dict* mono_expr_opr_dict[] ;
extern word_dict* element_opr_dict[]   ;
extern word_dict* number_opr_dict;


#define describe_behavior describe_rd_behavior


	static int describe_do_behavior(tMYc token* owner_tp);


ENTRY int describe_behavior(tMYc token* owner_tp) {
	lex* lexp = my->sfllexp;
	int code;
	word_dict* save_tblp = lexp->opr_tblp;
	jmp_buf* save_jbp    = my->jmpbfp;
	jmp_buf jbuf;
	int rtc;
	my->behacp = owner_tp->acp;
	my->jmpbfp = &jbuf;
	rtc = setjmp(jbuf);
	if (rtc == 0) {
		/* ւ */
		lexp->opr_tblp = behavior_opr_dict[lexp->sflspec - 1];
		code = describe_do_behavior(MYc owner_tp);
		}
	lexp->opr_tblp = save_tblp;
	my->jmpbfp = save_jbp;
	if(rtc != 0) {
		/* ُI */
		longjmp(*(my->jmpbfp),rtc);
		}
	return code;
	}


/*
| ::=
|	  parubN
|	| altubN
|	| anyubN
|	| ifubN
|	| Pʓ
|
|parubN ::= par'{{}'}
|altubN ::= alt'{t{t}[else]'}
|anyubN ::= any'{t{t}[else]'}
|ifubN ::= if()
|t ::= :
|else ::= else:
| ::= 
*/


/* ====================================================================


expr ̃N\

g[N灃쁄ւ̃N

    token.behavoir -> expr = 쁄
    ^                     .opr = OPR_behavior 
    |                     .op1 -> expr = ۂ́쁄`
    |                     .op2 -> fileloc.file ̒`ꂽꏊ
    *-------------------- .beh           .line 


`


쁄

expr = 쁄
^   .beh = L҂ւ̃|C^
|   .opr = OPR_behavior 
|   .op2 -> fileloci̒`ꂽꏊ߁j
|   .op1 -> expr.opr = OPR_par  par P
|<------------- .beh
|           ^   .op1 -> expr = P쁄
|           *--------------------------
|               .op2 -> expr.opr = OPR_par
|<------------------------- .beh
|                       ^   .op1 -> expr = Q쁄
|                       *--------------------------
|                           .op2 -> expr.opr = OPR_par
|<------------------------------------- .beh
                                    ^   .op1 -> expr = R쁄
                                    *--------------------------
                                        .op2 -> 0 I


C쁄

expr = 쁄
^   .beh = L҂ւ̃|C^
|   .opr = OPR_behavior 
|   .op2 -> fileloci`ꂽꏊj
|   .op1 -> expr.opr = OPR_alt,OPR_any	( alt/any P )
|<--------------.beh
|           ^   .op1 -> expr.opr = OPR_if_cond P
|           |           ^   .op1 -> expr = 
|           |           *------------------- .beh
|           |           ^   .op2 -> expr = >
|           |           *------------------- .beh
|           |               .beh -> expr.opr = condition ID 
|           |                           .op1 -> 0
|           |                           .op2 -> fileloci`ꂽꏊj
|           *---------------------------.beh
|
|               .op2 -> expr.opr = OPR_alt,OPR_any
|<------------------------- .beh
|                       ^   .op1 -> expr.opr = OPR_if_cond Q
|                       |           ^   .op1 -> expr = 
|                       |           *------------------- .beh
|                       |           ^   .op2 -> expr = >
|                       |           *------------------- .beh
|                       |               .beh -> expr.opr = condition ID 
|                       |                           .op1 -> 0
|                       |                           .op2 -> fileloci`ꂽꏊj
|                       *---------------------------.beh
|
|                           .op2 -> expr.opr = OPR_alt,OPR_any
|<------------------------------------- .beh
                                    ^   .op1 -> expr.opr = OPR_if_cond R
                                    |           ^   .op1 = 0   
                                    |           *------------------- .beh
                                    |           ^   .op2 -> expr = >
                                    |           *------------------- .beh
                                    |               .beh -> expr.opr = condition ID 
                                    |                           .op1 -> 0
                                    |                           .op2 -> fileloci`ꂽꏊj
                                    *---------------------------.beh
                                        .op2 -> 0 I


쁄

expr = 쁄
^   .beh = L҂ւ̃|C^
|   .opr = OPR_behavior 
|   .op2 -> fileloci`ꂽꏊ߁j
|   .op1 -> expr.opr = OPR_if
|           ^   .op1 -> expr = 
|           *------------------- .beh
|           ^   .op2 -> expr = >
|           *------------------- .beh
|               .beh -> expr.opr = condition ID 
|                           .op1 -> 0
|                           .op2 -> fileloci`ꂽꏊj
*---------------------------.beh


Pʓ쁄

expr = 쁄
^   .beh = L҂ւ̃|C^
|   .opr = OPR_behavior 
|   .op2 -> fileloci̒`ꂽꏊ߁j
|   .op1 -> ۂ́Pʓ expr.    
*------------------------------- .beh   


==================================================================== */


	static expr* describe_exp_behavior(tMYc expr* beh);


static int describe_do_behavior(tMYc token* owner_tp) {
	alloc_ctl* acp = my->behacp;
	lex* lexp = my->sfllexp;
	component* cp;
	expr* ep;
	expr* oep;
	expr* bep;
	int c_cnt;
	footmark("describe_do_behavior");
	ep = describe_exp_behavior(MYc (expr*)owner_tp);
	if (ep == 0) return 0;
	cp = component_table(owner_tp);
	if ((oep = cp->behavior) != 0) {
		/* ɉ̓삪`Ă */
		switch(token_id(owner_tp)) {
		case DEF_module       :
		case DEF_circuit      :
		case DEF_stage_name   :
		case DEF_segment_name :
		case DEF_state_name   :
/* %%% */
		case DEF_instrin      :
		case DEF_instrout     :
		case DEF_instrself    :
			/* ɂẮAʓ̕`F߂ */
			break;
		default:
			sprintf(lexp_errbuf(lexp),"re-definition behavior at %s",expr_location(oep));

			tok_error(lexp,owner_tp);
			}
		if (oep->fig == 0) {
			/* ܂AP̓삪o^Ă邾ł邩A悸parň͂ */
			bep = new_expr(acp,OPR_behavior,1,0,oep->op2,oep->beh);
			bep->op1 = new_expr(acp,OPR_par,0,oep,0,oep->beh);	/* par P */
			cp->behavior = oep = bep;
			}
		c_cnt = 0;
		/* par`̍ŌT */
		for (bep = oep->op1 ; bep->op2 != 0 ; bep = bep->op2) ++c_cnt;
		/* par`̍Ōɓo^ */
		bep->op2 = new_expr(acp,OPR_par,c_cnt,ep,0,ep->beh);	/* par P */
		oep->fig = c_cnt + 1;	/* parŊ */
		ep = oep;
		}
	cp->behavior = ep;
	return 1;
	}


	static expr* define_exp_behavior(tMYc expr* beh);
	static expr* describe_mono_behavior(tMYc expr* owner);
	static unsigned int define_opr_expression(tMYc int lvl,expr** ep, expr* beh);


ENTRY expr* step_back_behavior(expr* ep) {
	/* Pɑk */
	switch(ep->opr) {
	case OPR_if_cond:
	case OPR_if:
		/* ̏ꍇbehP̂ŁA]ɑk */
		ep = ep->beh;
		}
	return ep->beh;
	}


static expr* behavior_location(tMYc token* lxp, expr* owner) {
	alloc_ctl* acp = my->behacp;
/* %%%
	lex* lexp = my->sfllexp;
*/
	expr* ep = (expr*)new_fileloc(acp,&(lxp->loc));
	/* !!!opr_arg(OPR_behavior,E_expr,E_filoc) */
	return new_expr(acp,OPR_behavior,0,0,ep,owner);
	}


static expr* condition_location(
	tMYc
	token* lxp,
	expr* owner,
	cond_node** condpp,
	int opr,
	int top,
	int pno
) {
	expr* ep;
	*condpp = condition_regist(MYc opr,top,pno);
	ep = behavior_location(MYc lxp,owner);
	ep->opr = my->cond_cnt++;
	return ep;
	}


static expr* describe_exp_behavior(tMYc expr* owner) {
	static char* Err_cond = "bit width";
	alloc_ctl* acp = my->behacp;
	lex*   lexp = my->sfllexp;
	token* lxp  = new_entity(my->tokecp);
	int opr;
	int c_top;
	int c_cnt;
	token* tp;
	expr* rep;
	expr* cep;
	expr* ep;
	expr* e1p;
	expr* beh;
	expr* tagp;
	cond_node* condp;
	footmark("describe_exp_behavior");
	tp = get_token(MYc my->sflkey_tp,lxp);
	switch(token_id(tp)) {
	case KEY_par:
		beh = behavior_location(MYc lxp,owner);
		sfl_assert(lexp,'{');
		c_cnt = 0;
		/* !!!opr_arg(OPR_par,E_expr,E_expr) */
		tagp = rep = new_expr(acp,OPR_par,c_cnt,0,0,beh);	/* par P */
		for (ep = rep ; ; ep = ep->op2) {
			e1p = describe_exp_behavior(MYc tagp);
			if (e1p == 0) {
				/* S̋󕶁ipar {}jǂf */
				if (c_cnt == 0) {
					/* S̋󕶁ipar {}j */
/* %%%
					e1p = new_expr(acp,OPR_void,0,0,0,tagp);
*/
					e1p = behavior_location(MYc lxp,tagp);
					e1p->op1 = new_expr(acp,OPR_void,0,0,0,beh);
					}
				else {
					sprintf(lexp_errbuf(lexp),"unknown behavior");
					lex_error(lexp,ERR_user);
					}
				}
			ep->op1 = e1p;
			tp = get_token(MYc 0,lxp);
			if (token_id(tp) == '}') break;
			unget_token(lexp,lxp);
			tagp = ep->op2 = new_expr(acp,OPR_par,++c_cnt,0,0,beh);
			}
		break;
	case KEY_alt:
		opr = OPR_alt;
		goto any;
	case KEY_any:
		opr = OPR_any;
	any:
		beh = behavior_location(MYc lxp,owner);
		sfl_assert(lexp,'{');
		c_cnt = 0;
		/* !!!opr_arg(OPR_alt,E_expr,E_expr) */
		/* !!!opr_arg(OPR_any,E_expr,E_expr) */
		tagp = rep = new_expr(acp,opr,c_cnt,0,0,beh);	/* alt/any P */
		c_top = my->cond_cnt;
		for (ep = rep ; ; ep = ep->op2) {
			/*
			|t ::= :
			|else ::= else:
			*/
			tp = get_token(MYc my->sflkey_tp,lxp);
			cep = condition_location(MYc lxp,tagp,&condp,opr,c_top,c_cnt++);
			/* !!!opr_arg(OPR_if_cond,E_expr,E_expr) */
			cep = new_expr(acp,OPR_if_cond,1,0,0,cep);
			if (token_id(tp) != KEY_else) {
				unget_token(lexp,lxp);
				if (define_opr_expression(MYc NO_priority,&(cep->op1),cep) != 1) {
					if (sflspec_no == 1) {
						sprintf(lexp_errbuf(lexp),Err_cond);
						tok_error(lexp,lxp);
						}
					}
				}
			else {
				if (ep == rep) {
					sprintf(lexp_errbuf(lexp),"unexpected 'else'");
					tok_error(lexp,lxp);
					}
				}
			condp->cep = cep->op1;
			sfl_assert(lexp,':');
			cep->op2 = define_exp_behavior(MYc cep);
			ep->op1 = cep;
			tp = get_token(MYc 0,lxp);
			if (token_id(tp) == '}') break;
			if (cep->op1 == 0) {	/* else: */
				sprintf(lexp_errbuf(lexp),"'}' expected");
				tok_error(lexp,lxp);
				}
			unget_token(lexp,lxp);
			tagp = ep->op2 = new_expr(acp,opr,c_cnt,0,0,beh);
			}
		condp = ((cond_node**)(my->c_condp->ap))[c_top];
		condp->len = c_cnt;
		if (cep->op1 == 0) {	/* else: */
			switch(opr) {
			case OPR_alt:	condp->opr = OPR_alt_e; break;
			case OPR_any:	condp->opr = OPR_any_e; break;
				}
			}
		break;
	case KEY_if:
		beh = behavior_location(MYc lxp,owner);
		sfl_assert(lexp,'(');
		get_token(MYc my->sflkey_tp,lxp);
		cep = condition_location(MYc lxp,beh,&condp,OPR_if,my->cond_cnt,0);
		condp->len = 1;
		/* !!!opr_arg(OPR_if,E_expr,E_expr) */
		rep = new_expr(acp,OPR_if,1,0,0,cep);
		unget_token(lexp,lxp);
		if (define_opr_expression(MYc NO_priority,&(rep->op1),rep) != 1) {
			if (sflspec_no == 1) {
				sprintf(lexp_errbuf(lexp),Err_cond);
				tok_error(lexp,lxp);
				}
			}
		sfl_assert(lexp,')');
		condp->cep = rep->op1;
		rep->op2 = define_exp_behavior(MYc rep);
		break;
	default:
		unget_token(lexp,lxp);
		beh = describe_mono_behavior(MYc owner);
		goto ret;
		}
	beh->op1 = rep;
ret:
	del_entity(my->tokecp,lxp);
	return beh;
	}


static expr* define_exp_behavior(tMYc expr* beh) {
	lex* lexp = my->sfllexp;
	expr* ep;
	footmark("define_exp_behavior");
	ep = describe_exp_behavior(MYc beh);
	if (ep == 0) {
		token* lxp = new_entity(my->tokecp);
		get_token(MYc 0,lxp);
		sprintf(lexp_errbuf(lexp),"'behavior' expected");
		tok_error(lexp,lxp);
		del_entity(my->tokecp,lxp);
		}
	return ep;
	}


/*****************************************************************************/
/* ========================================================================= */
/* =====   Pʓ                                                  ===== */
/* ========================================================================= */
/*****************************************************************************/


/*
|Pʓ ::=
|	  [qւ̒l̏o
|	| WX^ւ̏
|	| ւ̏
|	| ԑJ
|	| ZOgĂяo
|	| ߂Ԃw肵ȂZOgĂяo
|	| ZOg̕A
|	| Wu̐
|	| Wu̓]
|	| WȕI
|	| [q̋N
|	| 
|   |
|   | [qxNgւ̒lxNg̏o

|[qւ̒l̏o ::=
|	  f[^[q=;
|	| f[^o͒[q=;
|	| f[^o[q=;
|	| TuW[.f[^͒[q=;
|	| TuW[.f[^o[q=;
|WX^ւ̏ ::= WX^:=;
|ւ̏ ::=  '[ ']:=;
|ԑJ ::= goto Ԗ;
|ZOgĂяo ::= call ZOg(߂Ԗ);
|߂Ԃw肵ȂZOgĂяo ::= call ZOg();
|ZOg̕A ::= return;
|Wu̐ ::= generate Xe[W{.^XN}([{,}]);
|Wu̓] ::= relay Xe[W{.^XN}([{,}]);
|WȕI ::= finish;
|[q̋N ::=
|	  o͒[q([{,}]);
|	| [q([{,}]);
|	| TuW[.͒[q([{,}]);
| ::= ;
|߂Ԗ ::= Ԗ
| ::= 
*/


	static char* Err_figure = "figure mismatch";


static expr* data_translate_beh(tMYc int opr, token* tp, expr* beh) {
	alloc_ctl* acp = my->behacp;
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	expr* ep;
	unsigned int fig;
	get_token(MYc my->sflkey_tp,lxp);		/* G[\̂߈ꎞL */
	unget_token(lexp,lxp);
	fig = define_opr_expression(MYc NO_priority,&ep,beh);
	if (fig != tp->figure) {
		Ex_beh_resize_sfln(fig,tp->figure,ep)
		{
			sprintf(lexp_errbuf(lexp),"%s(1) (left=%u, right=%u)",
					Err_figure,tp->figure,fig);
			tok_error(lexp,lxp);
			}
		}
	/* !!!opr_arg(OPR_eq_term,E_token,E_expr) */
	/* !!!opr_arg(':=',E_token,E_expr) */
	ep = new_expr(acp,opr,tp->figure,(expr*)tp,ep,beh);
	/* TRANSLATE: OPR_eq_term */
	/* TRANSLATE: ':=' */
	append_expr_ulink(acp,&(tp->translate),ep);
	Ex_data_translate_beh(tp);
	del_entity(my->tokecp,lxp);
	return ep;
	}


	static expr* argument_val(tMYc token*, expr* beh);


static expr* instruct_active(tMYc token* tp,expr* beh) {
	alloc_ctl* acp = my->behacp;
	lex* lexp = my->sfllexp;
	expr* ep;
	Ex_instruct_active(tp);
	/* !!!opr_arg(OPR_active,E_token,E_expr) */
	ep = new_expr(acp,OPR_active,1,(expr*)tp,argument_val(MYc tp,beh),beh);
	/* TRANSLATE: OPR_active */
	append_expr_ulink(acp,&(tp->translate),ep);
	return ep;
	}


	static unsigned int describe_opr_expression(tMYc int lvl,expr** epp, expr* beh);


static expr* get_mem_address(tMYc token* tp, token* lxp, expr* beh) {
	lex* lexp = my->sfllexp;
	expr* ap;
	unsigned int a_fig;
	unsigned int fig;
	sfl_assert(lexp,'[');
	fig = describe_opr_expression(MYc NO_priority,&ap,beh);
	if (ap == 0) {
		tp = get_token(MYc 0,lxp);
		sprintf(lexp_errbuf(lexp),"'memory address' expected");
		tok_error(lexp,lxp);
		}
	a_fig = get_mem_adr_bits(tp);
	if (fig == a_fig) goto ret;
	Ex_beh_resize_sfln(fig,a_fig,ap)
	{
		sprintf(lexp_errbuf(lexp),
			"memory address bits (mem fig=%u, exper fig=%u)",
			a_fig,fig);
		tok_error(lexp,lxp);
		}
ret:
	sfl_assert(lexp,']');
	return ap;
	}


	static expr* vector_translate_beh(tMYc expr* beh);
	static token* get_task_token(tMYc token* stage_tp);

static expr* describe_mono_behavior(tMYc expr* owner) {
	alloc_ctl* acp = my->behacp;
	lex*   lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* tp;
	token* stp;
	expr* ep = 0;
	expr* beh;
	expr* ap;
	int set_flg;
	footmark("describe_mono_behavior");
	tp = get_token(MYc my->module_tp,lxp);
	switch(token_id(tp)) {
	/* |[qւ̒l̏o ::= */
	case DEF_bus  :		/*   f[^[q =  ; */
	case DEF_sel  :
	case DEF_bus_v:
	case DEF_sel_v:
	case DEF_output:	/* | f[^o͒[q =  ; */
	case DEF_bidirect:	/* | f[^o[q =  ; */
		beh = behavior_location(MYc lxp,owner);
		sfl_assert(lexp,OPR_eq_term);
		ep = data_translate_beh(MYc OPR_eq_term,tp,beh);
		break;
	case DEF_submod:	/* | TuW[.f[^͒[q =  ; */
						/* | TuW[.f[^o[q =  ; */
						/* | TuW[.͒[q([{,}]) ; */
		beh = behavior_location(MYc lxp,owner);
		sfl_assert(lexp,'.');
		stp = get_token(MYc tp,lxp);
		switch(stp->id) {
		case DEF_input:
		case DEF_bidirect:
			sfl_assert(lexp,OPR_eq_term);
			/* !!!opr_arg(OPR_eq_term,E_token,E_expr) */
			ep = data_translate_beh(MYc OPR_eq_term, stp, beh);
			break;
		case DEF_instrin:
			/* ( [{,}] ) */
			sfl_assert(lexp,'(');
			/* !!!opr_arg(OPR_active,E_token,E_expr) */
			ep = instruct_active(MYc stp,beh);
			sfl_assert(lexp,')');
			break;
		default:
			sprintf(lexp_errbuf(lexp),"'input', 'bidirect' or 'instrin' expected");
			tok_error(lexp,lxp);
			}
		break;
	/* WX^ւ̏ ::= */
	case DEF_reg:		/* WX^ :=  ; */
	case DEF_reg_ws:
	case DEF_reg_wr:
		beh = behavior_location(MYc lxp,owner);
		sfl_assert(lexp,OPR_eq_reg);
		/* !!!opr_arg(OPR_eq_reg,E_token,E_expr) */
		ep = data_translate_beh(MYc  OPR_eq_reg, tp, beh);
		break;
	/* ւ̏ ::= */
	case DEF_mem:		/*  '[ ']:=; */
		beh = behavior_location(MYc lxp,owner);
		ap = get_mem_address(MYc tp,lxp, beh);
		sfl_assert(lexp,OPR_eq_reg);
		/* !!!opr_arg(OPR_memory,E_token,E_expr) */
		ap = new_expr(acp,OPR_memory,get_mem_adr_bits(tp),(expr*)tp,ap,beh);
		ep = data_translate_beh(MYc OPR_mem_wt, tp, beh);
		/* !!!opr_arg(OPR_mem_wt,E_expr,E_expr) */
		ep->op1 = ap;
		/*-----------------------------
		ep->opr = OPR_mem_wt
		    op1 -> opr = OPR_memory
		           op1 = g[N
		           op2 = AhX
		    op2 -> Eӂ̎
		------------------------------*/
		break;
	/* [q̋N ::= */
	case DEF_instrout:		/*   o͒[q([{,}]); */
	case DEF_instrself:		/* | [q([{,}]); */
		beh = behavior_location(MYc lxp,owner);
		sfl_assert(lexp,'(');
		/* !!!opr_arg(OPR_active,E_token,E_expr) */
		ep = instruct_active(MYc tp,beh);
		sfl_assert(lexp,')');
		break;
	case ';':				/*  ::= ; */
		beh = behavior_location(MYc lxp,owner);
		unget_token(lexp,lxp);
		/* !!!opr_arg(OPR_void,0,0) */
		ep = new_expr(acp,OPR_void,0,0,0,beh);
		break;
	case '(':
		beh = behavior_location(MYc lxp,owner);
		unget_token(lexp,lxp);
		ep = vector_translate_beh(MYc beh);
		break;
	case DEF_input:
		sprintf(lexp_errbuf(lexp),"output-pin expected");
		tok_error(lexp,lxp);
	default:
		goto check_key;
		}
	goto ret;

check_key:
	switch(token_id(tp)) {
	case DEF_stage_name:
		break;
	default:
		set_flg = 1;
		tp = token_lookup(my->sflkey_tp, lxp, &set_flg);
		if (tp == 0) {
			sprintf(lexp_errbuf(lexp),"behavior expected");
			tok_error(lexp,lxp);
			}
		break;
		}
	switch(token_id(tp)) {
	/* ԑJ ::= */
	case KEY_goto:			/*goto Ԗ; */
		beh = behavior_location(MYc lxp,owner);
		tp = get_state_name(MYc my->stgseg_tp);
		/* !!!opr_arg(OPR_goto,E_token,E_token) */
		ep = new_expr(acp,OPR_goto,0,(expr*)(my->stgseg_tp),(expr*)tp,beh);
		/* TRANSLATE: OPR_goto */
		append_expr_ulink(acp,&(my->stage_tp->translate),ep);
		/*----------------------------------
		ep->opr = OPR_goto
		    op1 = (expr*)(my->stgseg_tp)
		    op2 = (expr*)tp Ԗ
		----------------------------------*/
		break;
	/* ZOgĂяo ::= */
	case KEY_call:
		beh = behavior_location(MYc lxp,owner);
		tp = get_segment_name(MYc my->stage_tp);
		/* !!!opr_arg(OPR_call,E_token,E_expr) */
		ep = new_expr(acp,OPR_call,0,(expr*)(my->stgseg_tp),0,beh);
		/* TRANSLATE: OPR_call */
		append_expr_ulink(acp,&(my->stage_tp->translate),ep);
		append_expr_ulink(acp,&(tp->translate),ep);
		sfl_assert(lexp,'(');
		stp = get_token(MYc my->stgseg_tp,lxp);
		switch(stp->id) {
		case ')':
			/* ߂Ԃw肵ȂZOgĂяo ::= */
			/* call ZOg(); */
			/* !!!opr_arg(OPR_ret_void,E_token,E_token) */
			ep->op2 = new_expr(acp,OPR_ret_void,0,(expr*)tp,(expr*)(my->state_tp),beh);
			/*-----------------------------------------
			ep->opr = OPR_call
			    op1 = (expr*)(my->stgseg_tp)
			    op2 -> opr = OPR_ret_void
			           op1 = (expr*)tp ďoZOg
			           op2 = (expr*)(my->state_tp)
			-----------------------------------------*/
			break;
		case LEX_SYM:
			unget_token(lexp,lxp);
			stp = get_state_name(MYc my->stgseg_tp);
		case DEF_state_name:
			/* call ZOg(߂Ԗ); */
			sfl_assert(lexp,')');
			/* !!!opr_arg(OPR_ret_stat,E_token,E_token) */
			ep->op2 = new_expr(acp,OPR_ret_stat,0,(expr*)tp,(expr*)stp,beh);
			/*----------------------------------------
			ep->opr = OPR_call
			    op1 = (expr*)(my->stgseg_tp)
			    op2 -> opr = OPR_ret_stat
			           op1 = (expr*)tp ďoZOg
			           op2 = (expr*)stp ߂Xe[g
			----------------------------------------*/
			break;
		default:
			sprintf(lexp_errbuf(lexp),"'return state' name expected");
			tok_error(lexp,lxp);
			}
		break;
	/* ZOg̕A ::= */
	case KEY_return:		/* return; */
		beh = behavior_location(MYc lxp,owner);
		if (my->segment_tp == 0) {
			sprintf(lexp_errbuf(lexp),"illegal return");
			tok_error(lexp,lxp);
			}
		/* !!!opr_arg(OPR_return,E_token,0) */
		ep = new_expr(acp,OPR_return,0,(expr*)(my->segment_tp),0,beh);
		/* TRANSLATE: OPR_return */
		append_expr_ulink(acp,&(my->stage_tp->translate),ep);
		/*----------------------------------
		ep->opr = OPR_return
		    op1 = (expr*)(my->segment_tp)
		    op2 = 0
		----------------------------------*/
		break;
	/* Wu̐ ::= */
	case KEY_generate:		/* generate Xe[W{.^XN}([{,}]); */
		tp = get_stage_name(MYc my->module_tp);
	case DEF_stage_name:
		beh = behavior_location(MYc lxp,owner);
		stp = get_task_token(MYc tp);
		sfl_assert(lexp,'(');
		/* !!!opr_arg(OPR_generate,E_token,E_expr) */
		ep = argument_val(MYc stp,beh);
		ep = new_expr(acp,OPR_generate,0,(expr*)stp,ep,beh);
		/* TRANSLATE: OPR_generate */
		append_expr_ulink(acp,&(tp->translate),ep);	/* stage */
		sfl_assert(lexp,')');
		/*---------------------------
		ep->opr = OPR_generate
		    op1 = (expr*)stp ^XN
		    op2 -> Xg
		----------------------------*/
		break;
	/* Wu̓] ::= */
	case KEY_relay:			/* relay Xe[W{.^XN}([{,}]); */
		beh = behavior_location(MYc lxp,owner);
		tp = get_stage_name(MYc my->module_tp);
		stp = get_task_token(MYc tp);
		sfl_assert(lexp,'(');
		/* !!!opr_arg(OPR_relay,E_expr,E_expr) */
		ep = argument_val(MYc stp,beh);
		ep = new_expr(acp,OPR_relay,0,0,ep,beh);
		/* TRANSLATE: OPR_relay */
		append_expr_ulink(acp,&(tp->translate),ep);	/* relay stage */
		/* !!!opr_arg(OPR_rel_task,E_token,E_token) */
		ep->op1 = new_expr(acp,OPR_rel_task,0,(expr*)stp,(expr*)(my->stage_tp),beh);
		/* TRANSLATE: OPR_rel_task */
		append_expr_ulink(acp,&(my->stage_tp->translate),ep);	/* now stage */
		sfl_assert(lexp,')');
		/*---------------------------
		ep->opr = OPR_relay
		    op1 -> opr = OPR_rel_task
		           op1 = (expr*)stp ^XN
		           op2 = (expr*)(my->stage_tp)ďoXe[W
		    op2 -> Xg
		----------------------------*/
		break;
	/* WȕI ::= */
	case KEY_finish:		/* finish; */
		beh = behavior_location(MYc lxp,owner);
		/* !!!opr_arg(OPR_finish,E_token,0) */
		ep = new_expr(acp,OPR_finish,0,(expr*)(my->stage_tp),0,beh);
		/* TRANSLATE: OPR_finish */
		append_expr_ulink(acp,&(my->stage_tp->translate),ep);	/* now stage */
		/*---------------------------
		ep->opr = OPR_finish
		    op1 = (expr*)my->stage
		    op2 = 0
		----------------------------*/
		break;
	default:
		unget_token(lexp,lxp);
		del_entity(my->tokecp,lxp);
		return 0;
		}
ret:
	beh->op1 = ep;
	sfl_assert(lexp,';');
	del_entity(my->tokecp,lxp);
	return beh;
	}


	/* ߂Ԗ ::= Ԗ */
	/*  ::=  */


/* [  { ,  } ]  ) */


static expr* argument_val(tMYc token* atp, expr* beh) {
	alloc_ctl* acp = my->behacp;
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	uni_link* lp = atp->arg;
	int opr;
	int tc;
	token* tp;
	expr* ep;
	expr* rep = 0;
	expr** repp = &rep;
	footmark("argument_val");
	if (lp == 0) goto ret;
	forever {
		tp = lp->ap;
		lp = lp->np;
		tc = token_id(tp);
		opr = (tc == DEF_reg || tc == DEF_reg_ws || tc == DEF_reg_wr) ? OPR_eq_reg : OPR_eq_term;
		/* !!!opr_arg(OPR_eq_reg,E_token,E_expr) */
		/* !!!opr_arg(OPR_eq_term,E_token,E_expr) */
		ep = data_translate_beh(MYc opr, tp, beh);
		/* !!!opr_arg(OPR_exp_link,E_expr,E_expr) */
		*repp = new_expr(acp,OPR_exp_link,0,ep,0,beh);
		repp = &((*repp)->op2);
		if (lp == 0) break;
		sfl_assert(lexp,',');
		}
ret:
	tp = get_token(MYc 0,lxp);
	if (token_id(tp) != ')') {
		sprintf(lexp_errbuf(lexp),"')' expected");
		tok_error(lexp,lxp);
		}
	unget_token(lexp,lxp);
	del_entity(my->tokecp,lxp);
	return rep;
	}


/*****************************************************************************/
/* ========================================================================= */
/* =====   CZq                                                ===== */
/* ========================================================================= */
/*****************************************************************************/


/* ========================================================================= */
/* =====  Zq̗D揇                                             ===== */
/* ========================================================================= */


#undef  def_opr
#define def_opr(s,c,p) case c: return p;

ENTRY int decl_opr_priority(int opr) {
	switch(opr) {
	declare_opr
		}
	return 0;
	}

ENTRY int beh_opr_priority(int opr) {
	switch(opr) {
	behavior_opr
		}
	return 0;
	}

ENTRY int expr_opr_priority(int sflspec_no,int opr) {
	switch(sflspec_no) {
	case 1:
		switch(opr) {
		v1_expression_opr
			}
		break;
	case 2:
		switch(opr) {
		v2_expression_opr
			}
		break;
	case 3:
		switch(opr) {
		v2_expression_opr
			}
		break;
		}
	return 0;
	}


ENTRY int mono_opr_priority(int sflspec_no,int opr) {
	switch(sflspec_no) {
	case 1:
		switch(opr) {
		v1_mono_expr_opr
		case OPR_0expand: return MOp_0expand;
			}
		break;
	case 2:
		switch(opr) {
		v2_mono_expr_opr
		case OPR_0expand: return MOp_0expand;
			}
		break;
	case 3:
		switch(opr) {
		v2_mono_expr_opr
			}
		break;
		}
	return 0;
	}


ENTRY int element_opr_priority(int opr) {
	switch(opr) {
	element_opr
		}
	return 0;
	}


/* ========================================================================= */
/* =====   CZq                                                ===== */
/* ========================================================================= */


extern int meta_off_ctl;

static unsigned int describe_do_opr_expression(tMYc int lvl,expr** epp, expr* beh);


static unsigned int describe_opr_expression(tMYc int lvl,expr** epp, expr* beh) {
	lex* lexp = my->sfllexp;
	unsigned int fig;
	word_dict* save_tblp;
	int        save_meta;
	jmp_buf* save_jbp = my->jmpbfp;
	jmp_buf jbuf;
	int rtc;
	save_tblp = lexp->opr_tblp;
	save_meta = lexp->meta_off;
	my->jmpbfp = &jbuf;
	rtc = setjmp(jbuf);
	if (rtc == 0) {
		/* ւ */
		lexp->opr_tblp = expression_opr_dict[lexp->sflspec - 1];
		lexp->meta_off = meta_off_ctl;
		fig = describe_do_opr_expression(MYc lvl,epp,beh);
		}
	lexp->meta_off = save_meta;
	lexp->opr_tblp = save_tblp;
	my->jmpbfp = save_jbp;
	if(rtc != 0) {
		/* ُI */
		longjmp(*(my->jmpbfp),rtc);
		}
	return fig;
	}


/*
| ::=
|	  P |  		// or 
|	| P @  		// eor 
|	| P &  		// and 
|	| P || 		// A 
|	| P +  		// Z 
|	| P >> 		// rbgEVtg 
|	| P << 		// rbgVtg 
|	| P == 		// v 
|	| P
*/


static expr* value_exp(token* tp, expr* arg, expr* beh) {
	alloc_ctl* acp;
	expr* ep;
	/* !!!opr_arg(OPR_value,E_token,E_expr) */
	acp = tp->acp;
	ep = new_expr(acp,OPR_value,tp->figure,(expr*)tp,arg,beh);
	append_expr_ulink(acp,&(tp->reference),ep);
	return ep;
	}


	static unsigned int describe_mono_expression(tMYc int lvl,expr** epp, expr* beh);


static unsigned int describe_do_opr_expression(tMYc int lvl,expr** epp,expr* beh) {
	alloc_ctl* acp = my->behacp;
	lex*   lexp = my->sfllexp;
	token* lxp;
	token* tp;
	int    opr_lvl;
	int    opr;
	expr*  ep;
	expr*  e_ep;
	unsigned int r_fig;
	unsigned int m_fig;
	unsigned int e_fig;
	footmark("describe_do_opr_expression");
	*epp = 0;
	/* P̒lvZ\쐬 */
	r_fig = m_fig = describe_mono_expression(MYc lvl,&ep,beh);
	if (ep == 0) return 0;
	lxp = new_entity(my->tokecp);
	forever {
		/* QZq擾 */
		tp = get_token(MYc 0,lxp);
		switch(opr = token_id(tp)) {
		case OPR_or:		/* !!!opr_arg(OPR_or ,    E_expr,E_expr) */
		case OPR_xor:		/* !!!opr_arg(OPR_xor,    E_expr,E_expr) */
		case OPR_and:		/* !!!opr_arg(OPR_and,    E_expr,E_expr) */
		case OPR_catinate:	/* !!!opr_arg(OPR_catinate,E_expr,E_expr) */
		case OPR_logand:	/* !!!opr_arg(OPR_logand ,E_expr,E_expr) */
		case OPR_plus:		/* !!!opr_arg(OPR_plus,   E_expr,E_expr) */
		case OPR_minus:		/* !!!opr_arg(OPR_minus,  E_expr,E_expr) */
		case OPR_multi:		/* !!!opr_arg(OPR_multi,  E_expr,E_expr) */
		case OPR_divide:	/* !!!opr_arg(OPR_divide ,E_expr,E_expr) */
		case OPR_residue:	/* !!!opr_arg(OPR_residue,E_expr,E_expr) */
		case OPR_sft_r:		/* !!!opr_arg(OPR_sft_r,  E_expr,E_expr) */
		case OPR_sft_l:		/* !!!opr_arg(OPR_sft_l,  E_expr,E_expr) */
		case OPR_cmp_eq:	/* !!!opr_arg(OPR_cmp_eq, E_expr,E_expr) */
		case OPR_cmp_ne:	/* !!!opr_arg(OPR_cmp_ne, E_expr,E_expr) */
		case OPR_cmp_gt:	/* !!!opr_arg(OPR_cmp_gt, E_expr,E_expr) */
		case OPR_cmp_ge:	/* !!!opr_arg(OPR_cmp_ge, E_expr,E_expr) */
		case OPR_cmp_lt:	/* !!!opr_arg(OPR_cmp_lt, E_expr,E_expr) */
		case OPR_cmp_le:	/* !!!opr_arg(OPR_cmp_le, E_expr,E_expr) */
			opr_lvl = expr_opr_priority(sflspec_no,opr);
			break;
		default:
			opr_lvl = 0;
			}
/* %%%
		if ((opr_lvl == 0) || (opr_lvl >= lvl) ){
*/
		/* P ?  Ȃ̂ŉED悷邽 opr_lvl == lvl ͊܂߂Ȃ */
		if ((opr_lvl == 0) || (opr_lvl > lvl) ){
			/* QZqłȂAZxア */
			unget_token(lexp,lxp);
			break;
			}
		/* QIyh擾 */
		e_fig = define_opr_expression(MYc opr_lvl,&e_ep,beh);
		/* ̒lvZ\쐬 */
		ep = new_expr(acp,opr,r_fig,ep,e_ep,beh);
		/* ̃rbgrAʂ̃rbg߂ */
		switch(opr) {
		case OPR_or:
		case OPR_xor:
		case OPR_and:
			/* ̃rbg͓łȂ΃G[ */
			if (m_fig != e_fig) {
				sprintf(lexp_errbuf(lexp),"%s(2) (fig_1=%u, fig_2=%u)",
						Err_figure,m_fig,e_fig);
				tok_error(lexp,lxp);
				}
			Ex_beh_simple_op2_expr(m_fig,e_fig,r_fig,ep);
			break;
		case OPR_catinate:
			/* ʂ̃rbǵÃrbg̘a */
			ep->fig = r_fig = m_fig + e_fig;
			Ex_beh_simple_catinate(m_fig,e_fig,ep);
			break;
		case OPR_logand:
			/* ʂ̃rbǵA1rbg */
			ep->fig = r_fig = 1;
			break;
		case OPR_plus:
		case OPR_minus:
			{
			unsigned long* vp;
			/* op1op2̃TCYȂ̂ő傫ɍ킹 */
			if (m_fig < e_fig) {
				ep->fig = r_fig = e_fig;
				/* op1̕ */
				if (ep->op1->opr == OPR_sfln) {
					/* op1͒PȂrekmǂݏo */
					ep->op1->op1 = (expr*)resize_sfln(MYc e_fig,(token*)(ep->op1->op1));
					}
				else {
					vp = new_alloc(acp,sizeof(*vp)*2);
					*vp = e_fig;
					/* !!!opr_arg(OPR_0expand,E_expr,E_long1) */
					ep->op1 = new_expr(acp,OPR_0expand,0,ep->op1,(expr*)vp,beh);
					}
				ep->op1->fig = m_fig = e_fig;
				}
			else if (m_fig > e_fig) {
				/* op2̕ */
				if (ep->op2->opr == OPR_sfln) {
					/* op2͒PȂrekmǂݏo */
					ep->op2->op1 = (expr*)resize_sfln(MYc m_fig,(token*)(ep->op2->op1));
					}
				else {
					vp = new_alloc(acp,sizeof(*vp)*2);
					*vp = m_fig;
					/* !!!opr_arg(OPR_0expand,E_expr,E_long1) */
					ep->op2 = new_expr(acp,OPR_0expand,0,ep->op2,(expr*)vp,beh);
					}
				ep->op2->fig = e_fig = m_fig;
				}
			Ex_beh_simple_op2_expr(m_fig,e_fig,r_fig,ep);
			}
			break;
		case OPR_multi:
			ep->fig = r_fig = m_fig + e_fig;
			Ex_beh_simple_op2_expr(m_fig,e_fig,r_fig,ep);
			break;
		case OPR_divide:
			if (m_fig < e_fig) ep->fig = r_fig = m_fig;
			Ex_beh_simple_op2_expr(m_fig,e_fig,r_fig,ep);
			break;
		case OPR_residue:
			ep->fig = r_fig = e_fig;
			Ex_beh_simple_op2_expr(m_fig,e_fig,r_fig,ep);
			break;
		case OPR_sft_r:
		case OPR_sft_l:
			/* %%% bit width no check
			fig = cal_bit_width(m_fig);
			if (fig != e_fig) {
				if (ep->op2->opr == OPR_sfln) {
					ep->op2->op1 = (expr*)resize_sfln(MYc fig,(token*)(ep->op2->op1));
					}
				else {
					sprintf(lexp_errbuf(lexp),"%s(3) (fig_1=%u, fig_2=%u)",
							Err_figure,m_fig,e_fig);
					tok_error(lexp,lxp);
					}
				}
			*/
			Ex_beh_is_const_opr
			break;
		case OPR_cmp_eq:
		case OPR_cmp_ne:
		case OPR_cmp_gt:
		case OPR_cmp_ge:
		case OPR_cmp_lt:
		case OPR_cmp_le:
			/* ̃rbg͓łȂ΃G[ */
			if (m_fig != e_fig) {
				sprintf(lexp_errbuf(lexp),"%s(4) (fig_1=%u, fig_2=%u)",
						Err_figure,m_fig,e_fig);
				tok_error(lexp,lxp);
				}
			ep->fig = r_fig = 1;
			Ex_beh_is_const_opr
			break;
			}
		set_opr_inst(MYc ep,m_fig,e_fig);
		m_fig = r_fig;
		}
	del_entity(my->tokecp,lxp);
	*epp = ep;
	return r_fig;
	}


static unsigned int define_opr_expression(tMYc int lvl,expr** epp, expr* beh) {
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	unsigned int fig;
	footmark("define_opr_expression");
	fig = describe_opr_expression(MYc lvl,epp,beh);
	if (*epp == 0) {
		get_token(MYc 0,lxp);
		sprintf(lexp_errbuf(lexp),"'expression' expected");
		tok_error(lexp,lxp);
		}
	del_entity(my->tokecp,lxp);
	return fig;
	}


/*****************************************************************************/
/* ========================================================================= */
/* =====   P                                                    ===== */
/* ========================================================================= */
/*****************************************************************************/


	static unsigned int describe_do_mono_expression(tMYc int lvl,expr** epp, expr* beh);


static unsigned int describe_mono_expression(tMYc int lvl,expr** epp, expr* beh) {
	lex* lexp = my->sfllexp;
	unsigned int fig;
	word_dict* save_tblp;
	jmp_buf* save_jbp = my->jmpbfp;
	jmp_buf jbuf;
	int rtc;
	save_tblp = lexp->opr_tblp;
	my->jmpbfp = &jbuf;
	rtc = setjmp(jbuf);
	if (rtc == 0) {
		/* ւ */
		lexp->opr_tblp = mono_expr_opr_dict[lexp->sflspec - 1];
		fig = describe_do_mono_expression(MYc lvl,epp,beh);
		}
	lexp->opr_tblp = save_tblp;
	my->jmpbfp = save_jbp;
	if(rtc != 0) {
		/* ُI */
		longjmp(*(my->jmpbfp),rtc);
		}
	return fig;
	}


/*
|P ::=
|	  ^  P	// ے 
|	| /| P	//  or 
|	| /@ P	//  eor 
|	| /& P	//  and 
|	| /  P	// fR[h 
|	| \  P	// GR[h 
|	| ʂ̌ #P	// g 
|	| vf '<ŏʌʒu[:ŉʌʒu]'>	// rbg؂o 
|	| vf
*/


	static unsigned int describe_exp_element(tMYc expr** epp, expr* beh);


static unsigned int describe_do_mono_expression(
	tMYc
	int lvl,
	expr** epp,
	expr* beh
){
	alloc_ctl* acp = my->behacp;
	lex*   lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* tp;
	expr*  ep = 0;
	unsigned long* vp;
	unsigned int m_fig;
	unsigned int r_fig;
	int    opr;
	int    opr_lvl;
	int    bpos;
	int    msb;
	int    lsb;
	footmark("describe_do_mono_expression");
	tp = get_token(MYc 0,lxp);
	opr = token_id(tp);
	/* prefix operation */
	switch(opr) {
	case OPR_invert :	/* !!!opr_arg(OPR_invert ,E_expr,0) */
	case OPR_bit_or :	/* !!!opr_arg(OPR_bit_or ,E_expr,0) */
	case OPR_bit_xor:	/* !!!opr_arg(OPR_bit_xor,E_expr,0) */
	case OPR_bit_and:	/* !!!opr_arg(OPR_bit_and,E_expr,0) */
	case OPR_lognot :	/* !!!opr_arg(OPR_lognot, E_expr,0) */
	case OPR_decode :	/* !!!opr_arg(OPR_decode ,E_expr,0) */
	case OPR_encode :	/* !!!opr_arg(OPR_encode ,E_expr,0) */
		opr_lvl = mono_opr_priority(sflspec_no,opr);
		/* P̒lvZ\쐬 */
		m_fig = describe_mono_expression(MYc opr_lvl,&ep,beh);
		if (ep == 0) {
			tp = get_token(MYc 0,lxp);
			sprintf(lexp_errbuf(lexp),"'monomial expression' expected");
			tok_error(lexp,lxp);
			}
		switch(opr) {
		case OPR_invert:
			r_fig = m_fig;
			break;
		case OPR_bit_or:
		case OPR_bit_xor:
		case OPR_bit_and:
		case OPR_lognot:
			r_fig =1;
			break;
		case OPR_decode:
			if (m_fig >= 16) {
				get_token(MYc 0,lxp);
				sprintf(lexp_errbuf(lexp),"'%s' too big decode",token_name(tp));
				tok_error(lexp,lxp);
				}
			r_fig = 1 << m_fig;
			break;
		case OPR_encode:
			r_fig = cal_bit_width(m_fig) + 1;
			break;
			}
		ep = new_expr(acp,opr,r_fig,ep,0,beh);
		break;
	case '(':
		if (is_number_opr(lexp,')') != GOOD) {
			goto def_exp;
			}
		r_fig = (int)get_number(lexp,lexp->sflspec);
		sfl_assert(lexp,')');
		goto expand;
	case LEX_NUM:
		unget_token(lexp,lxp);
		tp = get_eval_num_tok(lexp,lxp);
		r_fig = (int)(tp->value);
	case OPR_num:
	expand:
		if ((int)r_fig < 1) {
			sprintf(lexp_errbuf(lexp),"illegal expand width (%d)\n",r_fig);
			tok_error(lexp,lxp);
			}
		sfl_assert(lexp,OPR_expand);
		m_fig = describe_mono_expression(MYc NO_priority,&ep,beh);
		if (ep == 0) {
			get_token(MYc 0,lxp);
			sprintf(lexp_errbuf(lexp),"'monomial expression' expected");
			tok_error(lexp,lxp);
			}
		vp = new_alloc(acp,sizeof(*vp)*2);
		*vp = (long)r_fig;
		/* !!!opr_arg(OPR_expand,E_expr,E_long1) */
		ep = new_expr(acp,OPR_expand,r_fig,ep,(expr*)vp,beh);
		break;
	default:
	def_exp:
		/* get element */
		unget_token(lexp,lxp);
		r_fig = m_fig = describe_exp_element(MYc &ep,beh);
		if (ep == 0) goto ret;
		forever {
			tp = get_token(MYc 0,lxp);
			/* sufix operation */
			opr_lvl = 0;
			switch(opr = token_id(tp)) {
			case '<':
				if (is_number_opr(lexp,' ') != GOOD) break;
			case OPR_incre:
			case OPR_decre:
				opr_lvl = mono_opr_priority(sflspec_no,opr);
				}
			if ((opr_lvl == 0) || (opr_lvl >= lvl)){
				/* PZqłȂAZxア */
				unget_token(lexp,lxp);
				goto ret;
				}
			switch(opr) {
			/* sufix operation */
			case '<':
				bpos = (int)get_number(lexp,lexp->sflspec);
				/* ŏʌʒu ŉʌʒu */
				vp = new_alloc(acp,sizeof(*vp)*2);
				vp[0] = bpos;
				vp[1] = bpos;
				tp = get_token(MYc 0,lxp);
				if (token_id(tp) == OPR_partial) {
					/* ŏʌʒu ŉʌʒu */
					vp[1] = get_bit_order(lexp,"bit position(LSB)",0);
					}
				else unget_token(lexp,lxp);
				sfl_assert(lexp,'>');
				msb = (int)vp[0];
				lsb = (int)vp[1];
				r_fig = (msb > lsb) ? (msb - lsb) : (lsb - msb);
				++r_fig;
				/* !!!opr_arg(OPR_partial,E_expr,E_long2) */
				ep = new_expr(acp,OPR_partial,r_fig,ep,(expr*)vp,beh);
				break;
			case OPR_incre:
			case OPR_decre:
				/* !!!opr_arg(OPR_incre,E_expr,0) */
				/* !!!opr_arg(OPR_decre,E_expr,0) */
				ep = new_expr(acp,opr,r_fig,ep,0,beh);
				break;
				}
			m_fig = r_fig;
			}
		}
	Ex_beh_simple_mono_expr
ret:
	del_entity(my->tokecp,lxp);
	*epp = ep;
	if (ep != 0) set_opr_inst(MYc ep,m_fig,0);
	return r_fig;
	}



/*****************************************************************************/
/* ========================================================================= */
/* =====   vf                                                      ===== */
/* ========================================================================= */
/*****************************************************************************/


static unsigned int describe_do_exp_element(tMYc expr** epp, expr* beh);


static unsigned int describe_exp_element(tMYc expr** epp, expr* beh) {
	lex* lexp = my->sfllexp;
	unsigned int fig;
	word_dict* save_tblp;
	jmp_buf* save_jbp = my->jmpbfp;
	jmp_buf jbuf;
	int rtc;
	save_tblp = lexp->opr_tblp;
	my->jmpbfp = &jbuf;
	rtc = setjmp(jbuf);
	if (rtc == 0) {
		/* ւ */
		lexp->opr_tblp = element_opr_dict[lexp->sflspec - 1];
		fig = describe_do_exp_element(MYc epp,beh);
		}
	lexp->opr_tblp = save_tblp;
	my->jmpbfp = save_jbp;
	if(rtc != 0) {
		/* ُI */
		longjmp(*(my->jmpbfp),rtc);
		}
	return fig;
	}


/*
|vf ::=
|	  ()
|	| 萔
|	| WX^
|	|  '[AhX ']
|	| Xe[W{.^XN}
|	| f[^[q
|	| [q
|	| f[^͒[q
|	| f[^o͒[q
|	| f[^o[q
|	| ͒[q
|	| o͒[q
|	| TuW[.f[^͒[q
|	| TuW[.f[^o͒[q
|	| TuW[.f[^o[q
|	| TuW[.͒[q
|	| TuW[.o͒[q
|	| TuW[.͒[q([{,}]).f[^o͒[q
|	| TuW[.͒[q([{,}]).f[^o[q
|	| [q([{,}]).f[^[q
|	| o͒[q([{,}]).f[^͒[q
|	| o͒[q([{,}]).f[^o[q
*/


/*
|AhX ::= 
*/


static token* get_task_token(tMYc token* stage_tp) {
	lex*   lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* tp;
	tp = get_token(MYc 0,lxp);
	if (token_id(tp) == '.') {
		tp = get_token(MYc stage_tp,lxp);
		if (tp->id != DEF_task) {
			sprintf(lexp_errbuf(lexp),"'task' name expected");
			tok_error(lexp,lxp);
			}
		}
	else {
		unget_token(lexp,lxp);
		tp = seek_auto_task(MYc stage_tp,0);
		}
	del_entity(my->tokecp,lxp);
	return tp;
	}


static unsigned int describe_do_exp_element(tMYc expr** epp, expr* beh) {
	alloc_ctl* acp = my->behacp;
	lex*   lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* tp;
	token* stp;
	token* ktp;
	expr* ep = 0;
	expr* ap;
	unsigned int fig;
	footmark("describe_do_exp_element");

	tp = get_token(MYc my->module_tp,lxp);
	fig = tp->figure;
	/* vf ::= */
	switch(token_id(tp)) {
	case '(':				/* (  ) ܂́Ai萔jEEE@*/

		/* PȂ鐔lǂׂ */
		if (is_number_opr(lexp,')') == GOOD) goto give_up;

		fig = define_opr_expression(MYc NO_priority,&ep,beh);
		sfl_assert(lexp,')');
		/* epOPR_sfln̏ꍇ́AOPR_bracket͕KvȂ */
		if (ep->opr != OPR_sfln) {
			/* !!!opr_arg(OPR_bracket,E_expr,0) */
			ep = new_expr(acp,OPR_bracket,ep->fig,ep,0,beh);	/* (...) */
			}
		break;
	case LEX_SFLN:			/* 萔 */
		/* !!!opr_arg(OPR_sfln,E_token,E_char) */
		ep = new_expr(acp,OPR_sfln,tp->figure,(expr*)tp,(expr*)(tp->tokren->name),beh);
		fig = tp->figure;
		break;
	case DEF_reg:			/* WX^ */
	case DEF_reg_ws:
	case DEF_reg_wr:
		ep = value_exp(tp,0,beh);
		break;
	case DEF_mem:			/*  '[AhX '] */
		ap = get_mem_address(MYc tp, lxp, beh);
		/* !!!opr_arg(OPR_mem_rd,E_token,E_expr) */
		ep = new_expr(acp,OPR_mem_rd,tp->figure,(expr*)tp,ap,beh);
		append_expr_ulink(tp->acp,&(tp->reference),ep);
		break;
	case DEF_stage_name:	/* Xe[W{.^XN} */
		stp = get_task_token(MYc tp);
		ep = value_exp(stp,0,beh);
		break;
	case DEF_bus  :			/* f[^[q */
	case DEF_sel  :
	case DEF_bus_v:
	case DEF_sel_v:
		ep = value_exp(tp,0,beh);
		break;
	case DEF_instrself:		/* [q */
		stp = get_token(MYc 0,lxp);
		switch(stp->id) {
		case '(':			/* ([{,}]).f[^[q */
			/* !!!opr_arg(OPR_active,E_token,E_expr) */
			ep = instruct_active(MYc tp,beh);
			sfl_assert(lexp,')');
			sfl_assert(lexp,'.');
			stp = get_token(MYc my->module_tp,lxp);
			switch(stp->id) {
			case DEF_bus  :
			case DEF_sel  :
			case DEF_bus_v:
			case DEF_sel_v:
				fig = stp->figure;
				ep = value_exp(stp,ep,beh);
				break;
			default:
				sprintf(lexp_errbuf(lexp),"'sel' or 'bus' name expected");
				tok_error(lexp,lxp);
				}
			break;
		default:			/* [q only */
			unget_token(lexp,lxp);
			ep = value_exp(tp,0,beh);
			break;
			}
		break;
	case DEF_input:		/* f[^͒[q */
	case DEF_output:	/* f[^o͒[q */
	case DEF_bidirect:	/* f[^o[q */
	case DEF_instrin:	/* ͒[q */
		ep = value_exp(tp,0,beh);
		break;
	case DEF_instrout:	/* o͒[q */
		stp = get_token(MYc 0,lxp);
		switch(stp->id) {
		case '(':			/* ([{,}]).f[^͒[q   */
							/* ([{,}]).f[^o[q */
			/* !!!opr_arg(OPR_active,E_token,E_expr) */
			ep = instruct_active(MYc tp,beh);
			sfl_assert(lexp,')');
			sfl_assert(lexp,'.');
			stp = get_token(MYc my->module_tp,lxp);
			switch(stp->id) {
			case DEF_input   :		/* f[^͒[q   */
			case DEF_bidirect:		/* f[^o[q */
				fig = stp->figure;
				ep = value_exp(stp,ep,beh);
				break;
			default:
				sprintf(lexp_errbuf(lexp),"'input'or 'bidirect' name expected");
				tok_error(lexp,lxp);
				}
			break;
		default:			/* o͒[q only */
			unget_token(lexp,lxp);
			ep = value_exp(tp,0,beh);
			break;
			}
		break;
	case DEF_submod:	/* TuW[ */
		sfl_assert(lexp,'.');
		stp = get_token(MYc tp,lxp);
		fig = stp->figure;
		switch(stp->id) {
		case DEF_input:			/* f[^͒[q */
		case DEF_output:		/* f[^o͒[q */
		case DEF_bidirect:		/* f[^o[q */
			break;
		case DEF_instrin:		/* ͒[q */
			ktp = get_token(MYc 0,lxp);
			switch(ktp->id) {
			case '(':			/* ([{,}]).f[^o͒[q   */
								/* ([{,}]).f[^o[q */
				/* !!!opr_arg(OPR_active,E_token,E_expr) */
				ep = instruct_active(MYc stp,beh);
				sfl_assert(lexp,')');
				sfl_assert(lexp,'.');
				ktp = get_token(MYc tp,lxp);
				switch(ktp->id) {
				case DEF_output:	/* f[^o͒[q */
				case DEF_bidirect:	/* f[^o[q */
					stp = ktp;
					fig = stp->figure;
					break;
				default:
					sprintf(lexp_errbuf(lexp),"'output' or 'bidirect' name expected");
					tok_error(lexp,lxp);
					}
				break;
			default:				/* ͒[q only */
				unget_token(lexp,lxp);
				break;
				}
			break;
		case DEF_instrout:		/* o͒[q */
			break;
			}
		ep = value_exp(stp,ep,beh);
		break;
	/* %%%
	case LEX_SYM:
		sprintf(lexp_errbuf(lexp),"expression expected");
		tok_error(lexp,lxp);
	*/
	default:
	give_up:
		unget_token(lexp,lxp);
		break;
		}
ret:
	del_entity(my->tokecp,lxp);
	*epp = ep;
	return fig;
	}



/*****************************************************************************/
/* ========================================================================= */
/* =====   xNg] (Special Function for Mario. Mar/GoodDay/'99)===== */
/* ========================================================================= */
/*****************************************************************************/

/*
|
|[qxNgւ̒lxNg̏o ::= [qxNg = lxNg;
|
|[qxNg ::= 
|   | (ݒ[q{,ݒ[q])
|
|ݒ[q ::=
|	  f[^[q
|	| f[^o͒[q
|	| f[^o[q
|
|lxNg ::=
|	| [q([{,}]).(Ǐo[q{,Ǐo[q})
|	| o͒[q([{,}]).(Ǐo[q{,Ǐo[q})
|	| TuW[.͒[q([{,}]).(ǏoTu[q{,ǏoTu[q})
|
|Ǐo[q ::=
|	| f[^[q
|	| [q
|	| f[^͒[q
|	| f[^o͒[q
|	| f[^o[q
|	| ͒[q
|	| o͒[q
|
|ǏoTu[q ::= TuW[
|	  f[^͒[q
|	| f[^o͒[q
|	| f[^o[q
|	| ͒[q
|	| o͒[q
|
*/


enum {
	VCT_target = 1,
	VCT_module,
	VCT_submod,
	};


static token* get_vector_token(tMYc token* module_tp, int typ) {
	static symbol* toksym = 0;
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* link_tp;
	token* tp;
	int chk;
	int tc;
	footmark("get_vector_token");
	if (toksym == 0) toksym = symbol_lookup(lexp,"vector");
	tp = get_token(MYc 0,lxp);
	if (token_id(tp) != '(') {
		sprintf(lexp_errbuf(lexp),"'(' expected");
		tok_error(lexp,lxp);
		}
	lxp->toksym = lxp->tokren = toksym;
	link_tp = new_token(module_tp->acp,DEF_vector,lxp);
	link_tp->parent = module_tp;
	tp = get_token(MYc module_tp,lxp);
	if (token_id(tp) == ')') {
		sprintf(lexp_errbuf(lexp),"pin list expected");
		tok_error(lexp,lxp);
		}
	for ( ;; link_tp->figure++) {
		chk = 0;
		tc = token_id(tp);
		switch(typ) {
		case VCT_target:
			/*
			|ݒ[q ::=
			|	  f[^[q
			|	| f[^o͒[q
			|	| f[^o[q
			*/
			chk = (
				tc == DEF_sel || tc == DEF_sel_v || tc == DEF_bus || tc == DEF_bus_v ||
				tc == DEF_output   || 
				tc == DEF_bidirect    
				);
			break;
		case VCT_module:
			/*
			|Ǐo[q ::=
			|	| f[^[q
			|	| [q
			|	| f[^͒[q
			|	| f[^o͒[q
			|	| f[^o[q
			|	| ͒[q
			|	| o͒[q
			*/
			chk = (
				tc == DEF_sel || tc == DEF_sel_v || tc == DEF_bus || tc == DEF_bus_v ||
				tc == DEF_instrself || 
				tc == DEF_input     || 
				tc == DEF_output    || 
				tc == DEF_bidirect  || 
				tc == DEF_instrin   || 
				tc == DEF_instrout     
				);
			break;
		case VCT_submod:
			/*
			|ǏoTu[q ::= TuW[
			|	  f[^͒[q
			|	| f[^o͒[q
			|	| f[^o[q
			|	| ͒[q
			|	| o͒[q
			*/
			chk = (
				tc == DEF_input     || 
				tc == DEF_output    || 
				tc == DEF_bidirect  || 
				tc == DEF_instrin   || 
				tc == DEF_instrout     
				);
			break;
		default:
			sprintf(lexp_errbuf(lexp),"Unknown type vector");
			tok_error(lexp,lxp);
			}
		if (chk == 0) {
			char* pin_type;
			switch(typ) {
			case VCT_target:
				pin_type = "writable";
				break;
			case VCT_module:
				pin_type = "readable";
				break;
			case VCT_submod:
				pin_type = "external";
				break;
				}
			sprintf(lexp_errbuf(lexp),"'%s' pin expected",pin_type);
			tok_error(lexp,lxp);
			}
		chain_arg_list(link_tp,tp);
		tp = get_token(MYc 0,lxp);
		switch(token_id(tp)) {
		case ')': goto ret;
		case ',': break;
		default : 
			sprintf(lexp_errbuf(lexp),"',' or ')' expected");
			tok_error(lexp,lxp);
			}
		tp = get_token(MYc module_tp,lxp);
		}
ret:
	del_entity(my->tokecp,lxp);
	return link_tp;
	}


static expr* vector_translate_beh(tMYc expr* beh) {
	alloc_ctl* acp = my->behacp;
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* mtp = my->module_tp;
	token* tp;
	token* stp;
	expr* ep;
	token* target_tp;
	token* read_tp;
	uni_link* lp;
	uni_link* rlp;
	target_tp = get_vector_token(MYc my->module_tp,VCT_target);
	sfl_assert(lexp,OPR_eq_term);
	tp = get_token(MYc mtp,lxp);
	switch(token_id(tp)) {
	case DEF_instrself:
	case DEF_instrout:
		/*
		|	| [q([{,}]).(Ǐo[q{,Ǐo[q})
		|	| o͒[q([{,}]).(Ǐo[q{,Ǐo[q})
		*/
		sfl_assert(lexp,'(');
		/* !!!opr_arg(OPR_active,E_token,E_expr) */
		ep = instruct_active(MYc tp,beh);
		sfl_assert(lexp,')');
		sfl_assert(lexp,'.');
		read_tp = get_vector_token(MYc mtp, VCT_module);
		break;

	case DEF_submod:		/* TuW[ */
		/*
		|	| TuW[.͒[q([{,}]).(ǏoTu[q{,ǏoTu[q})
		*/
		sfl_assert(lexp,'.');
		stp = get_token(MYc tp,lxp);
		switch(stp->id) {
		case DEF_instrin:
			/* ( [{,}] ) */
			sfl_assert(lexp,'(');
			/* !!!opr_arg(OPR_active,E_token,E_expr) */
			ep = instruct_active(MYc stp,beh);
			sfl_assert(lexp,')');
			sfl_assert(lexp,'.');
			read_tp = get_vector_token(MYc tp, VCT_submod);
			break;
		default:
			sprintf(lexp_errbuf(lexp),"'input', 'bidirect' or 'instrin' expected (sub)");
			tok_error(lexp,lxp);
			}
		break;
	default:
		sprintf(lexp_errbuf(lexp),"'instrout' or 'instrself' expected (mod)");
		tok_error(lexp,lxp);
		break;
		}
	lp = target_tp->arg, rlp = read_tp->arg ;
	for ( ; lp != 0 && rlp != 0 ; lp = lp->np, rlp = rlp->np) {
		token* ttp = lp->ap;
		token* rtp = rlp->ap;
		if (ttp->figure != rtp->figure) {
			sprintf(lexp_errbuf(lexp),"%s(3) (fig_1=%u, fig_2=%u)",
					Err_figure, ttp->figure, rtp->figure);
			tok_error(lexp,lxp);
			}
		}
	if (lp != 0 || rlp != 0) {
		sprintf(lexp_errbuf(lexp),"vector element count mismatch. (left=%u, right=%u)",
				target_tp->figure,read_tp->figure);
		tok_error(lexp,lxp);
		}

	/* !!!opr_arg(OPR_value,E_token,E_expr) */
	ep = new_expr(mtp->acp,OPR_value,read_tp->figure,(expr*)read_tp,ep,beh);
	/* REFERENCE: OPR_eq_term */
	for (lp = read_tp->arg ; lp != 0 ; lp = lp->np) {
		token* ttp = lp->ap;
		append_expr_ulink(acp,&(ttp->reference),ep);
		}

	/* !!!opr_arg(OPR_eq_term,E_token,E_expr) */
	ep = new_expr(mtp->acp,OPR_eq_term,target_tp->figure,(expr*)target_tp,ep,beh);
	/* TRANSLATE: OPR_eq_term */
	for (lp = target_tp->arg ; lp != 0 ; lp = lp->np) {
		token* ttp = lp->ap;
		append_expr_ulink(acp,&(ttp->translate),ep);
		}

	Ex_vector_translate_beh(target_tp);
	del_entity(my->tokecp,lxp);
	return ep;
	}


/*****************************************************************************/
/* ========================================================================= */
/* =====   `̍\                                          ===== */
/* ========================================================================= */
/*****************************************************************************/


#define all_oparg \
	opr_arg(OPR_behavior,E_expr ,E_filoc)\
	opr_arg(OPR_expand  ,E_expr ,E_long1)\
	opr_arg(OPR_0expand ,E_expr ,E_long1)\
	opr_arg(OPR_and     ,E_expr ,E_expr )\
	opr_arg(OPR_plus    ,E_expr ,E_expr )\
	opr_arg(OPR_minus   ,E_expr ,E_expr )\
	opr_arg(OPR_multi,   E_expr ,E_expr )\
	opr_arg(OPR_divide  ,E_expr ,E_expr )\
	opr_arg(OPR_residue ,E_expr ,E_expr )\
	opr_arg(OPR_decode  ,E_expr ,0      )\
	opr_arg(OPR_partial ,E_expr ,E_long2)\
	opr_arg(OPR_eq_term ,E_token,E_expr )\
	opr_arg(OPR_xor     ,E_expr ,E_expr )\
	opr_arg(OPR_encode  ,E_expr ,0      )\
	opr_arg(OPR_invert  ,E_expr ,0      )\
	opr_arg(OPR_or      ,E_expr ,E_expr )\
	opr_arg(OPR_active  ,E_token,E_expr )\
	opr_arg(OPR_alt     ,E_expr ,E_expr )\
	opr_arg(OPR_any     ,E_expr ,E_expr )\
	opr_arg(OPR_bit_xor ,E_expr ,0      )\
	opr_arg(OPR_bit_and ,E_expr ,0      )\
	opr_arg(OPR_bit_or  ,E_expr ,0      )\
\
	opr_arg(OPR_lognot  ,E_expr ,0      )\
	opr_arg(OPR_incre   ,E_expr ,0      )\
	opr_arg(OPR_decre   ,E_expr ,0      )\
\
	opr_arg(OPR_bracket ,E_expr ,0      )\
	opr_arg(OPR_call    ,E_token,E_expr )\
	opr_arg(OPR_catinate,E_expr ,E_expr )\
	opr_arg(OPR_logand  ,E_expr ,E_expr )\
	opr_arg(OPR_if_cond ,E_expr ,E_expr )\
	opr_arg(OPR_cmp_eq  ,E_expr ,E_expr )\
	opr_arg(OPR_cmp_ne  ,E_expr ,E_expr )\
	opr_arg(OPR_cmp_gt  ,E_expr ,E_expr )\
	opr_arg(OPR_cmp_ge  ,E_expr ,E_expr )\
	opr_arg(OPR_cmp_lt  ,E_expr ,E_expr )\
	opr_arg(OPR_cmp_le  ,E_expr ,E_expr )\
	opr_arg(OPR_eq_reg  ,E_token,E_expr )\
	opr_arg(OPR_finish  ,E_token,0      )\
	opr_arg(OPR_generate,E_token,E_expr )\
	opr_arg(OPR_goto    ,E_token,E_token)\
	opr_arg(OPR_if      ,E_expr ,E_expr )\
	opr_arg(OPR_exp_link,E_expr ,E_expr )\
	opr_arg(OPR_memory  ,E_token,E_expr )\
	opr_arg(OPR_mem_rd  ,E_token,E_expr )\
	opr_arg(OPR_mem_wt  ,E_expr ,E_expr )\
	opr_arg(OPR_par     ,E_expr ,E_expr )\
	opr_arg(OPR_relay   ,E_expr ,E_expr )\
	opr_arg(OPR_rel_task,E_token,E_token)\
	opr_arg(OPR_ret_stat,E_token,E_token)\
	opr_arg(OPR_ret_void,E_token,E_token)\
	opr_arg(OPR_return  ,E_token,0      )\
	opr_arg(OPR_sfln    ,E_token,E_char )\
	opr_arg(OPR_sft_l   ,E_expr ,E_expr )\
	opr_arg(OPR_sft_r   ,E_expr ,E_expr )\
	opr_arg(OPR_value   ,E_token,E_expr )\
	opr_arg(OPR_void    ,0      ,0      )


enum {
	E_expr = 1,
	E_token,
	E_filoc,
	E_long1,
	E_long2,
	E_char,
	};


#define opr_arg(opr,t1,t2) case opr: *op1=t1; *op2=t2; break;


static void expr_arg_type(int opr, int* op1, int* op2) {
	switch(opr) {
	all_oparg
	default:
		sprintf(serr_buf,"expr_arg_type() unknown (type=%d)\n",opr);
		sys_error(0);
		}
	}


/* ========================================================================= */
/* =====   `\̈vmF                                      ===== */
/* ========================================================================= */


ENTRY char* expr_location(expr *beh) {
	fileloc* locp;
	char* buf = get_looped_buf(0);
	for ( ; beh != 0 ; beh = beh->beh) {
		if (beh->opr == OPR_behavior) {
			locp = (fileloc*)(beh->op2);
			if (locp == 0) break;
			sprintf(buf,"(%s -%d)",symcate_name(locp->file),locp->line);
			return buf;
			}
		}
	return "";
	}


static answer same_exp_fail(lex* lexp,char* mess) {
	char* buf = get_looped_buf(512);
	sprintf(buf,"\n    %s : %s",mess,lexp->errbuf);
	sprintf(lexp->errbuf,"%s",buf);
	return FAIL;
	}


	static answer assert_expr_op(lex* lexp, int typ, expr* dep, expr* sep);


ENTRY answer same_exp_assert(lex* lexp, expr* dep, expr* sep) {
	int op1;
	int op2;
	footmark("same_exp_assert");
	if (sep == 0) {
		if (dep == 0) return GOOD;
		return same_exp_fail(lexp,"unbalance expression");
		}
	if (dep == 0) {
		return same_exp_fail(lexp,"unbalance expression");
		}
	if (dep->opr != sep->opr) {
		char* buf = get_looped_buf(512);
		sprintf(buf,"operation mismatch (%s != %s)",type_name(sep->opr),type_name(dep->opr));
		return same_exp_fail(lexp,buf);
		}
	expr_arg_type(sep->opr, &op1, &op2);
	if (op2 == E_filoc) {
		if (assert_expr_op(lexp,op2,dep->op2,sep->op2) == FAIL) return FAIL;
		if (assert_expr_op(lexp,op1,dep->op1,sep->op1) == FAIL) return FAIL;
		}
	else {
		if (assert_expr_op(lexp,op1,dep->op1,sep->op1) == FAIL) return FAIL;
		if (assert_expr_op(lexp,op2,dep->op2,sep->op2) == FAIL) return FAIL;
		}
	return GOOD;
	}


static answer assert_expr_op(lex* lexp, int typ, expr* dep, expr* sep) {
	uni_link* dlp;
	uni_link* slp;
	token* dtp;
	token* stp;
	long*  dvp;
	long*  svp;
	footmark("assert_expr_op");
	if (sep == 0) {
		if (dep == 0) return GOOD;
		return same_exp_fail(lexp,"unbalance expression");
		}
	switch(typ) {
	case 0:
		if (dep == 0) {
			return same_exp_fail(lexp,"unbalance expression");
			}
		if (dep != sep) {
			return same_exp_fail(lexp,"unbalance expression");
			}
		break;
	case E_expr:
		return same_exp_assert(lexp,dep,sep);
	case E_token:
		dtp = (token*)dep;
		stp = (token*)sep;
		if (dtp->id != stp->id || dtp->toksym != stp->toksym) {
			char* buf = get_looped_buf(512);
			sprintf(buf,"operand mismatch (%s != %s) : ",
				token_name(dtp),token_name(stp) );
			return same_exp_fail(lexp,buf);
			}
		if (dtp->id != DEF_vector) break;
		dlp = dtp->arg;
		slp = stp->arg;
		for ( ; dlp != 0 && slp != 0 ; dlp = dlp->np , slp = slp->np) {
			if (assert_expr_op(lexp,E_token,(expr*)(dlp->ap),(expr*)(slp->ap)) == FAIL) return FAIL;
			}
		break;
	case E_filoc:
		{	fileloc* dp = (fileloc*)dep;
			fileloc* sp = (fileloc*)sep;
			lexp_errclr(lexp);
			/* G[̂߂ɁA݈ʒuL^Ă */
			sprintf(lexp_errbuf(lexp),"(%s -%d), (%s -%d)",
				symcate_name(sp->file),sp->line,
				symcate_name(dp->file),dp->line 
				);
			}
		break;
	case E_long1:
		dvp = (long*)dep;
		svp = (long*)sep;
		if (*dvp != *svp) {
			char* buf = get_looped_buf(512);
			sprintf(buf,"value-error (%ld != %ld)",*dvp,*svp);
			return same_exp_fail(lexp,buf);
			}
		break;
	case E_long2:
		dvp = (long*)dep;
		svp = (long*)sep;
		if (*dvp != *svp) {
			char* buf = get_looped_buf(512);
			sprintf(buf,"value-error (%ld != %ld)",*dvp,*svp);
			return same_exp_fail(lexp,buf);
			}
		if (*(dvp+1) != *(svp+1)) {
			char* buf = get_looped_buf(512);
			sprintf(buf,"value-error (%ld != %ld)",*(dvp+1),*(svp+1));
			return same_exp_fail(lexp,buf);
			}
		break;
	case E_char:
		if (dep != sep) {
			char* buf = get_looped_buf(512);
			sprintf(buf,"string-error (%s != %s)",(char*)dep,(char*)sep);
			return same_exp_fail(lexp,buf);
			}
		break;
		}
	return GOOD;
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


