/*
 *  notice: japanese
 *@쌠҂̍mF
 *@@uf[^TCgJvOgp@QŁv
 *@@ɋLڂ́uvOvƓɎ舵ĒƂɁA
 *@@{hLg̉{EpEۊǂF߂܂B
 */

/*
 * ps_sflrd.c
 *
 * sflread command execution.
 * Version 1.10 Beta   Date 1999.5.8
 * Copyright (c) Datasight Corp., 1996-1999.
 * All Rights Reserved.
 * Made by A.Nakashima
 *
 */


#define foot_on 0
#include "ps_selec.h"
#include "ps_misc.h"
#include "ps_lex.h"
#include "ps_strct.h"
#include "ps_tdef.h"
#include "ps_proto.h"


#if defined(EXTRA)
#	define Ex_sflrd
#	include "extra.h"
#	endif


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


#if !defined(Ex_sflrd_my_clear)
#	define Ex_sflrd_my_clear
#	define Ex_sflrd_mod_tok_setup
#	define Ex_sflrd_submod_tok_setup(set_tp) 
#	endif


/*****************************************************************************/
/* ========================================================================= */
/* =====   V{`                                              ===== */
/* ========================================================================= */
/*****************************************************************************/


static  char* def_name(int typ);


#undef def_key
#undef beh_key
#undef opr_key
#define def_key(key) case KEY_##key: return "K_" #key;
#define beh_key(key) case KEY_##key: return "K_" #key;
#define opr_key(key) case KEY_##key: return "K_" #key;


ENTRY char* type_name(int typ) {
	switch(typ) {
	sfl_key
		}
	return def_name(typ);
	}


#undef def_key
#undef beh_key
#undef opr_key
#define def_key(key) case DEF_##key: return #key;
#define beh_key(key) 
#define opr_key(key) 


static  char* def_name(int typ) {
	switch(typ) {
	sfl_key
	case LEX_SYM:     return "symbol";
	case LEX_NUM:     return "number";
	case TPL_module:  return "module template";
	case TPL_circuit: return "circuit template";
	case TPL_declare: return "declare template";
	case DEF_submod:  return "submod";
		}
	return opr_name(typ);
	}


ENTRY char* tok_id_name(token* tp) {
	return type_name(token_id(tp));
	}


#undef def_key
#undef beh_key
#undef opr_key
#define def_key(key) {#key,KEY_##key},
#define beh_key(key) {#key,KEY_##key},
#define opr_key(key) {#key,KEY_##key},


key_word sfl_key_tbl[] = {
	sfl_key
	{"submod_type",KEY_declare},
	{"circuit_type",KEY_circuit},
	{"",0}
	};


#undef  def_sign
#define def_sign(s,c) {s,c},

key_word char_opr_tbl[] = {
	all_sign
	{"",0}
	};


#undef  def_opr
#undef  def_sign
#define def_opr(s,c,p) case c: return s;
#define def_sign(s,c) 

#undef def_key
#undef beh_key
#undef opr_key
#undef str_opr

#define def_key(key) 
#define beh_key(key) 
#define opr_key(key) case OPR_##key: return #key;
#define str_opr(key) case OPR_##key: return #key;



ENTRY char* element_opr_name(int opr) {
	switch(opr) {
	element_opr
		}
	return "Unknown opr name";
	}

ENTRY char* mono_opr_name(int opr) {
	switch(sflspec_no) {
	case 1:
		switch(opr) {
		v1_mono_expr_opr
		case OPR_0expand: return "0expand";
			}
		break;
	case 2:
		switch(opr) {
		v2_mono_expr_opr
		case OPR_0expand: return "0expand";
			}
		break;
		}
	return element_opr_name(opr);
	}

ENTRY char* expr_opr_name(int opr) {
	switch(sflspec_no) {
	case 1:
		switch(opr) {
		v1_expression_opr
			}
		break;
	case 2:
		switch(opr) {
		v2_expression_opr
			}
		break;
		}
	return mono_opr_name(opr);
	}

ENTRY char* beh_opr_name(int opr) {
	switch(opr) {
	behavior_opr
		}
	return expr_opr_name(opr);
	}

ENTRY char* decl_opr_name(int opr) {
	switch(opr) {
	declare_opr
		}
	return beh_opr_name(opr);
	}


ENTRY char* opr_name(int opr) {
	switch(opr) {
	all_stropr
	sfl_key
	case LEX_SYM   : return "symbol";
	case LEX_NL    : return "newline";
	case LEX_SPC   : return "space";
	case LEX_CHR   : return "char code";
	case LEX_STR   : return "string";
	case LEX_SQT   : return "single quote";
	case LEX_WQT   : return "double quote";
	case LEX_NUM   : return "number";
	case LEX_SFLN  : return "SFL number";
		}
	return decl_opr_name(opr);
	}


/* ------------------------ */


ENTRY void teach_key_dict(lex* lexp, token* ktp, key_word* tbl) {
	token tok;
	token* tp;
	int set_flg;
	int i;
	footmark("teach_key_dict");
	if (ktp == 0) {
		sprintf(lexp_errbuf(lexp),"teach_key_dict ktp == 0");
		lex_error(lexp,ERR_system);
		}
	tp = &tok;
	memset(tp,0,sizeof(*tp));
	tp->id = SFL_key;
	for (i = 0 ; tbl[i].word[0] != 0 ; ++i) {
		tp->tokren = tp->toksym = symbol_lookup(lexp,tbl[i].word);
		token_id(tp) = tbl[i].key;
		set_flg = 1;
		token_lookup(ktp,tp,&set_flg);
		}
	}


/* ========================================================================= */
/* =====  ߃vǑĂяo                                     ===== */
/* ========================================================================= */


#undef  def_opr
#define def_opr(s,c,p) {s,c},

key_word declare_opr_tbl[] = {
	declare_opr
	{"",0}
	};
key_word behavior_opr_tbl[] = {
	behavior_opr
	{"",0}
	};
key_word v1_expression_opr_tbl[] = {
	v1_expression_opr
	{"",0}
	};
key_word v2_expression_opr_tbl[] = {
	v2_expression_opr
	{"",0}
	};
key_word v1_mono_expr_opr_tbl[] = {
	v1_mono_expr_opr
	{"",0}
	};
key_word v2_mono_expr_opr_tbl[] = {
	v2_mono_expr_opr
	{"",0}
	};
key_word element_opr_tbl[] = {
	element_opr
	{"",0}
	};
key_word num_expr_opr_tbl[] = {
	num_expr_opr
	{"",0}
	};


word_dict* declare_opr_dict[2];
word_dict* behavior_opr_dict[2];
word_dict* expression_opr_dict[3];
word_dict* mono_expr_opr_dict[3];
word_dict* element_opr_dict[2];
word_dict* number_opr_dict;

int control_num_spec = 3;



ENTRY void attach_opr_dict(alloc_ctl* acp) {
	/* SFL spec V1 */
	declare_opr_dict[0]    = teach_word_dict(acp,declare_opr_tbl);
	behavior_opr_dict[0]   = teach_word_dict(acp,behavior_opr_tbl);
	expression_opr_dict[0] = teach_word_dict(acp,v1_expression_opr_tbl);
	mono_expr_opr_dict[0]  = teach_word_dict(acp,v1_mono_expr_opr_tbl);
	element_opr_dict[0]    = teach_word_dict(acp,element_opr_tbl);
	/* SFL spec V2 */
	declare_opr_dict[1]    = declare_opr_dict[0];
	behavior_opr_dict[1]   = behavior_opr_dict[0];
	expression_opr_dict[1] = teach_word_dict(acp,v2_expression_opr_tbl);
	mono_expr_opr_dict[1]  = teach_word_dict(acp,v2_mono_expr_opr_tbl);
	element_opr_dict[1]    = element_opr_dict[0];
	/* constant expression(V3) */
	control_num_spec = 3;
	expression_opr_dict[2] = teach_word_dict(acp,v2_expression_opr_tbl);
	mono_expr_opr_dict[2]  = teach_word_dict(acp,v2_mono_expr_opr_tbl);

	number_opr_dict = teach_word_dict(acp,num_expr_opr_tbl);
	}


static token* source_reader(
	tMYc 
	word_dict* opr_tblp,	/* Iy[VL̎ */
	token* parent,
	int    def_typ,
	token* (*reader)(tMYc token*, int, token*)
){
	lex* lexp = my->sfllexp;
	token* tp;
	word_dict* save_tblp;
	jmp_buf* save_jbp = my->jmpbfp;
	jmp_buf jbuf;
	int rtc;
	save_tblp = lexp->opr_tblp;
	my->jmpbfp = &jbuf;
	rtc = setjmp(jbuf);
	if (rtc == 0) {
		/* ւ */
		lexp->opr_tblp = opr_tblp;	/* char operator */
		tp = (*reader)(MYc parent,def_typ,0);
		}
	lexp->opr_tblp = save_tblp;
	my->jmpbfp = save_jbp;
	if(rtc != 0) {
		/* ُI */
		longjmp(*(my->jmpbfp),rtc);
		}
	return tp;
	}


/*****************************************************************************/
/* ######################################################################### */
/* #####  SFL syntax                                                   ##### */
/* ######################################################################### */
/*****************************************************************************/
;

/* ========================================================================= */
/* =====   SFLLq̉                                             ===== */
/* ========================================================================= */


/*
| SFLLq ::= { W[̐錾 | W[̒` | @\H̒` }
*/


	static token* define_declare(tMYc token* declare_tp, int def_typ,token* mod_tp);
	static token* define_module(tMYc token* class_tp, int def_typ, token* mod_tp);
	void dsp_instr_expr(tMYc token* mtp, FILE* spkfp);

static void describe_sfl(tMY) {
	lex*    lexp = my->sfllexp;
	token*  lxp = new_entity(my->tokecp);
	token*  tp;
	token*  mtp;
	time_t  rd_time;
	footmark("describe_sfl");
	time(&rd_time);
	cmd_lexp = lexp;					/* %%% attention !!! */
	forever {
		my->define_tp = 0;				/* define start */
		my->max_figure = word_bitsiz;	/* module̍őlT */
		Ex_sflrd_my_clear
		lexp->sflacp = 0;				/* f[^`̓o^iIj */
		my->cond_cnt = 0;				/* ̃JE^ */
		lexp->tplhash = 0;				/* clear template argument table */
		tp = get_token(MYc my->sflkey_tp,lxp);
		switch(token_id(tp)) {
		case KEY_declare:
			lexp->sflacp = new_mactl();
			mtp = source_reader(MYc declare_opr_dict[lexp->sflspec - 1],
				my->declare_tp,DEF_declare,define_declare);
			if (mtp != 0) {
				set_mod_max_fig(mtp,my->max_figure);
				with_toksym_alias(MYc mtp);
				}
			continue;
		case KEY_module:
			lexp->sflacp = new_mactl();
			mtp = source_reader(MYc declare_opr_dict[lexp->sflspec - 1],
				my->class_tp,DEF_module,define_module);
			break;
		case KEY_circuit:
			lexp->sflacp = new_mactl();
			mtp = source_reader(MYc declare_opr_dict[lexp->sflspec - 1],
				my->class_tp,DEF_circuit,define_module);
			break;
		case LEX_EOF:
			goto ret;
		default:
			sprintf(lexp_errbuf(lexp),"'declare', 'module' or 'circuit' keyword expected");
			tok_error(lexp,lxp);
			}
		if (mtp == 0) continue;
		component_table(mtp);
		with_toksym_alias(MYc mtp);
		Ex_sflrd_mod_tok_setup
		/* %%% EXTRA
		dsp_instr_expr(MYc mtp, stdout);
		*/
		}
ret:
	clear_sflacp(lexp);
	del_entity(my->tokecp,lxp);
	}


ENTRY void sflread(tMYc char* fname, int argc, char** args) {
	new_source(my->cmdlexp,my->sfllexp,READ_FILE,fname,'$',argc,args);
	describe_sfl(MY);	/* sflread */
	close_all_sfp(my->sfllexp);
	}


/* ========================================================================= */
/* =====  W[̐錾                                             ===== */
/* ========================================================================= */


/*
|W[̐錾 ::=
|	declare W[ '{
|		{O[q̒`}
|		{험p̐[q̉̒`}
|	'}
*/


#define L_tpl_ang '<'
#define R_tpl_ang '>'


#define describe_behavior describe_rd_behavior


static void set_token_env(token* tp, mod_def_env* ep) {
	component* cp = component_table(tp);
	cp->first = (token*)ep;
	}


	static int describe_exterm(tMYc token*);
	static int describe_instrin_arg(tMYc token*);


static token* define_declare(tMYc token* declare_tp, int def_typ,token* mod_tp) {
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* tp;
	token* now_tp;
	token* set_tp;
	int tc;
	int set_flg;
	footmark("define_declare");
	/* ev[g̃CX^XH */
	if (mod_tp != 0) {
		/* ev[g`̑s */
		set_tp = mod_tp;
		*lxp = *set_tp;
		goto def;
		}
	/* ʏ̃W[̐錾Jn */
	tp = get_token(MYc declare_tp,lxp);
	switch(tc = token_id(tp)) {
	case LEX_SYM:
		/* VK̒`Ȃ̂ŁAVo^邱Ƃw */
		set_flg = 1;
		break;
	case DEF_declare:
	case TPL_declare:
		/* Ē`Ȃ̂ŁAo^ȂƂw */
		set_flg = 0;
		/* O̒`L^ */
		now_tp = tp;
		break;
	default:
		sprintf(lexp_errbuf(lexp),"'%s' name expected",type_name(def_typ));
		tok_error(lexp,lxp);
		}

	/* `g[Nm */
	if (set_flg) set_tp = new_token(lexp->sflacp,DEF_declare,lxp);
	else         set_tp = new_token(my->tmpacp,DEF_declare,lxp);

	if (next_tokcode(lexp) == L_tpl_ang) {
		mod_def_env*  envp;
		/* L[[hev[g`w肵Ă */
		switch(tc) {
		case LEX_SYM:
		case TPL_declare:
			/* VK̒`A܂́AO̒`ev[g`Ȃnj */
			break;
		case DEF_declare:
			sprintf(lexp_errbuf(lexp),"conflict.2 with %s",token_location(now_tp));
			tok_error(lexp,lxp);
			}
		/* ev[g` */
		get_arg_link_of_token(MYc set_tp,LEX_SYM, L_tpl_ang, R_tpl_ang);
		set_tp->id = TPL_declare;
		envp = save_my_env_at_define(MYc set_tp->acp);
		set_token_env(set_tp,envp);
		/* {W[̖{̒`L^ */
		record_template(MYc set_tp,envp);
		goto set;
		}
def:
	{
		token* save_mod_tp;
		token* save_def_tp;
		int anything;
		/* W[錾̊Jn */
		save_mod_tp = my->module_tp;
		save_def_tp = my->define_tp;
		my->module_tp = set_tp;
		my->define_tp = set_tp;
		sfl_assert(lexp,'{');
		anything = 1;
		while (anything) {
			anything = 0;
			/* {O[q̒`} */
			while(describe_exterm(MYc set_tp)) anything = 1;
			/* {험p̐[q̉̒`} */
			while(describe_instrin_arg(MYc set_tp)) anything = 1;
			}
		sfl_assert(lexp,'}');
		Ex_sflrd_submod_tok_setup(set_tp);
		my->module_tp = save_mod_tp;
		my->define_tp = save_def_tp;
		}
set:
	/* W[̓o^ */
	if (set_flg) {
		/* VK`̂ŁÃg[No^B */
		set_flg = 0;		/* set_tp ̂܂܎gp */
		token_lookup(declare_tp,set_tp,&set_flg);
		if (set_flg == 0) {		/* o^Ȃ */
			sprintf(lexp_errbuf(lexp),"%s registration fail",type_name(def_typ));
			tok_error(lexp,lxp);
			}
		}
	else {
		/* Ē`̂ŁAO̒`Ɠł邱ƂmFB*/
		check_dup_member(MYc set_flg,now_tp,set_tp);
		set_tp = 0;
		}
	del_entity(my->tokecp,lxp);
	return set_tp;
	}


/*
|O[q̒` ::=
|	  input    f[^͒[q['<rbg '>]{,f[^͒[q['<rbg'>]};
|	| output   f[^o͒[q['<rbg '>]{,f[^o͒[q['<rbg '>]};
|	| bidirect f[^o[q['<rbg '>]{,f[^o[q['<rbg '>]};
|	| instrin  ͒[q{,͒[q};
|	| instrout o͒[q{,o͒[q};
*/


	static void rep_define_element(tMYc token*,int,int);


static int describe_exterm(tMYc token* module_tp) {
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* tp;
	int rtc = 1;
	footmark("describe_exterm");
	tp = get_token(MYc my->sflkey_tp,lxp);
	switch(token_id(tp)) {
	case KEY_input:
		rep_define_element(MYc module_tp,DEF_input,0);
		break;
	case KEY_output:
		rep_define_element(MYc module_tp,DEF_output,0);
		break;
	case KEY_bidirect:
		rep_define_element(MYc module_tp,DEF_bidirect,0);
		break;
	case KEY_instrin:
		rep_define_element(MYc module_tp,DEF_instrin,1);
		break;
	case KEY_instrout:
		rep_define_element(MYc module_tp,DEF_instrout,1);
		break;
	default:
		unget_token(lexp,lxp);
		rtc = 0;
		}
	del_entity(my->tokecp,lxp);
	return rtc;
	}



static token* seek_token_in_group(tMYc token* gtp,token* tp) {
	token tok = *tp;
	int set_flg = 0;
	tok.id = LEX_SYM;
	return token_lookup(gtp, &tok, &set_flg);
	}


static void seek_token_arg_by_declare(tMYc token* module_tp,token* link_tp) {
	lex*   lexp = my->sfllexp;
	token* sub_mtp;
	token* sub_ltp;
	token* ptp;
	token* tp;
	uni_link* lp;
	footmark("seek_token_arg_by_declare");

	/* w̃W[ɑΉdeclare錾邩 */
	sub_mtp = seek_token_in_group(MYc my->declare_tp,module_tp);
	if (sub_mtp == 0) return;	/* declare錾Ȃ */

	/* declare錾ɁAwlink[q邩 */
	sub_ltp = seek_token_in_group(MYc sub_mtp,link_tp);
	if (sub_ltp == 0) return;	/* link[qȂ */

	/* declarelink[qɃA[Mgw肳Ă邩 */
	if (sub_ltp->arg == 0) return;	/* A[MgȂ */

	for (lp = sub_ltp->arg ; lp != 0 ; lp = lp->np) {
		ptp = (token*)(lp->ap);
		tp = seek_token_in_group(MYc module_tp,ptp);
		if (tp == 0) {
			sprintf(lexp_errbuf(lexp),"%s missing",token_location(ptp));
			tok_error(lexp,link_tp);
			}
		chain_arg_list(link_tp,tp);
		}
	}


/*
|f[^͒[q['<rbg '>] { , f[^͒[q['<rbg'>] } ;
*/

	static void   define_token_argument(tMYc token* module_tp,token* tp,int typ);
	static token* define_arg_of_token(tMYc token* module_tp,int typ);

static void rep_define_element(tMYc token* module_tp, int typ, int width) {
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* tp;
	token* stp;
	token* ktp;
	long value;
	component* cp;
	footmark("rep_define_element");
	forever {
/* %%% */
		tp = get_token(MYc module_tp,lxp);
		if (token_id(tp) == DEF_submod) {
			/* TuW[ɑ΂` */
			sfl_assert(lexp,'.');
			switch(typ) {
			case DEF_instrin:
				/* ̏㏑ */
				define_arg_of_token(MYc tp,DEF_instrin);
				break;
			case DEF_instrout:
				tp = get_token(MYc tp,lxp);
				if (token_id(tp) != typ) {
					sprintf(lexp_errbuf(lexp),"'%s' expected",type_name(typ));
					tok_error(lexp,lxp);
					}
				ktp = get_token(MYc 0,lxp);
				if (token_id(ktp) != '{') {
					sprintf(lexp_errbuf(lexp),"'{' expected");
					tok_error(lexp,lxp);
					}
				cp = component_table(tp);
				if (cp->behavior != 0) {
					sprintf(lexp_errbuf(lexp),"re-definition behavior at %s",expr_location(cp->behavior));
					tok_error(lexp,lxp);
					}
				while (describe_behavior(MYc tp)) ;
				sfl_assert(lexp,'}');
				goto ret;
			default:
				sprintf(lexp_errbuf(lexp),"instrin pin expected");
				tok_error(lexp,lxp);
				}
			}
		else {
			/* W[ɑ΂` */
			unget_token(lexp,lxp);
			tp = define_new_member(MYc module_tp,typ);
			tp->figure = 1;
			switch(width) {
			case 1:
				if (next_tokcode(lexp) == '(') {
					/* W[̃s`ɃA[Mgw肵 */
					define_token_argument(MYc module_tp,tp,typ);
					}
				else {;
					/* A[Mg̎w肪̂declareT */
					seek_token_arg_by_declare(MYc module_tp,tp);
					}
				switch(typ) {
				case DEF_instrin:
				case DEF_instrself:
					ktp = get_token(MYc 0,lxp);
					if (token_id(ktp) != '{') {
						unget_token(lexp,lxp);
						break;
						}
					cp = component_table(tp);
					if (cp->behavior != 0) {
						sprintf(lexp_errbuf(lexp),"re-definition behavior at %s",expr_location(cp->behavior));
						tok_error(lexp,lxp);
						}
					while (describe_behavior(MYc tp));
					sfl_assert(lexp,'}');
					goto ret;
					}
				break;
			default:
				ktp = get_token(MYc 0,lxp);
				if (ktp->id != '<') {
					unget_token(lexp,lxp);
					break;
					}
				/* rbg 𓾂 */
				value = get_bit_order(lexp,"bit-width",1);
				tp->figure = (unsigned int)value;	/* rbgݒ */
				if (my->max_figure < tp->figure) my->max_figure = tp->figure;
				sfl_assert(lexp,'>');
				}
			}
		ktp = get_token(MYc 0,lxp);
		switch(ktp->id) {
		case ';': goto ret;
		case ',': break;
		default : 
			sprintf(lexp_errbuf(lexp),"';' expected");
			tok_error(lexp,lxp);
			}
		}
ret:
	del_entity(my->tokecp,lxp);
	}


/*
|험p̐[q̉̒` ::=
|	instr_arg ͒[q([͂ƂȂ[q{,͂ƂȂ[q}]);
*/


static int describe_instrin_arg(tMYc token* module_tp) {
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* tp;
	int rtc = 1;
	footmark("describe_instrin_arg");
	tp = get_token(MYc my->sflkey_tp,lxp);
	switch(token_id(tp)) {
	case KEY_instr_arg:
		define_arg_of_token(MYc module_tp,DEF_instrin);
		break;
	default:
		unget_token(lexp,lxp);
		rtc = 0;
		goto ret;
		}
	sfl_assert(lexp,';');
ret:
	del_entity(my->tokecp,lxp);
	return rtc;
	}


/*
|험p̐[q̉̒` ::=
|	instr_arg ͒[q([͂ƂȂ[q{,͂ƂȂ[q}]);
*/


/*
|[q̉̒` ::=
|	  instr_arg o͒[q([o͂ƂȂ[q{,o͂ƂȂ[q}]);
|	| instr_arg [q([f[^[q{,f[^[q}]);
|	| instr_arg TuW[.͒[q([͂ƂȂ[q{,͂ƂȂ[q}]);
||͂ƂȂ[q ::=
|	  f[^͒[q
|	| f[^o[q
||o͂ƂȂ[q ::=
|	  f[^o͒[q
|	| f[^o[q
*/


	static void define_argument(tMYc token*,token*,int);


static void define_token_argument(tMYc token* module_tp,token* tp,int typ) {
	lex* lexp = my->sfllexp;
	int arg;
	footmark("define_token_argument");
	switch(typ) {
	case DEF_task:      arg = DEF_reg;    break;
	case DEF_instrin:
		arg = DEF_input;
		if (token_id(module_tp) == DEF_submod) {
			if (get_arg_ovrwt(tp) == 0) {
				/* ܂㏑ĂȂȂA㏑ */
				set_arg_ovrwt(tp);
				tp->arg = 0;	/* ̃A[MgiNX̂́jNA */
				}
			}
		break;
	case DEF_instrout:  arg = DEF_output; break;
	case DEF_instrself: arg = DEF_sel;    break;
	default : 
		sprintf(lexp_errbuf(lexp),"Unknown type with argument");
		tok_error(lexp,tp);
		}
	define_argument(MYc module_tp,tp,arg);
	}


static token* define_arg_of_token(tMYc token* module_tp,int typ) {
	lex* lexp = my->sfllexp;
	token* save_tp = my->module_tp;
	token* lxp = new_entity(my->tokecp);
	token* tp;
	footmark("define_arg_of_token");
	my->module_tp = module_tp;
	tp = get_token(MYc module_tp,lxp);
	if (token_id(tp) != typ) {
		sprintf(lexp_errbuf(lexp),"'%s' expected",type_name(typ));
		tok_error(lexp,lxp);
		}
	define_token_argument(MYc module_tp,tp,typ);
	my->module_tp = save_tp;
	del_entity(my->tokecp,lxp);
	return tp;
	}


/* ========================================================================= */
/* =====  W[̒`                                             ===== */
/* ========================================================================= */


/*
|W[̒` ::=
|	module W[ '{
|		{W[̐錾}
|		{O[q̒`|\vf̒`}
|		{[q̉̒`}
|		{Xe[Wƃ^XNƉ̒`}
|		[ʓ̒`]
|		{[qɂ铮̒`}
|		{Xe[W̓菇̒`}
|	'}
*/

/* wstgseǵu菇̒`vĂ邩mFB */

static answer chk_stgseg_definition(token* stgseg_tp) {
	token* tp;
	component* cp;
	uni_link* lp;
	footmark("chk_stgseg_definition");
	if (stgseg_tp == 0) return FAIL;
	cp = stgseg_tp->comp_tbl;
	if (cp == 0) return FAIL;
	if (cp->behavior != 0) return GOOD;
	for (lp = cp->top ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		switch(token_id(tp)) {
		case DEF_segment_name:
		case DEF_state_name:
			return GOOD;
			}
		}
	return FAIL;
	}


static void chk_all_stage_definition(tMYc token* module_tp) {
	lex* lexp = my->sfllexp;
	token* tp;
	component* cp;
	uni_link* lp;
	footmark("chk_all_stage_definition");
	if (module_tp == 0) return;
	cp = module_tp->comp_tbl;
	if (cp == 0) return;
	for (lp = cp->top ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		switch(token_id(tp)) {
		case DEF_stage_name:
			if (chk_stgseg_definition(tp) == FAIL) {
				sprintf(lexp_errbuf(lexp),"stage definition missing");
				tok_error(lexp,tp);
				}
			}
		}
	}


	static int describe_declare(tMY);
	static int describe_element(tMYc token*);
	static int describe_instr_arg(tMYc token*);
	static int describe_stage_name(tMYc token*);
	static int describe_instruct(tMYc token*);
	static int describe_stage(tMYc token*);


static token* define_module(tMYc token* class_tp, int def_typ, token* mod_tp) {
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	int    set_flg = 1;
	token* save_tp;
	token* tp;
	token* now_tp;
	token* set_tp;
	int    tc;
	int    anything;
	footmark("define_module");
	/* ev[g̃CX^XH */
	if (mod_tp != 0) {
		/* ev[g`̑s */
		set_tp = mod_tp;
		*lxp = *set_tp;
		goto def;
		}
	/* ʏ̃W[`Jn */
	my->c_condp = 0;
	my->max_figure = 1;
	/* [@]FW[ '{ */
	tp = get_token(MYc class_tp,lxp);
	switch(tc = token_id(tp)) {
	case LEX_SYM:
		/* VK̒`Ȃ̂ŁAVo^邱Ƃw */
		set_flg = 1;
		break;
	case DEF_module:
	case TPL_module:
		if (def_typ != DEF_module) goto def_err;
		goto re_def;
	case DEF_circuit:
	case TPL_circuit:
		if (def_typ != DEF_circuit) goto def_err;
	re_def:
		/* Ē`Ȃ̂ŁAo^ȂƂw */
		set_flg = 0;
		/* O̒`L^ */
		now_tp = tp;
		break;
	default:
	def_err:
		sprintf(lexp_errbuf(lexp),"'%s' name expected",type_name(def_typ));
		tok_error(lexp,lxp);
		}

	/* `g[Nm */
	if (set_flg) set_tp = new_token(lexp->sflacp,def_typ,lxp);
	else         set_tp = new_token(my->tmpacp,def_typ,lxp);

	if (next_tokcode(lexp) == L_tpl_ang) {
		mod_def_env*  envp;
		/* L[[hev[g`w肵Ă */
		switch(tc) {
		case LEX_SYM:
		case TPL_module:
		case TPL_circuit:
			/* VK̒`A܂́AO̒`ev[g`Ȃnj */
			break;
		case DEF_module:
		case DEF_circuit:
			sprintf(lexp_errbuf(lexp),"conflict.3 with %s",token_location(now_tp));
			tok_error(lexp,lxp);
			}
		/* ev[g` */
		get_arg_link_of_token(MYc set_tp,LEX_SYM, L_tpl_ang, R_tpl_ang);
		set_tp->id = (def_typ == DEF_module) ? TPL_module : TPL_circuit;
		envp = save_my_env_at_define(MYc set_tp->acp);
		set_token_env(set_tp,envp);
		/* {W[̖{̒`L^ */
		record_template(MYc set_tp,envp);
		goto set;
		}
	/* ʏ̃W[` */
	switch(tc) {
	case LEX_SYM:
	case DEF_module:
	case DEF_circuit:
		/* VK̒`A܂́AO̒`ev[g`Ȃnj */
		break;
	case TPL_module:
	case TPL_circuit:
		sprintf(lexp_errbuf(lexp),"conflict.4 with %s",token_location(now_tp));
		tok_error(lexp,lxp);
		}
def:
	/* W[`̊Jn */
	set_tp->ipp = (void**)new_alloc(set_tp->acp,sizeof(void*)*TOKi_end);
	my->c_condp = new_bag(set_tp->acp);
	my->max_figure = 1;
	class_hashtbl = new_hashtbl(set_tp->acp);
	inst_hashtbl  = new_hashtbl(set_tp->acp);
	set_tp->ipp[TOKi_sfl_class] = class_hashtbl;
	set_tp->ipp[TOKi_sfl_inst ] = inst_hashtbl;
	save_tp = my->module_tp;
	my->module_tp = set_tp;
	my->define_tp = set_tp;
	sfl_assert(lexp,'{');
	/* {W[̐錾} */
	anything = 1;
	while(anything) {
		anything = 0;
		while(describe_declare(MY)) anything = 1;
		/* {O[q̒`|\vf̒`} */
		while(describe_exterm(MYc set_tp) || describe_element(MYc set_tp)) anything = 1;
		/* {[q̉̒`} */
		while(describe_instr_arg(MYc set_tp)) anything = 1;
		/* {Xe[Wƃ^XNƉ̒`} */
		while(describe_stage_name(MYc set_tp)) anything = 1;
		/* [ʓ̒`] */
		anything |= describe_behavior(MYc set_tp);
		/* {[qɂ铮̒`} */
		while(describe_instruct(MYc set_tp)) anything = 1;
		/* {Xe[W̓菇̒`} */
		while(describe_stage(MYc set_tp)) anything = 1;
		}
	sfl_assert(lexp,'}');
	chk_all_stage_definition(MYc set_tp);
	my->module_tp = save_tp;
	/* W[Ef[^̋L^ */
	set_mod_max_fig(set_tp,my->max_figure);
	set_tp->ipp[TOKi_cond_node] = my->c_condp;
set:
	/* W[̓o^ */
	if (set_flg) {
		/* VK`̂ŁÃg[No^B */
		set_flg = 0;		/* set_tp ̂܂܎gpiRs[Ȃj */
		token_lookup(class_tp,set_tp,&set_flg);
		if (set_flg == 0) {		/* o^Ȃ */
			sprintf(lexp_errbuf(lexp),"%s registration fail",type_name(def_typ));
			tok_error(lexp,lxp);
			}
		}
	else {
		/* ċK`̂ŁAO̒`Ɠł邱ƂmFB*/
		check_dup_member(MYc set_flg,now_tp,set_tp);
		set_tp = 0;
		}
	del_entity(my->tokecp,lxp);
	return set_tp;
	}


static int describe_declare(tMY) {
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* tp;
	int rtc = 1;
	footmark("describe_declare");
	tp = get_token(MYc my->sflkey_tp,lxp);
	switch(token_id(tp)) {
	case KEY_declare:
		define_declare(MYc my->declare_tp, DEF_declare, 0);
		break;
	default:
		unget_token(lexp,lxp);
		rtc = 0;
		}
	del_entity(my->tokecp,lxp);
	return rtc;
	}


/* ========================================================================= */
/* =====   @\H̒`                                              ===== */
/* ========================================================================= */


/*
|@\H̒` ::=
|	circuit @\H '{
|		{W[̐錾}
|		{O[q̒`|\vf̒`}
|		{[q̉̒`}
|		{Xe[Wƃ^XNƉ̒`}
|		[ʓ̒`]
|		{[qɂ铮̒`}
|		{Xe[W̓菇̒`}
|	'}
*/


/* define_circuit ́Adefine_module ɓ */;


/*****************************************************************************/
/* ========================================================================= */
/* =====   \vf`̎⊮                                    ===== */
/* ========================================================================= */
/*****************************************************************************/


static char* auto_task_name = "run_";



/* Xe[W̃^XN` */


static token* auto_def_task(tMYc token* module_tp,token* stage_tp) {
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* task_tp;
	int set_flg;
	lxp->loc = stage_tp->loc;
	lxp->figure = 1;
	lxp->toksym = lxp->tokren = symbol_lookup(lexp,auto_task_name);
	token_id(lxp) = DEF_task;
	set_flg = 1;
	task_tp = token_lookup(stage_tp, lxp, &set_flg);
	if (task_tp == 0) {
		sprintf(lexp_errbuf(lexp),"'%s' registration fail",type_name(DEF_task));
		tok_error(lexp,lxp);
		}
	del_entity(my->tokecp,lxp);
	return task_tp;
	}


/* Xe[W̎`ꂽ^XNT */


ENTRY token* seek_auto_task(tMYc token* stage_tp, int auto_def) {
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* task_tp;
	int set_flg;
	lxp->toksym = lxp->tokren = symbol_lookup(lexp,auto_task_name);
	token_id(lxp) = LEX_SYM;
	set_flg = 0;
	task_tp = token_lookup(stage_tp, lxp, &set_flg);
	if (task_tp == 0) {
		if (auto_def == 0) {
			sprintf(lexp_errbuf(lexp),"stage auto-task missing");
			tok_error(lexp,stage_tp);
			}
		/* `ꂽ^XN̂ŁAō */
		task_tp = auto_def_task(MYc my->module_tp,stage_tp);
		}
	del_entity(my->tokecp,lxp);
	return task_tp;
	}


ENTRY token* get_stage_name(tMYc token* module_tp) {
	lex*   lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* tp;
	tp = get_token(MYc module_tp,lxp);
	switch(token_id(tp)) {
	case LEX_SYM:
		/* Xe[W` */
		unget_token(lexp,lxp);
		tp = define_new_member(MYc module_tp,DEF_stage_name);
		auto_def_task(MYc module_tp,tp);
		break;
	case DEF_stage_name:
		break;
	default:
		sprintf(lexp_errbuf(lexp),"'%s' expected",type_name(DEF_stage_name));
		tok_error(lexp,lxp);
		}
	del_entity(my->tokecp,lxp);
	return tp;
	}


ENTRY token* get_segment_name(tMYc token* stage_tp) {
	lex*   lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* tp;
	tp = get_token(MYc stage_tp,lxp);
	switch(token_id(tp)) {
	case LEX_SYM:
		/* ߂Ă̏oȂ̂ŃZOg` */
		unget_token(lexp,lxp);
		tp = define_new_member(MYc stage_tp,DEF_segment_name);
		break;
	case DEF_segment_name:
		break;
	default:
		sprintf(lexp_errbuf(lexp),"'%s' expected",type_name(DEF_segment_name));
		tok_error(lexp,lxp);
		}
	del_entity(my->tokecp,lxp);
	return tp;
	}


ENTRY token* get_state_name(tMYc token* stgseg_tp) {
	lex*   lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* tp;
	tp = get_token(MYc stgseg_tp,lxp);
	switch(token_id(tp)) {
	case LEX_SYM:
		/* ߂Ă̏oȂ̂ŃXe[g` */
		unget_token(lexp,lxp);
		tp = define_new_member(MYc stgseg_tp,DEF_state_name);
		break;
	case DEF_state_name:
		break;
	default:
		sprintf(lexp_errbuf(lexp),"'%s' expected",type_name(DEF_state_name));
		tok_error(lexp,lxp);
		}
	del_entity(my->tokecp,lxp);
	return tp;
	}


/*****************************************************************************/
/* ========================================================================= */
/* =====   \vf                                                  ===== */
/* ========================================================================= */
/*****************************************************************************/



/*
|\vf̒` ::=
|	  instrself [q{,[q};
|	| bus f[^[q['<rbg '>]{,f[^[q['<rbg '>]};
|	| sel f[^[q['<rbg '>]{,f[^[q['<rbg '>]};
|	| bus_v f[^[q['<rbg '>]{,f[^[q['<rbg '>]};
|	| sel_v f[^[q['<rbg '>]{,f[^[q['<rbg '>]};
|	| reg WX^['<rbg '>]{,WX^['<rbg '>]};
|	| reg_ws WX^['<rbg '>]{,WX^['<rbg '>]};
|	| reg_wr WX^['<rbg '>]{,WX^['<rbg '>]};
|	| mem  '[|h ']['<rbg '>]{, '[|h ']['<rbg '>]};
|	| W[ TuW[{,TuW[};
*/


	static void rep_define_mem(tMYc token*);
	static void rep_define_submod(tMYc token*,token*);
	static void auto_declare(tMYc token* dtp, token* mtp);


static int describe_element(tMYc token* module_tp) {
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* slxp = new_entity(my->tokecp);
	token* tp;
	token* dtp;
	int c;
	int tc;
	int rtc = 1;
	int set_flg;
	footmark("describe_element");
	tp = get_token(MYc my->sflkey_tp,lxp);
	switch(token_id(tp)) {
	case KEY_instrself:
		rep_define_element(MYc module_tp,DEF_instrself,1);
		break;
	case KEY_bus:
		rep_define_element(MYc module_tp,DEF_bus,0);
		break;
	case KEY_sel:
		rep_define_element(MYc module_tp,DEF_sel,0);
		break;
	case KEY_bus_v:
		rep_define_element(MYc module_tp,DEF_bus_v,0);
		break;
	case KEY_sel_v:
		rep_define_element(MYc module_tp,DEF_sel_v,0);
		break;
	case KEY_reg:
		rep_define_element(MYc module_tp,DEF_reg,0);
		break;
	case KEY_reg_ws:
		rep_define_element(MYc module_tp,DEF_reg_ws,0);
		break;
	case KEY_reg_wr:
		rep_define_element(MYc module_tp,DEF_reg_wr,0);
		break;
	case KEY_mem:
		rep_define_mem(MYc module_tp);
		break;
	default:
		/* ̍\vfł͂Ȃ̂ŁATuW[肷B */
		tc = sfl_word(lexp);
		/* ev[gw肩H */
		if (tc == L_tpl_ang) goto chk_tpl;
		c = lexp->tokbuf[0];
		unget_word(lexp,tc,lexp->toksym->name, &(lexp->tokloc));
		if (lexp->lead_delim) unget_word(lexp,LEX_SPC," ",&(lexp->tokloc));
		if ((c >= 'A' && c <= 'Z') || (c >= 'a' && c <= 'z')) {
			goto chk_sub;	/* TuW[ */
			}
		/* ́u\vf̒`vł͂Ȃ */
		goto give_up;
		}
	/* ̍\vfŉ͂ł */
	goto ret;
chk_tpl:
	/* ev[gwł */
	*slxp = *lxp;
	lxp->acp = module_tp->acp;				/* ́AƗpgp */
	define_tpl_real_arg(MYc lxp,R_tpl_ang);	/* A[Mg擾 */
	make_tpl_class_name(lexp,lxp);			/* A[Mgl̍쐬 */
	/* TuW[̐錾邩 */
	set_flg = 1;
	tp = token_lookup(my->declare_tp, lxp, &set_flg);
	if (tp != 0 && token_id(tp) == DEF_declare) goto sub_def;
	/* W[`邩 */
	set_flg = 1;
	tp = token_lookup(my->class_tp, lxp, &set_flg);
	if (tp != 0) {
		goto auto_sub;	/* W[` */
		}
	/* ev[gETuW[̐錾邩 */
	set_flg = 1;
	tp = token_lookup(my->declare_tp, slxp, &set_flg);
	if (tp != 0 && token_id(tp) == TPL_declare) {
		/* ̎ŁA悸TuW[錾 */
		lxp->id = DEF_declare;
		tp = apply_template(MYc tp,lxp, define_declare);
		goto sub_def;
		}
	/* ev[gEW[`邩 */
	set_flg = 1;
	tp = token_lookup(my->class_tp, slxp, &set_flg);
	if (tp == 0) goto give_up;
	switch(token_id(tp)) {
	case TPL_module:
		lxp->id = DEF_module;
		break;
	case TPL_circuit:
		lxp->id = DEF_circuit;
		break;
	default:
		goto give_up;
		}
	/* ̎ŁA悸W[` */
	tp = apply_template(MYc tp,lxp, define_module);
	goto auto_sub;
chk_sub:
	set_flg = 1;	/* tp->id  LEX_SYM łiAo^邱Ƃ͂Ȃj */
	tp = token_lookup(my->declare_tp, lxp, &set_flg);
	/* TuW[̐錾邩 */
	if (tp != 0 && token_id(tp) == DEF_declare) goto sub_def;
	/* W[`邩Hׂ */
	set_flg = 1;
	tp = token_lookup(my->class_tp, lxp, &set_flg);
	if (tp == 0) goto give_up;
auto_sub:
	switch(token_id(tp)) {
	case DEF_module:
	case DEF_circuit:
		break;
	default:
		goto give_up;
		}
	/* W[`̂ŁAꂩdeclare錾 */
	dtp = new_token(tp->acp,DEF_declare,lxp);
	dtp->twin = 0;
	dtp->arg = 0;
	set_flg = 0;
	dtp = token_lookup(my->declare_tp, dtp, &set_flg);
	/* declare錾 */
	auto_declare(MYc dtp,tp);
	tp = dtp;
sub_def:
	/* TuW[\vfƂĒ` */
	rep_define_submod(MYc module_tp,tp);
	goto ret;
give_up:
	/* ́u\vf̒`vł͉͂łȂ̂ŁAȂƂɂ */
	unget_token(lexp,lxp);
	rtc = 0;
ret:
	del_entity(my->tokecp,slxp);
	del_entity(my->tokecp,lxp);
	return rtc;
	}


/*
module ` declare 錾
*/


static void auto_declare(tMYc token* dtp, token* mtp) {
	token* tp;
	token* stp;
	component* cp;
	uni_link* lp;
	uni_link* slp;
	int set_flg;
	if (mtp == 0) return;
	mod_name_change(MYc dtp);
	cp = mtp->comp_tbl;
	if (cp == 0) return;
	/* {O[q̒`} */
	for (lp = cp->top ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		switch(token_id(tp)) {
		case DEF_input:
		case DEF_output:
		case DEF_bidirect:
		case DEF_instrin:
		case DEF_instrout:
			/* O[q𕡐 declare ̃oƂ */
			set_flg = 1;
			stp = token_lookup(dtp, tp, &set_flg);
			stp->prototype = 0;
			stp->comp_tbl = 0;
			stp->wpp = 0;
			stp->arg = 0;
			stp->translate = 0;
			stp->reference = 0;
			stp->ipp       = 0;
			/* ǒ{ twin ɋL^Ă */
			break;
			}
		}
	/* {험p̐[q̉̒`} */
	for (lp = cp->top ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		switch(token_id(tp)) {
		/* {O[q̒`} */
		case DEF_input:
		case DEF_output:
		case DEF_bidirect:
		case DEF_instrin:
		case DEF_instrout:
			/* Ă郁o̍\Rs[ */
			for (slp = tp->arg ; slp != 0 ; slp = slp->np) {
				stp = slp->ap;
				/* ǒ{ twin ɋL^Ă */
				chain_arg_list(tp->twin,stp->twin);
				}
			}
		}
	}


/*
| mem  '[|h ']['<rbg '>]{, '[|h ']['<rbg '>]};
*/


static void rep_define_mem(tMYc token* module_tp) {
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* tp;
	token* ktp;
	footmark("rep_define_mem");
	forever {
		tp = define_new_member(MYc module_tp,DEF_mem);
		sfl_assert(lexp,'[');
		/* ̃|h߂ */
		ktp = get_token(MYc 0,lxp);
		switch(ktp->id) {
		case LEX_NUM:
			/* |hPOiŎw肳ꂽꍇ */
			if (ktp->value <= 0) goto ma_err;
			ktp = str2sflntok(MYc lexp->tokbuf);
			/* breakȂ */
		case LEX_SFLN:
			/* |hrekmŎw肳ꂽꍇ */
			{
				size_t siz;
				word*  wp;
				word*  np;
				uint   fig;
				int    wlen;
				/*---------------------------------------------------
				   AhXTCY̎ẃgőAhX{PhȂ̂ŁA
				   |PčőAhX߁AƂ
				   KvȃAhXrbg߂vZB
				-------------------------------------------------- */
				wlen = cal_arr_len(ktp->figure);
				wp = get_sfln_word(ktp);
				siz = wlen * sizeof(wp[0]);
				np = (word*)new_mem(siz);			/* ꎞp */
				memcpy(np,wp,siz);
				decriment_word(ktp->figure, np);	/* AhXTCY|P */
				fig = sfln_valid_bits(wlen, np);	/* KvȃAhXrbg */
				del_mem(np);
				set_mem_adr_tokp(tp,ktp,fig);	/* ̃AhXTCY */
				}
			break;
		default:
		ma_err:
			sprintf(lexp_errbuf(lexp),"'memory word-size' expected");
			tok_error(lexp,lxp);
			}
		sfl_assert(lexp,']');
		tp->figure = 1;
		ktp = get_token(MYc 0,lxp);
		if (ktp->id != '<') unget_token(lexp,lxp);
		else {
			/* Erbg 𓾂 */
			tp->figure = (unsigned int)get_bit_order(lexp,"memory bit-width",1);
			if (my->max_figure < tp->figure) my->max_figure = tp->figure;
			sfl_assert(lexp,'>');
			}
		ktp = get_token(MYc 0,lxp);
		switch(ktp->id) {
		case ';': goto ret;
		case ',': break;
		default : 
			sprintf(lexp_errbuf(lexp),"';' expected");
			tok_error(lexp,lxp);
			}
		}
ret:
	del_entity(my->tokecp,lxp);
	}


/*
| W[ TuW[{,TuW[};
*/


static void rep_define_submod(tMYc token* module_tp,token* ctp) {
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* tp;
	token* ktp;
	footmark("rep_define_submod");
	forever {
		tp = define_new_member(MYc module_tp,DEF_submod);
		sub_token_duplicate(tp,ctp);
		ktp = get_token(MYc 0,lxp);
		switch(ktp->id) {
		case ';': goto ret;
		case ',': break;
		default : 
			sprintf(lexp_errbuf(lexp),"';' expected");
			tok_error(lexp,lxp);
			}
		}
ret:
	del_entity(my->tokecp,lxp);
	}


/*****************************************************************************/
/* ========================================================================= */
/* =====                                                     ===== */
/* ========================================================================= */
/*****************************************************************************/


/*
|[q̉̒` ::=
|	  instr_arg ͒[q([͂ƂȂ[q{,͂ƂȂ[q}]);
|	| instr_arg o͒[q([o͂ƂȂ[q{,o͂ƂȂ[q}]);
|	| instr_arg [q([f[^[q{,f[^[q}]);
|	| instr_arg TuW[.͒[q([͂ƂȂ[q{,͂ƂȂ[q}]);
||͂ƂȂ[q ::=
|	  f[^͒[q
|	| f[^o[q
||o͂ƂȂ[q ::=
|	  f[^o͒[q
|	| f[^o[q
*/


static int describe_instr_arg(tMYc token* module_tp) {
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* save_tp;
	token* tp;
	int rtc = 1;
	footmark("describe_instr_arg");
	tp = get_token(MYc my->sflkey_tp,lxp);
	switch(token_id(tp)) {
	case KEY_instr_arg:
		break;
	default:
		unget_token(lexp,lxp);
		rtc = 0;
		goto ret;
		}
	tp = get_token(MYc module_tp,lxp);
	switch(token_id(tp)) {
	case DEF_instrout:
		define_argument(MYc module_tp,tp,DEF_output);
		break;
	case DEF_instrself:
		define_argument(MYc module_tp,tp,DEF_sel);
		break;
	case DEF_submod:
		sfl_assert(lexp,'.');
		define_arg_of_token(MYc tp,DEF_instrin);
		break;
	case DEF_instrin:
		/* ǉ {험p̐[q̉̒`} */
		define_argument(MYc module_tp,tp,DEF_input);
		break;
	default:
		sprintf(lexp_errbuf(lexp),"'instruct terminal' expected(1)");
		tok_error(lexp,lxp);
		}
	sfl_assert(lexp,';');
ret:
	del_entity(my->tokecp,lxp);
	return rtc;
	}


/*
|Xe[Wƃ^XNƉ̒` ::=
|	stage_name Xe[W '{
|		{task ^XN([WX^{,WX^}]);}
|	'}
*/


	static int describe_task_name(tMYc token*,token*);


static int describe_stage_name(tMYc token* module_tp) {
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* tp;
	int rtc = 1;
	footmark("describe_stage_name");
	/* stage_name Xe[W '{ */
	tp = get_token(MYc my->sflkey_tp,lxp);
	switch(token_id(tp)) {
	case KEY_stage_name:
		break;
	default:
		unget_token(lexp,lxp);
		rtc = 0;
		goto ret;
		}
	/* Xe[W '{ */
	tp = define_new_member(MYc module_tp,DEF_stage_name);
	my->stage_tp = tp;
	my->stgseg_tp = tp;
	sfl_assert(lexp,'{');
	while(describe_task_name(MYc module_tp,tp));
	sfl_assert(lexp,'}');
ret:
	del_entity(my->tokecp,lxp);
	return rtc;
	}


static int describe_task_name(tMYc token* module_tp,token* stage_tp) {
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	/* { task ^XN ( [WX^{,WX^}] ) ; } */
	token* tp;
	int rtc = 1;
	footmark("describe_task_name");
	tp = get_token(MYc my->sflkey_tp,lxp);
	switch(token_id(tp)) {
	case KEY_task:
		tp = define_new_member(MYc stage_tp,DEF_task);
		define_token_argument(MYc module_tp,tp,DEF_task);
		break;
	default:
		unget_token(lexp,lxp);
		rtc = 0;
		goto ret;
		}
	sfl_assert(lexp,';');
ret:
	del_entity(my->tokecp,lxp);
	return rtc;
	}


/* ( [WX^{,WX^}] ) */


static void define_argument(tMYc token* module_tp, token* owner_tp, int typ) {
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* link_tp = new_entity(my->tokecp);
	token* tp;
	int chk;
	int tc;
	footmark("define_argument");
	*link_tp = *owner_tp;
	link_tp->loc = lexp->lexloc;
	link_tp->arg = 0;

	sfl_assert(lexp,'(');
	tp = get_token(MYc module_tp,lxp);
	if (token_id(tp) == ')') goto ret;
	forever {
		chk = 0;
		tc = token_id(tp);
		switch(typ) {
		case DEF_reg:
			chk = (tc == DEF_reg || tc == DEF_reg_ws || tc == DEF_reg_wr );
			break;
		case DEF_sel:
			chk = (tc == DEF_sel || tc == DEF_sel_v || tc == DEF_bus || tc == DEF_bus_v );
			break;
		case DEF_input:
		case DEF_output:
			chk = (tc == typ || tc == DEF_bidirect);
			break;
		default:
			sprintf(lexp_errbuf(lexp),"Unknown type with argument");
			tok_error(lexp,lxp);
			}
		if (chk == 0) {
			sprintf(lexp_errbuf(lexp),"'%s' expected",type_name(typ));
			tok_error(lexp,lxp);
			}
		chain_arg_list(link_tp,tp);
		tp = get_token(MYc 0,lxp);
		switch(token_id(tp)) {
		case ')': goto ret;
		case ',': break;
		default : 
			sprintf(lexp_errbuf(lexp),"',' or ')' expected");
			tok_error(lexp,lxp);
			}
		tp = get_token(MYc module_tp,lxp);
		}
ret:
	if (owner_tp->arg != 0) {
		if (same_arg_assert(MYc owner_tp, link_tp) == FAIL) {
			sprintf(lexp_errbuf(lexp),"argument is already defined");
			tok_error(lexp,link_tp);
			}
		}
	else owner_tp->arg = link_tp->arg;
	del_entity(my->tokecp,link_tp);
	del_entity(my->tokecp,lxp);
	}


ENTRY void chain_arg_list(token* link_tp,token* tp) {
	uni_link** lpp = &(link_tp->arg);
	footmark("chain_arg_list");
	/* Xg̍Ōɓo^B */
	while (*lpp != 0) lpp = &((*lpp)->np);
	*lpp = new_uni_link(link_tp->acp,tp,0);
	}


/*****************************************************************************/
/* ========================================================================= */
/* =====   ̎̂̓                                          ===== */
/* ========================================================================= */
/*****************************************************************************/


/* ========================================================================= */
/* =====  ʓ̒`                                               ===== */
/* ========================================================================= */


/*
|ʓ̒` ::= 
*/


/* ========================================================================= */
/* =====  [qɂ铮̒`                                     ===== */
/* ========================================================================= */


/*
|[qɂ铮̒` ::=
|	  instruct ͒[q 
|	| instruct [q 
|	| instruct TuW[.o͒[q 
*/


static int describe_instruct(tMYc token* module_tp) {
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* tp;
	token* stp;
	int rtc = 1;
	footmark("describe_instruct");
	tp = get_token(MYc my->sflkey_tp,lxp);
	switch(token_id(tp)) {
	case KEY_instruct:
		break;
	default:
		unget_token(lexp,lxp);
		rtc = 0;
		goto ret;
		}
	/*
	|	  ͒[q 
	|	| [q 
	|	| TuW[.o͒[q 
	*/
	tp = get_token(MYc module_tp,lxp);
	switch(token_id(tp)) {
	case DEF_instrin:
	case DEF_instrself:
		describe_behavior(MYc tp);
		break;
	case DEF_submod:
		sfl_assert(lexp,'.');
		stp = get_token(MYc tp,lxp);
		switch(stp->id) {
		case DEF_instrout:
			describe_behavior(MYc stp);
			break;
		default:
			sprintf(lexp_errbuf(lexp),"'instrout' expected");
			tok_error(lexp,lxp);
			}
		break;
	default:
		sprintf(lexp_errbuf(lexp),"'instruct terminal' expected");
		tok_error(lexp,lxp);
		}
ret:
	del_entity(my->tokecp,lxp);
	return rtc;
	}


/* ========================================================================= */
/* =====  Xe[W̓菇̒`                                     ===== */
/* ========================================================================= */


/*
|Xe[W̓菇̒` ::=
|	stage Xe[W '{
|		{Ԗ̒`}
|		{ZOg̒`}
|		[Ԃ̒`]
|		[ʓ̒`]
|		{Ԃ̓̒`}
|		{ZOg̓菇̒`}
|	'}
*/


static token* find_1st_state(token* tp) {
	component* cp;
	uni_link* lp;
	footmark("find_1st_state");
	if (tp == 0) return 0;
	cp = tp->comp_tbl;
	if (cp == 0) return 0;
	for (lp = cp->top ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		switch(token_id(tp)) {
		case DEF_state_name:
			return tp;
			}
		}
	return 0;
	}


static void chk_state_definition(tMYc token* stgseg_tp) {
	lex* lexp = my->sfllexp;
	token* tp;
	component* cp;
	uni_link* lp;
	footmark("chk_state_definition");
	if (stgseg_tp == 0) return;
	cp = stgseg_tp->comp_tbl;
	if (cp == 0) return;
	for (lp = cp->top ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		switch(token_id(tp)) {
		case DEF_state_name:
			cp = tp->comp_tbl;
			if (cp == 0 || cp->behavior == 0) {
				sprintf(lexp_errbuf(lexp),"state behavior missing");
				tok_error(lexp,tp);
				}
			}
		}
	}


	static int describe_state_name(tMYc token*);
	static int describe_segment_name(tMYc token*);
	static int describe_first_state(tMYc token*,int);
	static int describe_state(tMYc token*);
	static int describe_segment(tMYc token*);


static int describe_stage(tMYc token* module_tp) {
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* stage_tp;
	token* task_tp;
	token* tp;
	component* cp;
	int tc;
	int rtc = 1;
	int anything;
	footmark("describe_stage");
	tp = get_token(MYc my->sflkey_tp,lxp);
	switch(token_id(tp)) {
	case KEY_stage:
		break;
	default:
		unget_token(lexp,lxp);
		rtc = 0;
		goto ret;
		}
	/* stage Xe[W '{ */
	stage_tp = get_stage_name(MYc module_tp);
	tc = next_tokcode(lexp);
	if (tc == '(') {
		task_tp = seek_auto_task(MYc stage_tp, 1);
		define_token_argument(MYc module_tp,task_tp,DEF_task);
		tc = next_tokcode(lexp);
		}
	if (tc == ';') {
		get_token(MYc 0,lxp);	/* ';'̏ */
		goto ret;
		}

	if (chk_stgseg_definition(stage_tp) != FAIL) {
		/* ȑOɓe`Ƃ */
		sprintf(lexp_errbuf(lexp),"    re-definition of '%s'",
			tok_id_name(stage_tp));
		tok_error(lexp,lxp);
		}
	my->stage_tp = stage_tp;
	my->stgseg_tp = stage_tp;
	sfl_assert(lexp,'{');
	anything = 1;
	while(anything) {
		anything = 0;
		/*	{Ԗ̒`} */
		while(describe_state_name(MYc stage_tp)) anything = 1;
		/*	{ZOg̒`} */
		while(describe_segment_name(MYc stage_tp)) anything = 1;
		/*	[Ԃ̒`] */
		anything |= describe_first_state(MYc stage_tp,0);
		/*	[ʓ̒`] */
		anything |= describe_behavior(MYc stage_tp);
		/*	{Ԃ̓̒`} */
		while(describe_state(MYc stage_tp)) anything = 1;
		/*	{ZOg̓菇̒`} */
		while(describe_segment(MYc stage_tp)) anything = 1;
		}
	sfl_assert(lexp,'}');
	chk_state_definition(MYc stage_tp);
	cp = stage_tp->comp_tbl;
	if (cp != 0 && cp->first == 0) cp->first = find_1st_state(stage_tp);
ret:
	del_entity(my->tokecp,lxp);
	return rtc;
	}


/*
|ZOg̓菇̒` ::=
|	segment ZOg '{
|		{Ԗ̒`}
|		Ԃ̒`
|		[ʓ̒`]
|		{Ԃ̓̒`}
|	'}
*/


static int describe_segment(tMYc token* stage_tp) {
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* tp;
	component* cp;
	token* save_stg;
	int rtc = 1;
	int anything;
	footmark("describe_segment");
	tp = get_token(MYc my->sflkey_tp,lxp);
	switch(token_id(tp)) {
	case KEY_segment:
		break;
	default:
		unget_token(lexp,lxp);
		rtc = 0;
		goto ret;
		}
	/* segment ZOg '{ */
	tp = get_segment_name(MYc stage_tp);
	if (next_tokcode(lexp) == ';') goto ret;
	if (chk_stgseg_definition(tp) != FAIL) {
		/* ȑOɓe`Ƃ */
		sprintf(lexp_errbuf(lexp),"    re-definition of '%s'",
			tok_id_name(tp));
		tok_error(lexp,lxp);
		}
	my->segment_tp = tp;
	save_stg = my->stgseg_tp;
	my->stgseg_tp = tp;
	sfl_assert(lexp,'{');
	anything = 1;
	while(anything) {
		 anything = 0;
		/* {Ԗ̒`} */
		while(describe_state_name(MYc tp)) anything = 1;
		/* Ԃ̒` */
		anything |= describe_first_state(MYc tp,0);
		/* [ʓ̒`] */
		anything |= describe_behavior(MYc tp);
		/* {Ԃ̓̒`} */
		while(describe_state(MYc tp)) anything = 1;
		}
	sfl_assert(lexp,'}');
	chk_state_definition(MYc tp);
	cp = tp->comp_tbl;
	if (cp != 0 && cp->first == 0) cp->first = find_1st_state(tp);
	/* chk_dup_DEF_DECL */
	my->stgseg_tp = save_stg;
ret:
	del_entity(my->tokecp,lxp);
	return rtc;
	}


/*
|Ԗ̒` ::= state_name Ԗ{,Ԗ};
*/


static int describe_state_name(tMYc token* stgseg_tp) {
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* tp;
	component* cp;
	int rtc = 1;
	footmark("describe_state_name");
	/* state_name Ԗ{,Ԗ}; */
	tp = get_token(MYc my->sflkey_tp,lxp);
	switch(token_id(tp)) {
	case KEY_state_name:
		break;
	default:
		unget_token(lexp,lxp);
		rtc = 0;
		goto ret;
		}
	/* Ԗ{,Ԗ}; */
	forever {
		define_new_member(MYc stgseg_tp,DEF_state_name);
		tp = get_token(MYc 0,lxp);
		switch(token_id(tp)) {
		case ';': goto ret;
		case ',': break;
		default : 
			sprintf(lexp_errbuf(lexp),"';' expected");
			tok_error(lexp,lxp);
			}
		}
ret:
	del_entity(my->tokecp,lxp);
	return rtc;
	}


/*
|ZOg̒` ::= segment_name ZOg{,ZOg};
*/


static int describe_segment_name(tMYc token* stage_tp) {
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* tp;
	int rtc = 1;
	footmark("describe_segment_name");
	/* segment_name ZOg{,ZOg}; */
	tp = get_token(MYc my->sflkey_tp,lxp);
	switch(token_id(tp)) {
	case KEY_segment_name:
		break;
	default:
		unget_token(lexp,lxp);
		rtc = 0;
		goto ret;
		}
	/* ZOg{,ZOg}; */
	forever {
		define_new_member(MYc stage_tp,DEF_segment_name);
		tp = get_token(MYc 0,lxp);
		switch(token_id(tp)) {
		case ';': goto ret;
		case ',': break;
		default : 
			sprintf(lexp_errbuf(lexp),"';' expected");
			tok_error(lexp,lxp);
			}
		}
ret:
	del_entity(my->tokecp,lxp);
	return rtc;
	}


/*
|Ԃ̒` ::= first_state Ԗ;
*/


static void set_first_state(tMYc token* stgseg_tp,token* ftp) {
	lex* lexp = my->sfllexp;
	component* cp;
	cp = component_table(stgseg_tp);
	if (cp->first != 0 && cp->first != ftp) {
		sprintf(lexp_errbuf(lexp),"first state conflict with %s",
			token_location(cp->first) );
		tok_error(lexp,ftp);
		}
	cp->first = ftp;
	}


static int describe_first_state(tMYc token* stgseg_tp,int must_be) {
	lex* lexp = my->sfllexp;
	token* lxp;
	token* tp;
	component* cp;
	int rtc;
	if (stgseg_tp == 0) return 0;
	lxp = new_entity(my->tokecp);
	rtc = 1;
	cp = component_table(stgseg_tp);
	footmark("describe_first_state");
	tp = get_token(MYc my->sflkey_tp,lxp);
	switch(token_id(tp)) {
	case KEY_first_state:
		break;
	default:
		unget_token(lexp,lxp);
		rtc = 0;
		if (cp->first != 0 || must_be == 0) goto ret;
		sprintf(lexp_errbuf(lexp),"'first state' name of %s expected",
			token_name(stgseg_tp));
		tok_error(lexp,lxp);
		}
	tp = get_state_name(MYc stgseg_tp);
	set_first_state(MYc stgseg_tp,tp);
	sfl_assert(lexp,';');
ret:
	del_entity(my->tokecp,lxp);
	return rtc;
	}


/*
|Ԃ̓̒` ::= state Ԗ 
*/


static int describe_state(tMYc token* stgseg_tp) {
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* tp;
	token* ktp;
	int first = 0;
	int rtc = 1;
	footmark("describe_state");
top:
	tp = get_token(MYc my->sflkey_tp,lxp);
	switch(token_id(tp)) {
	case KEY_first:
		if (first != 0) {
			sprintf(lexp_errbuf(lexp),"too many 'first'");
			tok_error(lexp,lxp);
			}
		first = 1;
		goto top;
	case KEY_state:
		break;
	default:
		unget_token(lexp,lxp);
		rtc = 0;
		goto ret;
		}
	tp = get_state_name(MYc stgseg_tp);
	if (first) set_first_state(MYc stgseg_tp,tp);
	my->state_tp = tp;

/* %%% */
	ktp = get_token(MYc 0,lxp);
	if (token_id(ktp) == '{') {
		while (describe_behavior(MYc tp));
		sfl_assert(lexp,'}');
		}
	else {
		unget_token(lexp,lxp);
		describe_behavior(MYc tp);
		}
ret:
	del_entity(my->tokecp,lxp);
	return rtc;
	}


/*****************************************************************************/
/* ========================================================================= */
/* =====   OC                                                  ===== */
/* ========================================================================= */
/*****************************************************************************/


/*
|W[ ::= O
|@\H ::= O
|f[^͒[q ::= O
|f[^o͒[q ::= O
|f[^o[q ::= O
|f[^[q ::= O
|͒[q ::= O
|o͒[q ::= O
|[q ::= O
|TuW[ ::= O
|WX^ ::= O
| ::= O
|Xe[W ::= O
|^XN ::= O
|ZOg ::= O
|Ԗ ::= O
|rbg ::= 
||h ::= 
|ʂ̌ ::= 
|ŏʌʒu ::= 
|ŉʌʒu ::= 
*/



/*****************************************************************************/
/* ========================================================================= */
/* =====   lf[^𓾂                                          ===== */
/* ========================================================================= */
/*****************************************************************************/


int meta_off_ctl = 0;


typedef struct {
	int   flag;
	long  value;
	char* string;
	} OPERAND;


	static void get_exp(lex* lexp, int lvl, OPERAND *oprp,int opr_spec);


static void get_do_exp_2(lex* lexp, int lvl, OPERAND *oprp,int opr_spec) {
	OPERAND opr;
	int     opr_lvl;
	int     tc;
	forever {
		/* QZq𓾂 */
		tc = sfl_word(lexp);
		switch(tc) {
		case ')':
			unget_word(lexp,tc,lexp->toksym->name, &(lexp->tokloc));
			return;
		case OPR_cmp_eq   :
		case OPR_cmp_ne   :
		case OPR_cmp_gt   :
		case OPR_cmp_ge   :
		case OPR_cmp_le   :
		case OPR_cmp_lt   :
			if (opr_spec < control_num_spec) {
				opr_lvl = 0;
				break;
				}
		case OPR_or       :
		case OPR_xor      :
		case OPR_and      :
		case OPR_catinate :	/* OPR_logor */
		case OPR_logand   :
		case OPR_plus     :
		case OPR_minus    :
		case OPR_multi    :
		case OPR_divide   :
		case OPR_residue  :
		case OPR_sft_r    :
		case OPR_sft_l    :
			opr_lvl = expr_opr_priority(opr_spec,tc);
			break;
		default         :
			opr_lvl = 0;
			}

		if ((opr_lvl == 0) || (opr_lvl >= lvl)){
			/* QZqȂAZxȂ */

			if (oprp->string != 0) goto str_err;

			unget_word(lexp,tc,lexp->toksym->name, &(lexp->tokloc));
			return;			/* left to right calculation */
			}

		/* Q擾 */
		opr.flag = 0;
		opr.value = 0;
		opr.string = 0;
		get_exp(lexp,opr_lvl,&opr,opr_spec);
		/* do opr function */
		if (oprp->string != 0) {
			if (opr.string == 0) {
				sprintf(lexp_errbuf(lexp),"string expected");
				lex_error(lexp,ERR_user);
				}
			switch(tc) {
			case OPR_cmp_eq   :
				oprp->value = (strcmp(oprp->string,opr.string) == 0) ? 1 : 0;
				break;
			case OPR_cmp_ne   :
				oprp->value = (strcmp(oprp->string,opr.string) != 0) ? 1 : 0;
				break;
			case OPR_cmp_gt   :
				oprp->value = (strcmp(oprp->string,opr.string) >  0) ? 1 : 0;
				break;
			case OPR_cmp_ge   :
				oprp->value = (strcmp(oprp->string,opr.string) >= 0) ? 1 : 0;
				break;
			case OPR_cmp_lt   :
				oprp->value = (strcmp(oprp->string,opr.string) <  0) ? 1 : 0;
				break;
			case OPR_cmp_le   :
				oprp->value = (strcmp(oprp->string,opr.string) <= 0) ? 1 : 0;
				break;
			default:
				goto str_err;
				}
			oprp->string = 0;
			return;
			}
		switch(tc) {
		case OPR_cmp_eq   :
			oprp->value = (oprp->value == opr.value) ? 1 : 0;
			break;
		case OPR_cmp_ne   :
			oprp->value = (oprp->value != opr.value) ? 1 : 0;
			break;
		case OPR_cmp_gt   :
			oprp->value = (oprp->value >  opr.value) ? 1 : 0;
			break;
		case OPR_cmp_ge   :
			oprp->value = (oprp->value >= opr.value) ? 1 : 0;
			break;
		case OPR_cmp_lt   :
			oprp->value = (oprp->value <  opr.value) ? 1 : 0;
			break;
		case OPR_cmp_le   :
			oprp->value = (oprp->value <= opr.value) ? 1 : 0;
			break;
		case OPR_or       :
			oprp->value |= opr.value;
			break;
		case OPR_xor      :
			oprp->value ^= opr.value;
			break;
		case OPR_and      :
			oprp->value &= opr.value;
			break;
		case OPR_catinate :	/* OPR_logor */
			oprp->value = (oprp->value || opr.value) ? 1 : 0;
			break;
		case OPR_logand   :
			oprp->value = (oprp->value && opr.value) ? 1 : 0;
			break;
		case OPR_plus     :
			oprp->value += opr.value;
			break;
		case OPR_minus    :
			oprp->value -= opr.value;
			break;
		case OPR_multi    :
			oprp->value *= opr.value;
			break;
		case OPR_divide   :
			oprp->value /= opr.value;
			break;
		case OPR_residue  :
			oprp->value %= opr.value;
			break;
		case OPR_sft_r    :
			oprp->value >>= opr.value;
			break;
		case OPR_sft_l    :
			oprp->value <<= opr.value;
			break;
			}
		}
	return;
str_err:
	sprintf(lexp_errbuf(lexp),"compare operator expected");
	lex_error(lexp,ERR_user);
	}


static void get_exp_2(lex* lexp,int lvl,OPERAND *oprp,int opr_spec) {
	word_dict* save_tblp;
	jmp_buf* save_jbp = *(lexp->jmpbfpp);
	jmp_buf jbuf;
	int rtc;
	save_tblp = lexp->opr_tblp;
	*(lexp->jmpbfpp) = &jbuf;
	rtc = setjmp(jbuf);
	if (rtc == 0) {
		/* ւ */
		lexp->opr_tblp = expression_opr_dict[opr_spec - 1];
		get_do_exp_2(lexp,lvl,oprp,opr_spec);
		}
	lexp->opr_tblp = save_tblp;
	*(lexp->jmpbfpp) = save_jbp;
	if(rtc != 0) {
		/* ُI */
		longjmp(**(lexp->jmpbfpp),rtc);
		}
	}


static void chk_mono_priority(lex* lexp,int lvl,int opr_lvl) {
	if (lvl >= opr_lvl) return;
	sprintf(lexp_errbuf(lexp),"mono operator priority");
	lex_error(lexp,ERR_user);
	}


static void get_do_exp(lex* lexp, int lvl, OPERAND *oprp,int opr_spec) {
	int opr_lvl;
	int tc;
	/* P擾 */
	tc = sfl_word(lexp);
	opr_lvl = mono_opr_priority(opr_spec,tc);
	switch(tc) {
	/* prefix operator is */
	case OPR_plus:
		chk_mono_priority(lexp,lvl,opr_lvl);
		get_do_exp(lexp,opr_lvl,oprp,opr_spec);
		break;
	case OPR_minus:
		chk_mono_priority(lexp,lvl,opr_lvl);
		get_do_exp(lexp,opr_lvl,oprp,opr_spec);
		oprp->value = - oprp->value;
		break;
	case OPR_invert:
		chk_mono_priority(lexp,lvl,opr_lvl);
		get_do_exp(lexp,opr_lvl,oprp,opr_spec);
		oprp->value = ~(oprp->value);
		break;
	case OPR_lognot:
		chk_mono_priority(lexp,lvl,opr_lvl);
		get_do_exp(lexp,opr_lvl,oprp,opr_spec);
		oprp->value = (oprp->value) ? 0 : 1;
		break;
	case '(':
		get_do_exp(lexp,NO_priority,oprp,opr_spec);
		sfl_assert(lexp,')');
		break;
	case LEX_NUM:
		oprp->value = str2num(lexp,lexp->tokbuf);
		break;
	case LEX_SYM:
	case LEX_SQT:
	case LEX_WQT:
		if (opr_spec < control_num_spec) goto def_sym;
		if (tc == LEX_SYM && strcmp("defined",lexp->tokbuf) == 0) {
			macro* mac;
			int save_mac_flg;
			save_mac_flg = lexp->macro_ctl;
			lexp->macro_ctl = MAC_NG;
			char_assert(lexp, '(');
			tc = sfl_word(lexp);
			if (tc != LEX_SYM) {
				sprintf(lexp_errbuf(lexp),"macro name expected");
				lex_error(lexp,ERR_user);
				}
			/* }NƂĒ`Ă邩 */
			mac = 0;
			if (lexp->machash != 0) {
				mac = macro_lookup(lexp->acp,&(lexp->machash),lexp->toksym,0);
				}
			char_assert(lexp, ')');
			oprp->value = (mac != 0 && mac->string != 0) ? 1 : 0;
			lexp->macro_ctl = save_mac_flg;
			break;
			}
		else {
			oprp->string = lexp->toksym->name;
			break;
			}
	def_sym:
	default:
		/* %%% delete
		if (lexp->tokbuf[0] == '(') {
			get_do_exp(lexp,NO_priority,oprp,opr_spec);
			char_assert(lexp, ')');
			break;
			}
		*/
		sprintf(lexp_errbuf(lexp),"number expected");
		lex_error(lexp,ERR_user);
		}
	get_exp_2(lexp,lvl,oprp,opr_spec);
	}


static void get_exp(lex* lexp, int lvl, OPERAND *oprp,int opr_spec) {
	word_dict* save_tblp;
	int        save_meta;
	jmp_buf* save_jbp = *(lexp->jmpbfpp);
	jmp_buf jbuf;
	int rtc;
	save_tblp = lexp->opr_tblp;
	save_meta = lexp->meta_off;
	*(lexp->jmpbfpp) = &jbuf;
	rtc = setjmp(jbuf);
	if (rtc == 0) {
		/* ւ */
		lexp->opr_tblp = mono_expr_opr_dict[opr_spec - 1];
		lexp->meta_off = meta_off_ctl;
		get_do_exp(lexp,lvl,oprp,opr_spec);
		}
	lexp->meta_off = save_meta;
	lexp->opr_tblp = save_tblp;
	*(lexp->jmpbfpp) = save_jbp;
	if(rtc != 0) {
		/* ُI */
		longjmp(**(lexp->jmpbfpp),rtc);
		}
	}


ENTRY long get_number(lex* lexp,int opr_spec) {
	OPERAND opr;
	opr.flag  = 0;
	opr.value = 0;
	opr.string= 0;
	get_exp(lexp,NO_priority,&opr,opr_spec);
	return opr.value;
	}


ENTRY long get_mono_number(lex* lexp,int opr_spec) {
	OPERAND opr;
	opr.flag  = 0;
	opr.value = 0;
	opr.string= 0;
	get_exp(lexp,NO_priority,&opr,opr_spec);
	return opr.value;
	}


ENTRY long get_bit_order(lex* lexp, char* object, long low) {
	long value;
	fileloc loc;
	symbol* sym;
	int tc;
	tc = sfl_word(lexp);
	loc = lexp->tokloc;
	sym = lexp->toksym;
	unget_word(lexp,tc,lexp->toksym->name, &(lexp->tokloc));
	value = get_number(lexp,lexp->sflspec);
	if (value < low) {
		lexp->tokloc = loc;
		lexp->toksym = sym;
		sprintf(lexp_errbuf(lexp),"'%s' expected",object);
		lex_error(lexp, ERR_user);
		}
	return value;
	}



ENTRY token* get_eval_num_tok(lex* lexp,token* tp) {
	char buf[32];
	/* POíAvZĂP̃g[Nɕϊ */
	tp->id = LEX_NUM;
	tp->value = get_number(lexp,lexp->sflspec);
	sprintf(buf,"%ld",tp->value);
	tp->tokren = tp->toksym = symbol_lookup(lexp,buf);
	return tp;
	}


/* ========================================================================= */
/* =====   orQrekqc̏e[u                            ===== */
/* ========================================================================= */


setup_parm sflrd_ini[] = {
	sup_str(auto_task_name ),
	{0,0,0,0},
	};


