/*
 *  notice: japanese
 *@쌠҂̍mF
 *@@uf[^TCgJvOgp@QŁv
 *@@ɋLڂ́uvOvƓɎ舵ĒƂɁA
 *@@{hLg̉{EpEۊǂF߂܂B
 */

/*
 * sflpar.c
 *
 * SFL parser main.
 * Version 1.10 Beta   Date 1999.5.8
 * Copyright (c) Datasight Corp., 1996-1999.
 * All Rights Reserved.
 * Made by A.Nakashima
 *
 */


#define foot_on 0
#include "ps_selec.h"
#include "ps_misc.h"
#include "ps_lex.h"
#include "ps_strct.h"
#include "ps_tdef.h"
#include "ps_proto.h"


char *Version_no = "1.10 Beta b";

/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */
;


/* ----------------
	FreeBSD debug

	% gcc -g ....
	...
	% gdb sim
	(gdb)run
	SFL> xxx
	...
	core dump
	(gdb)backtrace
------------------- */


unsigned int _stklen = 8*1024;


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */
;


static global* gp;	/* dummy */


/* ========================================================================= */
/* =====   R}h̓o^                                            ===== */
/* ========================================================================= */
;


/* R}h L[[h ::= */;
#define cmd_key \
	def_key(bye)\
	def_key(claim)\
	def_key(claima)\
	def_key(define)\
	def_key(dir)\
	def_key(echo)\
	def_key(flush)\
	def_key(fork)\
	def_key(help)\
	def_key(leave)\
	def_key(listen)\
	def_key(lmc)\
	def_key(quit)\
	def_key(setenv)\
	def_key(setup)\
	def_key(sflread)\
	def_key(sflren)\
	def_key(sflspec)\
	def_key(sflwrite)\
	def_key(speak)\
	def_key(speaka)\
	def_key(verbose)\
	def_key(version)\
	def_key(template)\
	def_key(system)\

#define cmd2_key \
	def_key(parge_all)\
	def_key(put_ec)\
	def_key(ec_test)\
	def_key(ec_check)\
	def_key(sfl_word)\
	def_key(fc)\


/* R}hɑΉR[h */;
#undef def_key
#define def_key(key) CMD_##key,
enum {
	CMD_top_no = 512,
	cmd_key
	cmd2_key
	CMD_d_print,
	CMD_on,
	CMD_off,
	CMD_end_no,
	};

int LEX_d_print= CMD_d_print;
int LEX_listen = CMD_listen;
int cmd_end_no = CMD_end_no;


/* R}h̑ΉR[h֕ϊe[u */;
#undef def_key
#define def_key(key) {#key,CMD_##key},
key_word cmd_key_tbl[] = {
	cmd_key
	cmd2_key
	{"on"	,CMD_on },
	{"off"	,CMD_off},
	{"",0}
	};


/* R}ḧꗗe[u */;
#undef def_key
#define def_key(key) #key "\n"
static char* dsp_cmd_name = 
	"available command as: \n"
	cmd_key
	;


/* ========================================================================= */
/* =====   R}h֐̒`                                          ===== */
/* ========================================================================= */
;


static void c_bye(tMY) {
	longjmp(*(my->jmpbfp), ERR_bye);
	}


static void change_claim_file(tMYc int mode) {
	lex* lexp = my->cmdlexp;
	char* path;
	if (lexp->claimfp != stderr) {
		file_control(lexp, lexp->claimfn, lexp->claimfp, 'c');
		/*      close ͕̎Kw肷  ^^^^^^^^^^^^^     */
		}
	lexp->claimfn = symcate_lookup(lexp,STDerr,TYPE_STDERR);
	lexp->claimfp = stderr;
	if (lexp->argc < 2) return;
	path = full_file_name(NAME_PATH,lexp->lex_path->name,lexp->args[1]);
	lexp->claimfn = symcate_lookup(lexp,symbol_lookup(lexp,path),READ_FILE);
	lexp->claimfp = file_control(lexp, lexp->claimfn, 0, mode);
	/*    w/a ̎́AKt@CȂ̂łOw肷 ^^      */
	}


static void c_claim(tMY) {
	change_claim_file(MYc 'w');
	}


static void c_claima(tMY) {
	change_claim_file(MYc 'a');
	}


static void c_define(tMY) {
	lex* lexp = my->cmdlexp;
	source* sfp;
	char*   sp;
	symbol* sym;
	/* Õt@C\[X܂ł̂ڂ */
	sfp = lexp->sfp;
	while(is_macsrc(sfp)) {
		if (sfp->rfp == 0) break;
		sfp = sfp->rfp;
		}
	if (lexp->argc < 2) {
		tell_macro(lexp,sfp->machash,"define");
		return;
		}
	sp  = get_looped_buf(0);

/* %%%
	sprintf(sp,"$%s",lexp->args[1]);
*/

	sprintf(sp,"%s",lexp->args[1]);
	sym = symbol_lookup(lexp,sp);
	if (lexp->argc < 3) {
		/* 폜ɑ */
		macro_lookup(sfp->acp,&(sfp->machash),sym,"");
		}
	else {
		macro_lookup(sfp->acp,&(sfp->machash),sym, cmd_arg_line(lexp,2));
		}
	}


static void c_dir(tMY) {
	lex* lexp = my->cmdlexp;
	char* path;
	if (lexp->argc < 2) {
		fprintf(lexp->speakfp,"%s\n",lexp->lex_path->name);
		}
	else {
		path = cwd_path(lexp->args[1]);
		if (chdir(path) != 0) {
			sprintf(lexp->errbuf,"'%s' no such directory",path);
			lex_error(lexp,ERR_user);
			}
		lexp->lex_path = symbol_lookup(lexp,cwd_path(0));
		}
	}


static void c_echo(tMY) {
	lex*   lexp = my->cmdlexp;
	FILE*  speakfp = lexp->speakfp;
	char*  spc = "";
	char** args = lexp->args;
	int i;
	for (i = 1 ; i < lexp->argc ; ++i) {
		fprintf(speakfp,"%s%s",spc,args[i]);
		spc = " ";
		}
	fprintf(speakfp,"\n");
	}


static void c_flush(tMY) {
	lex* lexp = my->sfllexp;
	if (lexp != 0) {
		if (lexp->speakfp != 0) fflush(lexp->speakfp);
		}
	}


static void c_fork(tMY) {
	lex*  lexp = my->cmdlexp;
	lex*  nlexp;
	char* script;
	if (lexp->argc < 2) return;
	nlexp = fork_child(lexp);
	script = full_file_name(NAME_PATH, lexp->lex_path->name, lexp->args[1]);
	new_source(lexp,nlexp,READ_FILE,script,'$',lexp->argc-1,&(lexp->args[1]));
	lexp->restart = 1;
	}


static void c_help(tMY) {
	gp = my;
	printf("%s",dsp_cmd_name);
	}


static void c_leave(tMY) {
	lex* lexp = my->cmdlexp;
	del_include(lexp->sfp);
	}


static void c_listen(tMY) {
	c_bye(MY);	/* dummy */
	}


static void c_lmc(tMY) {
	lex*       lexp    = my->cmdlexp;
	FILE*      speakfp = lexp->speakfp;
	token*     tp;
	component* cp;
	uni_link*  lp;
	if (my->declare_tp == 0) goto next1;
	cp = my->declare_tp->comp_tbl;
	if (cp == 0) goto next1;
	for (lp = cp->top ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		switch(token_id(tp)) {
		case DEF_declare:
			fprintf(speakfp,"(declare) ");
			break;
		default:
			continue;
			}
		fprintf(speakfp,"%s\n",token_location(tp));
		}
next1:
	if (my->class_tp == 0) return;
	cp = my->class_tp->comp_tbl;
	if (cp == 0) return;
	for (lp = cp->top ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		switch(token_id(tp)) {
		case TPL_module:
			fprintf(speakfp,"(module template)  ");
			break;
		case DEF_module:
			fprintf(speakfp,"(module)  ");
			break;
		case DEF_circuit:
			fprintf(speakfp,"(circuit) ");
			break;
		default:
			continue;
			}
		fprintf(speakfp,"%s\n",token_location(tp));
		}
	}


static void c_quit(tMY) {
	longjmp(*(my->jmpbfp), ERR_quit);
	}


static void c_setenv(tMY) {
	lex* lexp = my->cmdlexp;
	char*   sp;
	symbol* sym;
	if (lexp->argc < 2) {
		tell_macro(lexp,lexp->machash,"setenv");
		return;
		}
	sp  = get_looped_buf(0);
/* %%%
	sprintf(sp,"$%s",lexp->args[1]);
*/
	sprintf(sp,"%s",lexp->args[1]);
	sym = symbol_lookup(lexp,sp);
	if (lexp->argc < 3) {
		/* 폜ɑ */
		macro_lookup(lexp->acp,&(lexp->machash),sym,"");
		}
	else {
		macro_lookup(lexp->acp,&(lexp->machash),sym, cmd_arg_line(lexp,2));
		}
	}


static void c_sflread(tMY) {
	lex* lexp = my->cmdlexp;
	if (lexp->argc < 2) return;
	my->sfllexp->claimfn = lexp->claimfn;
	my->sfllexp->claimfp = lexp->claimfp;
	sflread(MYc lexp->args[1],lexp->argc-1,&(lexp->args[1]));
	close_all_sfp(my->sfllexp);
	}


static void c_sflren(tMY) {
	alloc_ctl* acp;
	token*   sav_declare;
	token*   sav_class;
	jmp_buf* sav_jmpbp;
	jmp_buf  jbuf;
	lex*     lexp;
	token* tp;
	component* cp;
	uni_link* lp;
	int rtc;
	lexp = my->cmdlexp;
	if (lexp->argc < 2) return;
	acp = new_mactl();
	/* ݂̓o^[gۑ */
	sav_declare = my->declare_tp;
	sav_class   = my->class_tp;
	/* Wvۑ */
	sav_jmpbp   = my->jmpbfp;
	/* o^[gpɐݒ */
	{
		token tok;
		memset(&tok,0,sizeof(token));
		tok.tokren = tok.toksym = my->declare_tp->toksym;
		tok.figure = 1;
		my->declare_tp = new_token(acp, SFL_decl, &tok);
		my->class_tp   = new_token(acp, SFL_root, &tok);
		}
	/* Wvpɐݒ */
	my->jmpbfp = &jbuf;
	rtc = setjmp(jbuf);
	if (rtc == 0) {
		/* sflreadCsflwrites */
		my->sfllexp->claimfn = lexp->claimfn;
		my->sfllexp->claimfp = lexp->claimfp;
		sflread(MYc lexp->args[1],lexp->argc-1,&(lexp->args[1]));
		close_all_sfp(my->sfllexp);
		if (lexp->argc < 3) {
			sflwrite(MYc "");
			}
		else {
			sflwrite(MYc lexp->args[2]);
			}
		/* sflreadŊmۂemodule` */
		if (my->declare_tp == 0) goto next1;
		cp = my->declare_tp->comp_tbl;
		if (cp == 0) goto next1;
		for (lp = cp->top ; lp != 0 ; lp = lp->np) {
			tp = lp->ap;
			del_mactl(tp->acp);
			}
	next1:
		if (my->class_tp == 0) goto next2;
		cp = my->class_tp->comp_tbl;
		if (cp == 0) goto next2;
		for (lp = cp->top ; lp != 0 ; lp = lp->np) {
			tp = lp->ap;
			del_mactl(tp->acp);
			}
	next2:;
		}
	/* ƗpglobalGA */
	del_mactl(acp);
	/* o^[g𕜌 */
	my->declare_tp = sav_declare;
	my->class_tp   = sav_class  ;
	/* Wv𕜌 */
	my->jmpbfp     = sav_jmpbp  ;
	clear_sflacp(my->sfllexp);
	if (rtc != 0) {
		/* G[A҂̂ŁÃR}ĥG[Ƃ */
		longjmp(*(my->jmpbfp),rtc);
		}
	}


static void c_sflspec(tMY) {
	int vno;
	lex* lexp = my->cmdlexp;
	if (lexp->argc < 2) {
		fprintf(lexp->speakfp,"%d\n",my->sfllexp->sflspec);
		return;
		}
	switch(vno = atoi(lexp->args[1])) {
	case 1:
	case 2:
		sflspec_no = my->sfllexp->sflspec = vno;
		break;
		}
	}


static void c_sflwrite(tMY) {
	lex* lexp = my->cmdlexp;
	if (lexp->argc < 2) {
		sflwrite(MYc "");
		}
	else {
		sflwrite(MYc lexp->args[1]);
		}
	}


static void change_speak_file(tMYc int mode) {
	lex* lexp = my->cmdlexp;
	char* path;
	if (lexp->speakfp != stdout) {
		file_control(lexp, lexp->speakfn, lexp->speakfp, 'c');
		/*      close ͕̎Kw肷  ^^^^^^^^^^^^^     */
		}
	lexp->speakfn = symcate_lookup(lexp,STDout,TYPE_STDOUT);
	lexp->speakfp = stdout;
	if (lexp->argc < 2) return;
	path = full_file_name(NAME_PATH,lexp->lex_path->name,lexp->args[1]);
	lexp->speakfn = symcate_lookup(lexp,symbol_lookup(lexp,path),READ_FILE);
	lexp->speakfp = file_control(lexp, lexp->speakfn, 0, mode);
	/*    w/a ̎́AKt@CȂ̂łOw肷 ^^      */
	my->sfllexp->speakfp = lexp->speakfp;
	}


static void c_speak(tMY) {
	change_speak_file(MYc 'w');
	}


static void c_speaka(tMY) {
	change_speak_file(MYc 'a');
	}


static void c_verbose(tMY) {
	lex* lexp = my->cmdlexp;
	if (lexp->argc < 2) {
		fprintf(lexp->speakfp,"%s\n",(lexp->verbose)?"on":"off");
		return;
		}
	switch(get_cmd_code(MYc lexp->args[1])) {
	case CMD_on:
		lexp->verbose = 1;
		break;
	case CMD_off:
		lexp->verbose = 0;	/* suspended : default */
		break;
	default:
		sprintf(lexp->errbuf,"'%s' no such option",lexp->args[1]);
		cmd_error(lexp,ERR_user);
		}
	}


static void c_version(tMY) {
	lex* lexp = my->cmdlexp;
	fprintf(lexp->speakfp,"%s\n",Version_no);
	}


static void c_setup(tMY) {
	extern setup_parm* setup_tbl[];
	gp = my;
	put_filedef(setup_tbl);
	}


static void c_template(tMY) {
	lex* lexp = my->cmdlexp;
	if (lexp->argc < 2) {
		dsp_template(MYc NULL);
		}
	else {
		dsp_template(MYc lexp->args[1]);
		}
	}


static void c_system(tMY) {
	lex* lexp = my->cmdlexp;
	char* buf = get_looped_buf(0);
	int len,i;
	if (lexp->argc < 2) {
		;
		}
	else {
		len = 0;
		for (i = 1  ; i < lexp->argc ; ++i) {
			len += sprintf(&buf[len],"%s ",lexp->args[i]);
			}
		system(buf);
		}
	}


/* ========================================================================= */
/* =====   fobOR}h                                            ===== */
/* ========================================================================= */
;


extern int dsp_sfl_word;


static void test_flg_ctl(tMYc int* flgp) {
	lex* lexp = my->cmdlexp;
	if (lexp->argc < 2) {
		fprintf(lexp->speakfp,"%s\n",(*flgp)?"on":"off");
		return;
		}
	switch(get_cmd_code(MYc lexp->args[1])) {
	case CMD_on:
		*flgp = 1;
		break;
	case CMD_off:
		*flgp = 0;
		break;
	default:
		sprintf(lexp->errbuf,"'%s' no such option",lexp->args[1]);
		cmd_error(lexp,ERR_user);
		}
	}


static void c_parge_all(tMY) {
	parge_all(MY);
	}


	extern void  put_error_code(char* fn);

static void c_put_ec(tMY) {
	lex* lexp = my->cmdlexp;
	char* fn;
	fn = (lexp->argc < 2) ? 0 : lexp->args[1];
	put_error_code(fn);
	}


static void c_ec_test(tMY) {
	test_flg_ctl(MYc &ec_test_mode);
	}



/* %%% */

static void c_ec_check(tMY) {
	lex* lexp = my->cmdlexp;
	int num;
	if (lexp->argc < 2) {
		fprintf(lexp->speakfp,"%d\n",error_code);
		return;
		}
	sscanf(lexp->args[1],"%d",&num);
	if (error_code == num) return;
	}


static void c_sfl_word(tMY) {
	test_flg_ctl(MYc &dsp_sfl_word);
	}


static void c_fc(tMY) {
	lex* lexp = my->cmdlexp;
	FILE* f1p;
	FILE* f2p;
	int c;
	if (lexp->argc < 3) {
		sprintf(lexp->errbuf,"file name missing\n");
		goto e_ret;
		}
	f1p = fopen(lexp->args[1],"rt");
	if (f1p == NULL) {
		sprintf(lexp->errbuf,"file %s can't open\n",lexp->args[1]);
		goto e_ret;
		}
	f2p = fopen(lexp->args[2],"rt");
	if (f2p == NULL) {
		sprintf(lexp->errbuf,"file %s can't open\n",lexp->args[2]);
		goto e_ret;
		}
	while ((c = fgetc(f1p)) != EOF) {
		if (c != fgetc(f2p)) goto err;
		}
	if (fgetc(f2p) != EOF) goto err;
	fclose(f1p);
	fclose(f2p);
	return;
err:
	sprintf(lexp->errbuf,"file mismatch");
e_ret:
	if (f1p != NULL) fclose(f1p);
	if (f2p != NULL) fclose(f2p);
	cmd_error(lexp,ERR_user);
	}


/* ========================================================================= */
/* =====   R}h֐̓o^                                          ===== */
/* ========================================================================= */
;


/* R}hR[hƃR}h֐̑Ήe[u */;
#undef def_key
#define def_key(key) {CMD_##key,c_##key},
static cmd_func cmd_tbl[] = {
	cmd_key
	cmd2_key
	{0,0}
	};


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */
;


int sflspec_no = 1;
char* lib_comp_path  = "nld_lib;pcd_lib";
char* user_comp_path = "comp_nld";
char* comp_exec_path = ".";
char* comp_exec_ext  = ".exe";


setup_parm main_ini[] = {
	sup_int(sflspec_no),
	sup_str(lib_comp_path),
	sup_str(user_comp_path),
	sup_str(comp_exec_path),
	sup_str(comp_exec_ext),
	{0,0,0,0},
	};


extern setup_parm misc_ini[];
extern setup_parm lex_ini[];
extern setup_parm token_ini[];
extern setup_parm sflrd_ini[];
extern setup_parm sflwt_ini[];
extern setup_parm cmd_ini[];


#if defined(CONSOLE)
	extern setup_parm console_ini[];
	extern setup_parm dsq_sequence[];
	extern setup_parm ksq_sequence[];
#	endif


setup_parm* setup_tbl[] = {
	misc_ini,
	lex_ini,
	token_ini,
	sflrd_ini,
	sflwt_ini,
	cmd_ini,
	main_ini,
#	if defined(CONSOLE)
		console_ini,
		dsq_sequence,
		ksq_sequence,
#		endif
	0};


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */
;


/* fthp̃R}hi[̈iꉞAϐɂĂj */;

#define GUI_buflen 512
int   gui_buflen = GUI_buflen;
char* gui_buffer;


/* fth̃R}h󂯎֐ */;

static void waiting_for_command(int len,char* buf) {
	/* gui_buflen OȂR\[[hɂȂB */
	if (gui_buflen == 0) return;	/* CUI mode */
	dummy_gui_2_cui(len,buf);
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */
;


ENTRY void dsp_mono_opr(void);


ENTRY int main(int argc, char* argv[]) {
	global* my;
	char* ipath;
	int rtc;
	serr_efp = stderr;
	ipath = analize_arg(&argc,&argv);
	if (gui_buflen != 0) argc = 0;
	my = interpreter_init(argc,argv,ipath,cmd_tbl,setup_tbl);
	gui_buffer = gui_init(my,gui_buflen);
	/*=== R}hs[v ===*/
	do {
		waiting_for_command(gui_buflen,gui_buffer);
		rtc = command_interpreter(my);
		} while (rtc != ERR_bye);
	return 0;
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */
;
