%d module_def 1


declare submod_1 {
    input    sdata_in_bit;
    input    sdata_in_byte<8>;
    input    sdata_in_bit_1, sdata_in_bit_2;
    input    sdata_in_byte_1<8>, sdata_in_byte_2<8>, sdata_in_byte_3<8>;
    instrin  sinstr_in(sdata_in_bit);
    instrin  sinstr_in_bit(sdata_in_bit_1,sdata_in_bit_2);
    instrin  sinstr_in_byte(sdata_in_byte_1,sdata_in_byte_2);
    output   sdata_out_bit;
    output   sdata_out_byte<8>;
    output   sdata_out_bit_1, sdata_out_bit_2;
    output   sdata_out_byte_1<8>, sdata_out_byte_2<8>, sdata_out_byte_3<8>;
    instrout sinstr_out(sdata_out_bit);
    instrout sinstr_out_bit(sdata_out_bit_1,sdata_out_bit_2);
    instrout sinstr_out_byte(sdata_out_byte_1,sdata_out_byte_2);
}


module mod_pin2 {

	input data_in_bit;
	input data_in_byte<8>;
	input data_in_bit_1,data_in_bit_2,data_in_bit_3,data_in_bit_4;
	input data_in_byte_1<8>,data_in_byte_2<8>,data_in_byte_3<8>;

	output data_out_bit;
	output data_out_byte<8>;
	output data_out_bit_1,data_out_bit_2,data_out_bit_3;
	output data_out_byte_1<8>,data_out_byte_2<8>,data_out_byte_3<8>;

	bidirect data_bi_bit;
	bidirect data_bi_byte<8>;
	bidirect data_bi_bit_1,data_bi_bit_2,data_bi_bit_3;
	bidirect data_bi_byte_1<8>,data_bi_byte_2<8>,data_bi_byte_3<8>;

	instrin instr_in_0;
	instrin instr_in_1();
	instrin instr_in_1();
	instrin instr_in_2(data_in_bit_1);
	instrin instr_in_2(data_in_bit_1);
	instrin instr_in_3(data_bi_bit_1,data_bi_bit_2);
	instrin instr_in_0() {
		data_out_bit = 0b1;
		data_out_byte = 0x12;
		}
	instrin instr_in_1() {
		data_out_bit = 0b1;
		data_out_byte = 0x12;
		}
	instrin instr_in_2 {
		data_out_bit = 0b1;
		data_out_byte = 0x12;
		}
	instrin instr_in_3(data_bi_bit_1,data_bi_bit_2) {
		data_out_bit = 0b1;
		data_out_byte = 0x12;
		}

	instrout instr_out_0;
	instrout instr_out_1();
	instrout instr_out_1();
	instrout instr_out_2(data_out_bit_1,data_out_bit_2);
	instrout instr_out_2(data_out_bit_1,data_out_bit_2);
	instrout instr_out_3(data_out_bit_1);

	sel data_sel_bit;
	sel data_sel_byte<8>;
	sel data_sel_bit_1,data_sel_bit_2,data_sel_bit_3;
	sel data_sel_byte_1<8>,data_sel_byte_2<8>,data_sel_byte_3<8>;

	instrself instr_self_00;
	instrself instr_self_0;
	instrself instr_self_1();
	instrself instr_self_1();
	instrself instr_self_2(data_sel_bit_1);
	instrself instr_self_2(data_sel_bit_1);
	instrself instr_self_3(data_sel_bit_1,data_sel_bit_2);
	instrself instr_self_0() {
		data_out_bit = 0b1;
		data_out_byte = 0x12;
		}
	instrself instr_self_1() {
		data_out_bit = 0b1;
		data_out_byte = 0x12;
		}
	instrself instr_self_2(data_sel_bit_1) {
		data_out_bit = 0b1;
		data_out_byte = 0x12;
		}
	instrself instr_self_3(data_sel_bit_1,data_sel_bit_2) {
		data_out_bit = 0b1;
		data_out_byte = 0x12;
		}

	submod_1 submod_1;
    instrin  submod_1.sinstr_in_byte(sdata_in_byte_3,sdata_in_byte_2);

    instrout submod_1.sinstr_out_byte {
		data_out_bit = 0b1;
		data_out_byte = 0x12;
		}

	}


module mod_pin2_test {
	mod_pin2 mod_pin2;
	}


%u module_def 
